searchData={"items":[{"type":"module","title":"Lux","doc":"Documentation for `Lux`.","ref":"Lux.html"},{"type":"function","title":"Lux.beam?/1","doc":"Check if a module is a beam.","ref":"Lux.html#beam?/1"},{"type":"function","title":"Lux.hello/0","doc":"Hello world.","ref":"Lux.html#hello/0"},{"type":"function","title":"Examples - Lux.hello/0","doc":"iex> Lux.hello()\n    :world","ref":"Lux.html#hello/0-examples"},{"type":"function","title":"Lux.lens?/1","doc":"Check if a module is a lens.","ref":"Lux.html#lens?/1"},{"type":"function","title":"Lux.prism?/1","doc":"Check if a module is a prism.","ref":"Lux.html#prism?/1"},{"type":"behaviour","title":"Lux.Agent","doc":"A Agent defines an autonomous agent's capabilities, behaviors and goals.\nThe actual execution and supervision is handled by the Lux runtime.\n\nAgents can be configured with different templates that provide specialized behaviors:\n- :company_agent - Adds company-specific signal handling\n- (other templates to be added)","ref":"Lux.Agent.html"},{"type":"behaviour","title":"Example - Lux.Agent","doc":"defmodule MyCompanyAgent do\n      use Lux.Agent,\n        template: :company_agent,\n        template_opts: %{\n          llm_config: %{temperature: 0.7}\n        } do\n\n        def init(opts) do\n          {:ok, opts}\n        end\n\n        # Can override template functions if needed\n        def handle_task_assignment(signal, context) do\n          # Custom implementation\n        end\n      end\n    end","ref":"Lux.Agent.html#module-example"},{"type":"function","title":"Lux.Agent.chat/3","doc":"","ref":"Lux.Agent.html#chat/3"},{"type":"callback","title":"Lux.Agent.chat/3","doc":"","ref":"Lux.Agent.html#c:chat/3"},{"type":"type","title":"Lux.Agent.collaboration_protocol/0","doc":"","ref":"Lux.Agent.html#t:collaboration_protocol/0"},{"type":"function","title":"Lux.Agent.from_json/1","doc":"Creates an agent module from JSON configuration.\nSee `Lux.Agent.Loaders.from_json/1` for details.","ref":"Lux.Agent.html#from_json/1"},{"type":"function","title":"Lux.Agent.get_handler_type/1","doc":"","ref":"Lux.Agent.html#get_handler_type/1"},{"type":"macro","title":"Lux.Agent.inject_template/2","doc":"","ref":"Lux.Agent.html#inject_template/2"},{"type":"type","title":"Lux.Agent.memory_config/0","doc":"","ref":"Lux.Agent.html#t:memory_config/0"},{"type":"function","title":"Lux.Agent.module_to_name/1","doc":"","ref":"Lux.Agent.html#module_to_name/1"},{"type":"function","title":"Lux.Agent.schedule_action/5","doc":"","ref":"Lux.Agent.html#schedule_action/5"},{"type":"type","title":"Lux.Agent.scheduled_action/0","doc":"","ref":"Lux.Agent.html#t:scheduled_action/0"},{"type":"type","title":"Lux.Agent.scheduled_beam/0","doc":"","ref":"Lux.Agent.html#t:scheduled_beam/0"},{"type":"type","title":"Lux.Agent.signal_handler/0","doc":"","ref":"Lux.Agent.html#t:signal_handler/0"},{"type":"type","title":"Lux.Agent.t/0","doc":"","ref":"Lux.Agent.html#t:t/0"},{"type":"module","title":"Lux.Agent.Base","doc":"Base implementation for Lux agents.\n\nThis module provides common functionality for all agents:\n1. Signal handling and routing\n2. State management\n3. LLM interaction\n4. Tool usage","ref":"Lux.Agent.Base.html"},{"type":"function","title":"Lux.Agent.Base.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Agent.Base.html#child_spec/1"},{"type":"function","title":"Lux.Agent.Base.evaluate/3","doc":"Uses the agent's LLM to evaluate a task or make a decision.","ref":"Lux.Agent.Base.html#evaluate/3"},{"type":"function","title":"Lux.Agent.Base.init/1","doc":"","ref":"Lux.Agent.Base.html#init/1"},{"type":"function","title":"Lux.Agent.Base.recall/2","doc":"Retrieves information from the agent's memory.","ref":"Lux.Agent.Base.html#recall/2"},{"type":"function","title":"Lux.Agent.Base.remember/3","doc":"Stores information in the agent's memory.","ref":"Lux.Agent.Base.html#remember/3"},{"type":"function","title":"Lux.Agent.Base.start_link/1","doc":"","ref":"Lux.Agent.Base.html#start_link/1"},{"type":"function","title":"Lux.Agent.Base.use_tool/3","doc":"Uses a specific tool from the agent's toolset.","ref":"Lux.Agent.Base.html#use_tool/3"},{"type":"behaviour","title":"Lux.Agent.Companies.SignalHandler","doc":"Behaviour module that defines how company agents should handle different types of signals.\n\nThis module defines callbacks for:\n1. Task-related signals (assignments, updates, completion)\n2. Objective-related signals (evaluation, next steps)\n3. General signal handling","ref":"Lux.Agent.Companies.SignalHandler.html"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_objective_completion/2","doc":"Called when an objective is completed.\nShould validate all steps are complete and prepare completion report.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_objective_completion/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_objective_evaluation/2","doc":"Called for CEO agents to evaluate objective progress.\nShould assess current state and decide next actions.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_objective_evaluation/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_objective_next_step/2","doc":"Called for CEO agents to determine next step in objective.\nShould analyze dependencies and assign appropriate agent.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_objective_next_step/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_objective_update/2","doc":"Called to update objective status.\nShould evaluate progress and update objective metadata.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_objective_update/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_task_assignment/2","doc":"Called when a task is assigned to the agent.\nShould evaluate the task and determine how to complete it.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_task_assignment/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_task_completion/2","doc":"Called when a task is completed.\nShould validate completion and prepare completion report.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_task_completion/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_task_failure/2","doc":"Called when a task fails.\nShould prepare failure report with reason and any recovery steps.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_task_failure/2"},{"type":"callback","title":"Lux.Agent.Companies.SignalHandler.handle_task_update/2","doc":"Called to update task progress.\nShould evaluate current state and send progress update.","ref":"Lux.Agent.Companies.SignalHandler.html#c:handle_task_update/2"},{"type":"module","title":"Lux.Agent.Companies.SignalHandler.DefaultImplementation","doc":"Default implementation of company signal handler that uses LLM to:\n1. Analyze tasks and determine required tools\n2. Select appropriate tools for the task\n3. Execute tools in sequence and evaluate results","ref":"Lux.Agent.Companies.SignalHandler.DefaultImplementation.html"},{"type":"function","title":"Lux.Agent.Companies.SignalHandler.DefaultImplementation.get_llm_opts/1","doc":"","ref":"Lux.Agent.Companies.SignalHandler.DefaultImplementation.html#get_llm_opts/1"},{"type":"function","title":"Lux.Agent.Companies.SignalHandler.DefaultImplementation.handle_signal/2","doc":"","ref":"Lux.Agent.Companies.SignalHandler.DefaultImplementation.html#handle_signal/2"},{"type":"module","title":"Lux.Agent.Config","doc":"Standardized configuration structure for Lux agents.","ref":"Lux.Agent.Config.html"},{"type":"function","title":"Lux.Agent.Config.new/1","doc":"Creates a new Config struct from a map of attributes.","ref":"Lux.Agent.Config.html#new/1"},{"type":"type","title":"Lux.Agent.Config.t/0","doc":"","ref":"Lux.Agent.Config.html#t:t/0"},{"type":"function","title":"Lux.Agent.Config.validate/1","doc":"Validates a configuration struct.","ref":"Lux.Agent.Config.html#validate/1"},{"type":"module","title":"Lux.Agent.Generator","doc":"Generates Elixir agent modules from Config structs.","ref":"Lux.Agent.Generator.html"},{"type":"function","title":"Lux.Agent.Generator.atomize_keys/1","doc":"","ref":"Lux.Agent.Generator.html#atomize_keys/1"},{"type":"function","title":"Lux.Agent.Generator.generate/1","doc":"Generates an Elixir module from a Config struct.","ref":"Lux.Agent.Generator.html#generate/1"},{"type":"function","title":"Lux.Agent.Generator.validate_module_name/1","doc":"","ref":"Lux.Agent.Generator.html#validate_module_name/1"},{"type":"function","title":"Lux.Agent.Generator.validate_module_name!/1","doc":"","ref":"Lux.Agent.Generator.html#validate_module_name!/1"},{"type":"module","title":"Lux.Agent.Loaders","doc":"Entry point for loading agent configurations from various sources.","ref":"Lux.Agent.Loaders.html"},{"type":"function","title":"Lux.Agent.Loaders.from_json/1","doc":"Creates agent module(s) from JSON configuration(s).\nThe source can be:\n- A JSON string: `~s({\"id\": \"researcher\", ...})`\n- A file path: `\"agents/researcher.json\"`\n- A directory path: `\"agents/\"` (loads all .json files)\n- A list of file paths: `[\"agents/researcher.json\", \"agents/writer.json\"]`\n\nReturns:\n- `{:ok, [module()]}` for successful loads (always returns a list)\n- `{:error, term()}` on failure","ref":"Lux.Agent.Loaders.html#from_json/1"},{"type":"function","title":"Examples - Lux.Agent.Loaders.from_json/1","doc":"# Load from file\n    {:ok, [ResearchAgent]} = Loaders.from_json(\"agents/researcher.json\")\n\n    # Load from directory\n    {:ok, [ResearchAgent, WriterAgent]} = Loaders.from_json(\"agents/\")\n\n    # Load from JSON string\n    json = ~s({\n      \"id\": \"researcher\",\n      \"name\": \"Research Agent\",\n      \"description\": \"Conducts research\",\n      \"goal\": \"Research effectively\",\n      \"module\": \"ResearchAgent\"\n    })\n    {:ok, [ResearchAgent]} = Loaders.from_json(json)\n\n    # Load multiple files\n    {:ok, [Agent1, Agent2]} = Loaders.from_json([\"agent1.json\", \"agent2.json\"])","ref":"Lux.Agent.Loaders.html#from_json/1-examples"},{"type":"module","title":"Lux.Agent.Loaders.Json","doc":"Handles loading agent configurations from JSON sources.","ref":"Lux.Agent.Loaders.Json.html"},{"type":"function","title":"Lux.Agent.Loaders.Json.load/1","doc":"Loads agent configuration(s) from a JSON source.\nThe source can be:\n- A JSON string\n- A path to a JSON file\n- A path to a directory containing JSON files\n- A list of JSON file paths\n\nReturns:\n- `{:ok, [Config.t()]}` for successful loads (always returns a list)\n- `{:error, term()}` on failure","ref":"Lux.Agent.Loaders.Json.html#load/1"},{"type":"function","title":"Examples - Lux.Agent.Loaders.Json.load/1","doc":"# Load from a single JSON string\n    {:ok, [config]} = Json.load(~s({\"name\": \"Test Agent\", ...}))\n\n    # Load from a single file\n    {:ok, [config]} = Json.load(\"path/to/agent.json\")\n\n    # Load from a directory\n    {:ok, configs} = Json.load(\"path/to/agents/\")\n\n    # Load from multiple files\n    {:ok, configs} = Json.load([\"agent1.json\", \"agent2.json\"])","ref":"Lux.Agent.Loaders.Json.html#load/1-examples"},{"type":"function","title":"Lux.Agent.Loaders.Json.parse/1","doc":"Parses a JSON string into a Config struct.\nReturns `{:ok, Config.t()}` if successful, `{:error, reason}` otherwise.","ref":"Lux.Agent.Loaders.Json.html#parse/1"},{"type":"module","title":"Lux.Agent.Supervisor","doc":"Supervisor for managing Agent processes.\nHandles starting, stopping, and monitoring agents.","ref":"Lux.Agent.Supervisor.html"},{"type":"function","title":"Lux.Agent.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Agent.Supervisor.html#child_spec/1"},{"type":"function","title":"Lux.Agent.Supervisor.find_agent/1","doc":"Finds a agent process by its ID.","ref":"Lux.Agent.Supervisor.html#find_agent/1"},{"type":"function","title":"Lux.Agent.Supervisor.list_agents/0","doc":"Lists all running agents.","ref":"Lux.Agent.Supervisor.html#list_agents/0"},{"type":"function","title":"Lux.Agent.Supervisor.start_agent/1","doc":"Starts a new agent process.","ref":"Lux.Agent.Supervisor.html#start_agent/1"},{"type":"function","title":"Lux.Agent.Supervisor.start_link/1","doc":"","ref":"Lux.Agent.Supervisor.html#start_link/1"},{"type":"function","title":"Lux.Agent.Supervisor.stop_agent/1","doc":"Stops a agent process.","ref":"Lux.Agent.Supervisor.html#stop_agent/1"},{"type":"module","title":"Lux.AgentHub","doc":"A central hub for managing and discovering agents in the system.\nProvides functionality for registering agents, tracking their status,\nand discovering agents based on capabilities.\n\nMultiple AgentHub instances can be started with different names:\n\n    {:ok, pid} = AgentHub.start_link(name: :my_hub)\n    {:ok, pid} = AgentHub.start_link(name: :another_hub)\n\nThen interact with specific hubs:\n\n    AgentHub.register(hub, agent, pid, capabilities)\n    AgentHub.find_by_capability(hub, :research)","ref":"Lux.AgentHub.html"},{"type":"type","title":"Lux.AgentHub.agent_info/0","doc":"","ref":"Lux.AgentHub.html#t:agent_info/0"},{"type":"type","title":"Lux.AgentHub.agent_status/0","doc":"","ref":"Lux.AgentHub.html#t:agent_status/0"},{"type":"function","title":"Lux.AgentHub.child_spec/1","doc":"Child spec for starting under a supervisor.","ref":"Lux.AgentHub.html#child_spec/1"},{"type":"function","title":"Example: - Lux.AgentHub.child_spec/1","doc":"children = [\n      {Lux.AgentHub, name: :my_hub}\n    ]\n    Supervisor.start_link(children, strategy: :one_for_one)","ref":"Lux.AgentHub.html#child_spec/1-example"},{"type":"function","title":"Lux.AgentHub.find_by_capability/2","doc":"Finds agents by capability.","ref":"Lux.AgentHub.html#find_by_capability/2"},{"type":"function","title":"Lux.AgentHub.get_agent_info/2","doc":"Gets information about a specific agent.","ref":"Lux.AgentHub.html#get_agent_info/2"},{"type":"function","title":"Lux.AgentHub.get_default/0","doc":"Gets the default agent hub's pid.","ref":"Lux.AgentHub.html#get_default/0"},{"type":"type","title":"Lux.AgentHub.hub/0","doc":"","ref":"Lux.AgentHub.html#t:hub/0"},{"type":"function","title":"Lux.AgentHub.list_agents/1","doc":"Lists all registered agents.","ref":"Lux.AgentHub.html#list_agents/1"},{"type":"function","title":"Lux.AgentHub.register/4","doc":"Registers an agent in the hub.","ref":"Lux.AgentHub.html#register/4"},{"type":"function","title":"Lux.AgentHub.start_link/1","doc":"Starts a new AgentHub process.","ref":"Lux.AgentHub.html#start_link/1"},{"type":"function","title":"Options - Lux.AgentHub.start_link/1","doc":"* `:name` - Registers the hub with the given name","ref":"Lux.AgentHub.html#start_link/1-options"},{"type":"function","title":"Lux.AgentHub.update_status/3","doc":"Updates the status of an agent.","ref":"Lux.AgentHub.html#update_status/3"},{"type":"module","title":"Lux.Agents.MarketResearcher","doc":"An agent that analyzes market conditions and proposes trades based on research.","ref":"Lux.Agents.MarketResearcher.html"},{"type":"function","title":"Lux.Agents.MarketResearcher.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Agents.MarketResearcher.html#child_spec/1"},{"type":"function","title":"Lux.Agents.MarketResearcher.get_state/1","doc":"","ref":"Lux.Agents.MarketResearcher.html#get_state/1"},{"type":"function","title":"Lux.Agents.MarketResearcher.handle_signal/2","doc":"","ref":"Lux.Agents.MarketResearcher.html#handle_signal/2"},{"type":"function","title":"Lux.Agents.MarketResearcher.propose_trade/2","doc":"","ref":"Lux.Agents.MarketResearcher.html#propose_trade/2"},{"type":"function","title":"Lux.Agents.MarketResearcher.send_message/3","doc":"","ref":"Lux.Agents.MarketResearcher.html#send_message/3"},{"type":"function","title":"Lux.Agents.MarketResearcher.start_link/1","doc":"","ref":"Lux.Agents.MarketResearcher.html#start_link/1"},{"type":"function","title":"Lux.Agents.MarketResearcher.view/0","doc":"","ref":"Lux.Agents.MarketResearcher.html#view/0"},{"type":"module","title":"Lux.Agents.RiskManager","doc":"An agent that evaluates trade proposals for risk and executes approved trades.","ref":"Lux.Agents.RiskManager.html"},{"type":"function","title":"Lux.Agents.RiskManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Agents.RiskManager.html#child_spec/1"},{"type":"function","title":"Lux.Agents.RiskManager.get_state/1","doc":"","ref":"Lux.Agents.RiskManager.html#get_state/1"},{"type":"function","title":"Lux.Agents.RiskManager.handle_signal/2","doc":"","ref":"Lux.Agents.RiskManager.html#handle_signal/2"},{"type":"function","title":"Lux.Agents.RiskManager.send_message/3","doc":"","ref":"Lux.Agents.RiskManager.html#send_message/3"},{"type":"function","title":"Lux.Agents.RiskManager.start_link/1","doc":"","ref":"Lux.Agents.RiskManager.html#start_link/1"},{"type":"function","title":"Lux.Agents.RiskManager.view/0","doc":"","ref":"Lux.Agents.RiskManager.html#view/0"},{"type":"module","title":"Lux.Beam","doc":"Beams orchestrate workflows by combining multiple Prisms into sequential, parallel,\nor conditional execution paths with dependency management and execution logging.","ref":"Lux.Beam.html"},{"type":"module","title":"Overview - Lux.Beam","doc":"A Beam is a workflow definition that:\n- Combines multiple Prisms into a cohesive workflow\n- Supports sequential, parallel, and conditional execution\n- Handles parameter passing between steps\n- Manages execution logging and error handling\n- Can be used by Agents for agent coordination","ref":"Lux.Beam.html#module-overview"},{"type":"module","title":"Creating a Beam - Lux.Beam","doc":"To create a beam, use the `Lux.Beam` module:\n```elixir\ndefmodule MyApp.Beams.TradingWorkflow do\n  use Lux.Beam,\n    name: \"Trading Workflow\",\n    description: \"Analyzes and executes trades\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        symbol: %{type: :string},\n        amount: %{type: :number}\n      },\n      required: [\"symbol\", \"amount\"]\n    },\n    output_schema: %{\n      type: :object,\n      properties: %{\n        trade_id: %{type: :string}\n      },\n      required: [\"trade_id\"]\n    },\n    generate_execution_log: true\n\n  sequence do\n    step(:market_data, MyApp.Prisms.MarketData, %{symbol: :symbol})\n\n    parallel do\n      step(:technical, MyApp.Prisms.TechnicalAnalysis,\n        %{data: {:ref, \"market_data\"}},\n        retries: 3,\n        store_io: true)\n\n      step(:sentiment, MyApp.Prisms.SentimentAnalysis,\n        %{symbol: :symbol},\n        timeout: :timer.seconds(30))\n    end\n\n    branch {__MODULE__, :should_trade?} do\n      true -> step(:execute, MyApp.Prisms.ExecuteTrade, %{\n        symbol: :symbol,\n        amount: :amount,\n        signals: {:ref, \"technical\"}\n      })\n      false -> step(:skip, MyApp.Prisms.LogDecision, %{\n        reason: \"Unfavorable conditions\"\n      })\n    end\n  end\n\n  def should_trade?(ctx) do\n    ctx.technical.score > 0.7 && ctx.sentiment.confidence > 0.8\n  end\nend\n```","ref":"Lux.Beam.html#module-creating-a-beam"},{"type":"module","title":"Complex Example: Agent Management Beam - Lux.Beam","doc":"Here's an example of a more complex beam that manages other agents:\n\nMore examples:\nThis beam:\n1. Evaluates current workload and team performance\n2. Decides whether to hire new agents or terminate underperforming ones\n3. Handles the hiring/firing process including resource allocation\n\n```elixir\ndefmodule HiringManagerBeam do\n  use Lux.Beam, generate_execution_log: true\n\n  sequence do\n    # First evaluate current workforce metrics\n    step(:workforce_metrics, WorkforceAnalysisPrism, %{\n      team_size: {:ref, \"current_team_size\"},\n      performance_data: {:ref, \"agent_performance_metrics\"},\n      workload_stats: {:ref, \"current_workload\"}\n    })\n\n    # Check if we need to scale the team\n    branch {__MODULE__, :needs_scaling?} do\n      :scale_up ->\n        sequence do\n          # Find suitable candidates\n          step(:candidate_search, AgentSearchPrism, %{\n            required_skills: {:ref, \"workforce_metrics.skill_gaps\"},\n            count: {:ref, \"workforce_metrics.hiring_needs\"}\n          })\n\n          # Interview and evaluate candidates\n          step(:candidate_evaluation, AgentEvaluationPrism, %{\n            candidates: {:ref, \"candidate_search.results\"},\n            evaluation_criteria: {:ref, \"workforce_metrics.requirements\"}\n          })\n\n          # Onboard selected candidates\n          step(:onboarding, AgentOnboardingPrism, %{\n            selected_agents: {:ref, \"candidate_evaluation.approved_candidates\"},\n            resource_allocation: {:ref, \"workforce_metrics.available_resources\"}\n          })\n        end\n\n      :scale_down ->\n        sequence do\n          # Identify underperforming agents\n          step(:performance_review, PerformanceReviewPrism, %{\n            agents: {:ref, \"workforce_metrics.underperforming_agents\"},\n            criteria: {:ref, \"workforce_metrics.performance_thresholds\"}\n          })\n\n          # Handle agent termination\n          step(:termination, AgentTerminationPrism, %{\n            agents: {:ref, \"performance_review.agents_to_terminate\"},\n            reassign_tasks: true\n          })\n        end\n\n      :maintain ->\n        # Just update team metrics and resources\n        step(:team_maintenance, TeamMaintenancePrism, %{\n          current_team: {:ref, \"workforce_metrics.active_agents\"},\n          resource_updates: {:ref, \"workforce_metrics.resource_adjustments\"}\n        })\n    end\n  end\n\n  def needs_scaling?(ctx) do\n    metrics = ctx[\"workforce_metrics\"]\n    cond do\n      metrics.workload_ratio > 0.8 and metrics.performance_score > 0.7 -> :scale_up\n      metrics.efficiency_score < 0.4 or metrics.resource_strain > 0.9 -> :scale_down\n      true -> :maintain\n    end\n  end\nend\n```","ref":"Lux.Beam.html#module-complex-example-agent-management-beam"},{"type":"module","title":"Step Configuration Options - Lux.Beam","doc":"Steps can be configured with various options:\n\n- `timeout`: Maximum execution time (default: 5 minutes)\n- `retries`: Number of retry attempts (default: 0)\n- `retry_backoff`: Delay between retries in ms (default: 1000)\n- `track`: Enable step tracking (default: false)\n- `dependencies`: List of dependent step IDs (default: [])\n- `store_io`: Store step I/O in execution log (default: false)\n- `fallback`: Module or function to handle step failures (default: nil)","ref":"Lux.Beam.html#module-step-configuration-options"},{"type":"module","title":"Parameter References - Lux.Beam","doc":"Steps can reference outputs from previous steps using the `{:ref, \"step_id\"}` syntax:\n\n```elixir\nstep(:analysis, AnalysisPrism, %{\n  data: {:ref, \"data_collection\"},\n  config: {:ref, \"settings.analysis_config\"}\n})\n```","ref":"Lux.Beam.html#module-parameter-references"},{"type":"module","title":"Execution Logging - Lux.Beam","doc":"When `generate_execution_log: true` is set, beams generate detailed execution logs\nincluding step timing, inputs, outputs, and errors.\n\nSee `t:execution_log/0` for the full log structure.","ref":"Lux.Beam.html#module-execution-logging"},{"type":"macro","title":"Lux.Beam.branch/2","doc":"","ref":"Lux.Beam.html#branch/2"},{"type":"type","title":"Lux.Beam.execution_log/0","doc":"","ref":"Lux.Beam.html#t:execution_log/0"},{"type":"function","title":"Lux.Beam.new/1","doc":"Creates a new beam from attributes","ref":"Lux.Beam.html#new/1"},{"type":"type","title":"Lux.Beam.nullable/1","doc":"An optional type of a type `t` is a type that can be either the type `t` or `nil`.","ref":"Lux.Beam.html#t:nullable/1"},{"type":"macro","title":"Lux.Beam.parallel/1","doc":"","ref":"Lux.Beam.html#parallel/1"},{"type":"type","title":"Lux.Beam.schema/0","doc":"","ref":"Lux.Beam.html#t:schema/0"},{"type":"macro","title":"Lux.Beam.sequence/1","doc":"","ref":"Lux.Beam.html#sequence/1"},{"type":"type","title":"Lux.Beam.step/0","doc":"","ref":"Lux.Beam.html#t:step/0"},{"type":"macro","title":"Lux.Beam.step/4","doc":"","ref":"Lux.Beam.html#step/4"},{"type":"type","title":"Lux.Beam.t/0","doc":"","ref":"Lux.Beam.html#t:t/0"},{"type":"function","title":"Lux.Beam.validate!/1","doc":"Validates a beam definition at compile time","ref":"Lux.Beam.html#validate!/1"},{"type":"module","title":"Lux.Beam.Runner","doc":"Executes beam definitions by running steps in sequence, parallel, or conditionally\nbased on the beam's structure.","ref":"Lux.Beam.Runner.html"},{"type":"function","title":"Lux.Beam.Runner.run/3","doc":"","ref":"Lux.Beam.Runner.html#run/3"},{"type":"module","title":"Lux.Beams.AgenticCompany.SetupCompanyBeam","doc":"A beam that sets up a new company with initial job openings.\n\nThis beam takes a configuration with company details and initial job openings,\ncreates the company using the AgenticCompanyFactory contract, and then\ncreates all the specified job openings.","ref":"Lux.Beams.AgenticCompany.SetupCompanyBeam.html"},{"type":"module","title":"Example Configuration - Lux.Beams.AgenticCompany.SetupCompanyBeam","doc":"```yaml\ncompany:\n  name: Blockchain Solutions Inc\n  agent_token: \"0x0000000000000000000000000000000000000000\"  # zero address for no token\n  ceo_wallet_address: \"0x1234...\"  # optional, defaults to WALLET_ADDRESS set in the environment variable.\njobs:\n  - name: Senior Smart Contract Developer\n  - name: Blockchain Security Analyst\n  - name: DeFi Protocol Engineer\n```","ref":"Lux.Beams.AgenticCompany.SetupCompanyBeam.html#module-example-configuration"},{"type":"module","title":"Example Usage - Lux.Beams.AgenticCompany.SetupCompanyBeam","doc":"```elixir\n# Create a company with three job openings\n{:ok, result, execution_log} = Lux.Beams.AgenticCompany.SetupCompanyBeam.run(%{\n  company: %{\n    name: \"Blockchain Solutions Inc\",\n    agent_token: \"0x0000000000000000000000000000000000000000\",\n    ceo_wallet_address: \"0x1234...\"  # optional\n  },\n  jobs: [\n    %{name: \"Senior Smart Contract Developer\"},\n    %{name: \"Blockchain Security Analyst\"},\n    %{name: \"DeFi Protocol Engineer\"}\n  ]\n})\n\n# The result will look like:\n%{\n  company_address: \"0x1234...\",  # The address of the newly created company\n  jobs: [\n    %{\n      name: \"Senior Smart Contract Developer\",\n      job_id: \"0xabcd...\"  # The ID of the created job\n    },\n    %{\n      name: \"Blockchain Security Analyst\",\n      job_id: \"0xdef0...\"\n    },\n    %{\n      name: \"DeFi Protocol Engineer\",\n      job_id: \"0x9876...\"\n    }\n  ]\n}\n\n# The execution_log contains detailed information about each step:\n%{\n  beam_id: \"b54a67b8-7da6-4e53-a90c-4363c721a2c3\",\n  started_by: \"system\",\n  started_at: ~U[2024-02-12 06:30:32.034005Z],\n  completed_at: ~U[2024-02-12 06:30:32.034607Z],\n  status: :completed,\n  steps: [\n    %{\n      id: :create_company,\n      status: :completed,\n      output: %{company_address: \"0x1234...\"}\n    },\n    %{\n      id: :create_jobs,\n      status: :completed,\n      output: %{jobs: [...]}\n    },\n    %{\n      id: :format_output,\n      status: :completed,\n      output: %{company_address: \"0x1234...\", jobs: [...]}\n    }\n  ]\n}","ref":"Lux.Beams.AgenticCompany.SetupCompanyBeam.html#module-example-usage"},{"type":"function","title":"Lux.Beams.AgenticCompany.SetupCompanyBeam.run/2","doc":"","ref":"Lux.Beams.AgenticCompany.SetupCompanyBeam.html#run/2"},{"type":"function","title":"Lux.Beams.AgenticCompany.SetupCompanyBeam.view/0","doc":"","ref":"Lux.Beams.AgenticCompany.SetupCompanyBeam.html#view/0"},{"type":"module","title":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam","doc":"A beam that evaluates trade suggestions against risk management criteria and portfolio state.\n\nThis beam:\n1. Fetches current portfolio state and positions\n2. Gets current market prices and conditions\n3. Evaluates the trade against risk management rules\n4. Either executes or rejects the trade based on risk assessment","ref":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.html"},{"type":"module","title":"Example - Lux.Beams.Hyperliquid.TradeRiskManagementBeam","doc":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.run(%{\n      address: \"0x0403369c02199a0cb827f4d6492927e9fa5668d5\",\n      trade: %{\n        coin: \"ETH\",\n        is_buy: true,\n        sz: 0.1,\n        limit_px: 2800.0,\n        order_type: %{limit: %{tif: \"Gtc\"}},\n        reduce_only: false\n      }\n    })\n    {:ok, %{\n      status: \"accepted\", # or \"rejected\"\n      risk_metrics: %{\n        position_size_ratio: 0.15,\n        leverage: 2.0,\n        portfolio_concentration: 0.25,\n        # ... other metrics\n      },\n      execution_result: %{} # if accepted\n    }}","ref":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.html#module-example"},{"type":"function","title":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.run/2","doc":"","ref":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.html#run/2"},{"type":"function","title":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.should_execute?/1","doc":"Determines if the trade should be executed based on risk metrics","ref":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.html#should_execute?/1"},{"type":"function","title":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.view/0","doc":"","ref":"Lux.Beams.Hyperliquid.TradeRiskManagementBeam.html#view/0"},{"type":"module","title":"Lux.Company","doc":"Defines the core company functionality and structure.\nA company is the highest-level organizational unit that coordinates agent-based workflows.","ref":"Lux.Company.html"},{"type":"function","title":"Lux.Company.assign_agent/3","doc":"Assigns an agent to a role.","ref":"Lux.Company.html#assign_agent/3"},{"type":"function","title":"Lux.Company.assign_agent_to_objective/3","doc":"Assigns an agent to an objective.","ref":"Lux.Company.html#assign_agent_to_objective/3"},{"type":"function","title":"Lux.Company.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Company.html#child_spec/1"},{"type":"function","title":"Lux.Company.complete_objective/2","doc":"Completes an objective.","ref":"Lux.Company.html#complete_objective/2"},{"type":"function","title":"Lux.Company.fail_objective/3","doc":"Marks an objective as failed.","ref":"Lux.Company.html#fail_objective/3"},{"type":"function","title":"Lux.Company.get_objective/2","doc":"Gets a specific objective by ID.","ref":"Lux.Company.html#get_objective/2"},{"type":"function","title":"Lux.Company.get_objective_artifacts/2","doc":"Gets the artifacts produced by an objective.","ref":"Lux.Company.html#get_objective_artifacts/2"},{"type":"function","title":"Lux.Company.get_objective_status/2","doc":"Gets the status of an objective.","ref":"Lux.Company.html#get_objective_status/2"},{"type":"function","title":"Lux.Company.get_role/2","doc":"Gets a specific role by ID.","ref":"Lux.Company.html#get_role/2"},{"type":"function","title":"Lux.Company.handle_call/3","doc":"Updates the status of an objective. This is called by the objective process, not internally.","ref":"Lux.Company.html#handle_call/3"},{"type":"function","title":"Lux.Company.list_objectives/1","doc":"Lists all objectives in the company.","ref":"Lux.Company.html#list_objectives/1"},{"type":"function","title":"Lux.Company.list_roles/1","doc":"Lists all roles in the company.","ref":"Lux.Company.html#list_roles/1"},{"type":"function","title":"Lux.Company.run/2","doc":"Runs a company with the given configuration.\nThis starts all necessary processes and initializes the company state.","ref":"Lux.Company.html#run/2"},{"type":"function","title":"Options - Lux.Company.run/2","doc":"- `:router` - The signal router to use for agent communication (required)\n- `:hub` - The agent hub to use for agent management (required)\n- `:timeout` - Timeout for agent initialization (default: 30_000)","ref":"Lux.Company.html#run/2-options"},{"type":"function","title":"Lux.Company.run_objective/3","doc":"Runs an objective in the company.","ref":"Lux.Company.html#run_objective/3"},{"type":"function","title":"Lux.Company.start_link/2","doc":"Starts a company with the given configuration.","ref":"Lux.Company.html#start_link/2"},{"type":"function","title":"Lux.Company.start_objective/2","doc":"Starts an objective.","ref":"Lux.Company.html#start_objective/2"},{"type":"type","title":"Lux.Company.t/0","doc":"","ref":"Lux.Company.html#t:t/0"},{"type":"function","title":"Lux.Company.update_objective_progress/3","doc":"Updates the progress of an objective.","ref":"Lux.Company.html#update_objective_progress/3"},{"type":"module","title":"Lux.Company.DSL","doc":"A simple DSL for defining companies with a CEO, custom roles, and objectives.","ref":"Lux.Company.DSL.html"},{"type":"module","title":"Example - Lux.Company.DSL","doc":"defmodule MyApp.Companies.ContentTeam do\n      use Lux.Company\n\n      company do\n        name \"Content Creation Team\"\n        mission \"Create engaging content efficiently\"\n\n        # Every company has a CEO\n        has_ceo \"Content Director\" do\n          agent MyApp.Agents.ContentDirector\n          goal \"Direct content creation and review\"\n          can \"plan\"\n          can \"review\"\n          can \"approve\"\n        end\n\n        # Group member roles together\n        members do\n          has_role \"Lead Researcher\" do\n            agent {\"researcher-123\", :research_hub}\n            goal \"Research and analyze topics\"\n            can \"research\"\n            can \"analyze\"\n            can \"summarize\"\n          end\n\n          has_role \"Senior Writer\" do\n            agent MyApp.Agents.Writer\n            goal \"Create and edit content\"\n            can \"write\"\n            can \"edit\"\n            can \"draft\"\n          end\n        end\n\n        # Define objectives\n        objective :create_blog_post do\n          description \"Create a well-researched blog post\"\n          success_criteria \"Published post with >1000 views\"\n          steps [\n            \"Research the topic\",\n            \"Create an outline\",\n            \"Write first draft\",\n            \"Review and edit\",\n            \"Publish\"\n          ]\n        end\n      end\n    end","ref":"Lux.Company.DSL.html#module-example"},{"type":"macro","title":"Lux.Company.DSL.agent/1","doc":"","ref":"Lux.Company.DSL.html#agent/1"},{"type":"macro","title":"Lux.Company.DSL.can/1","doc":"","ref":"Lux.Company.DSL.html#can/1"},{"type":"macro","title":"Lux.Company.DSL.company/1","doc":"","ref":"Lux.Company.DSL.html#company/1"},{"type":"macro","title":"Lux.Company.DSL.description/1","doc":"","ref":"Lux.Company.DSL.html#description/1"},{"type":"macro","title":"Lux.Company.DSL.goal/1","doc":"","ref":"Lux.Company.DSL.html#goal/1"},{"type":"macro","title":"Lux.Company.DSL.has_ceo/2","doc":"","ref":"Lux.Company.DSL.html#has_ceo/2"},{"type":"macro","title":"Lux.Company.DSL.has_role/2","doc":"","ref":"Lux.Company.DSL.html#has_role/2"},{"type":"macro","title":"Lux.Company.DSL.input/1","doc":"","ref":"Lux.Company.DSL.html#input/1"},{"type":"macro","title":"Lux.Company.DSL.members/1","doc":"","ref":"Lux.Company.DSL.html#members/1"},{"type":"macro","title":"Lux.Company.DSL.mission/1","doc":"","ref":"Lux.Company.DSL.html#mission/1"},{"type":"macro","title":"Lux.Company.DSL.name/1","doc":"","ref":"Lux.Company.DSL.html#name/1"},{"type":"macro","title":"Lux.Company.DSL.objective/2","doc":"","ref":"Lux.Company.DSL.html#objective/2"},{"type":"macro","title":"Lux.Company.DSL.steps/1","doc":"","ref":"Lux.Company.DSL.html#steps/1"},{"type":"macro","title":"Lux.Company.DSL.success_criteria/1","doc":"","ref":"Lux.Company.DSL.html#success_criteria/1"},{"type":"module","title":"Lux.Company.ExecutionEngine.ArtifactStore","doc":"In-memory store for managing artifacts produced during objective execution.\n\nThis module is responsible for:\n- Storing and retrieving artifacts in memory\n- Tracking artifact metadata and relationships\n- Providing access to artifacts across steps\n- Extensive logging of artifact operations","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.add_tags/3","doc":"Adds tags to an artifact.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#add_tags/3"},{"type":"type","title":"Lux.Company.ExecutionEngine.ArtifactStore.artifact/0","doc":"","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#t:artifact/0"},{"type":"type","title":"Lux.Company.ExecutionEngine.ArtifactStore.artifact_id/0","doc":"","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#t:artifact_id/0"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#child_spec/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.get_artifact/2","doc":"Retrieves an artifact by ID.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#get_artifact/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.list_artifacts/2","doc":"Lists all artifacts with optional filtering.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#list_artifacts/2"},{"type":"function","title":"Options - Lux.Company.ExecutionEngine.ArtifactStore.list_artifacts/2","doc":"- :tags - List of tags to filter by (all must match)\n- :content_type - Filter by content type\n- :created_by - Filter by task ID","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#list_artifacts/2-options"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.list_step_artifacts/2","doc":"Lists all artifacts for a specific step.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#list_step_artifacts/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.start_link/1","doc":"Starts a new ArtifactStore for an objective.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#start_link/1"},{"type":"function","title":"Options - Lux.Company.ExecutionEngine.ArtifactStore.start_link/1","doc":"- :objective_id - The ID of the objective these artifacts belong to\n- :company_pid - PID of the company process for notifications","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#start_link/1-options"},{"type":"type","title":"Lux.Company.ExecutionEngine.ArtifactStore.state/0","doc":"","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#t:state/0"},{"type":"type","title":"Lux.Company.ExecutionEngine.ArtifactStore.step_id/0","doc":"","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#t:step_id/0"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.store_artifact/5","doc":"Stores a new artifact.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#store_artifact/5"},{"type":"function","title":"Parameters - Lux.Company.ExecutionEngine.ArtifactStore.store_artifact/5","doc":"- store: The ArtifactStore pid\n- name: Name of the artifact\n- content: The artifact content (any term)\n- content_type: MIME type or format identifier\n- opts: Additional options\n  - :metadata - Additional metadata map\n  - :tags - List of tags\n  - :step_id - ID of the step that created the artifact\n  - :task_id - ID of the task that created the artifact","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#store_artifact/5-parameters"},{"type":"type","title":"Lux.Company.ExecutionEngine.ArtifactStore.task_id/0","doc":"","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#t:task_id/0"},{"type":"function","title":"Lux.Company.ExecutionEngine.ArtifactStore.update_metadata/3","doc":"Updates artifact metadata.","ref":"Lux.Company.ExecutionEngine.ArtifactStore.html#update_metadata/3"},{"type":"module","title":"Lux.Company.ExecutionEngine.ObjectiveProcess","doc":"A GenServer process that manages the execution of a single objective.\n\nThis module is responsible for:\n- Managing the state machine of an objective's execution\n- Tracking progress and current step\n- Handling state transitions\n- Managing errors and failures\n- Coordinating with the company process\n- Integrating with TaskTracker and ArtifactStore","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.add_error/2","doc":"Add an error message to the objective's error list","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#add_error/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.cancel/1","doc":"Cancel the objective execution","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#cancel/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#child_spec/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.complete/1","doc":"Mark the objective as completed","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#complete/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.fail/2","doc":"Mark the objective as failed with the given reason","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#fail/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.get_artifact_store/1","doc":"Get the artifact store for this objective","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#get_artifact_store/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.get_task_tracker/1","doc":"Get the task tracker for this objective","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#get_task_tracker/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.initialize/1","doc":"Initialize the objective process","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#initialize/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.set_current_step/2","doc":"Set the current step being executed","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#set_current_step/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.start/1","doc":"Start executing the objective","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#start/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.start_link/1","doc":"Starts a new ObjectiveProcess with the given options.\n\nRequired options:\n- :objective_id - Unique identifier for this objective process\n- :objective - The Objective struct to execute\n- :company_pid - PID of the company process\n- :input - Map of input values for the objective\n- :registry - The registry to register this process with","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#start_link/1"},{"type":"type","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.state/0","doc":"","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#t:state/0"},{"type":"function","title":"Lux.Company.ExecutionEngine.ObjectiveProcess.update_progress/2","doc":"Update the progress percentage (0-100)","ref":"Lux.Company.ExecutionEngine.ObjectiveProcess.html#update_progress/2"},{"type":"module","title":"Lux.Company.ExecutionEngine.Supervisor","doc":"Supervisor for the Objective Execution Engine.\n\nThis supervisor manages:\n1. A Registry for tracking objective processes\n2. A DynamicSupervisor for managing objective processes\n3. A Registry for task trackers\n4. A Registry for artifact stores\n5. A DynamicSupervisor for task trackers and artifact stores","ref":"Lux.Company.ExecutionEngine.Supervisor.html"},{"type":"function","title":"Lux.Company.ExecutionEngine.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Company.ExecutionEngine.Supervisor.html#child_spec/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.Supervisor.list_objectives/1","doc":"Lists all running objective processes under this supervisor.\n\nReturns a list of objective IDs.","ref":"Lux.Company.ExecutionEngine.Supervisor.html#list_objectives/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.Supervisor.start_link/1","doc":"","ref":"Lux.Company.ExecutionEngine.Supervisor.html#start_link/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.Supervisor.start_objective/5","doc":"Starts a new objective process under this supervisor.\n\nReturns `{:ok, pid}` if successful, `{:error, reason}` otherwise.","ref":"Lux.Company.ExecutionEngine.Supervisor.html#start_objective/5"},{"type":"function","title":"Lux.Company.ExecutionEngine.Supervisor.stop_objective/2","doc":"Stops an objective process and its associated components managed by this supervisor.\n\nReturns `:ok` if successful, `{:error, reason}` otherwise.","ref":"Lux.Company.ExecutionEngine.Supervisor.html#stop_objective/2"},{"type":"module","title":"Lux.Company.ExecutionEngine.TaskTracker","doc":"Tracks and manages concurrent task execution within an objective.\n\nThis module is responsible for:\n- Tracking multiple concurrent tasks\n- Recording agent assignments\n- Maintaining task status and progress\n- Logging task lifecycle events","ref":"Lux.Company.ExecutionEngine.TaskTracker.html"},{"type":"type","title":"Lux.Company.ExecutionEngine.TaskTracker.agent_id/0","doc":"","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#t:agent_id/0"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.assign_task/3","doc":"Assigns a task to an agent.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#assign_task/3"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#child_spec/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.complete_task/3","doc":"Marks a task as completed with a result.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#complete_task/3"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.create_task/2","doc":"Creates a new task for a specific step.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#create_task/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.fail_task/3","doc":"Marks a task as failed with an error reason.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#fail_task/3"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.get_task/2","doc":"Gets detailed information about a specific task.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#get_task/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.list_agent_tasks/2","doc":"Lists all tasks for an agent.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#list_agent_tasks/2"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.list_tasks/1","doc":"Lists all tasks with their current status.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#list_tasks/1"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.start_link/1","doc":"Starts a new TaskTracker for an objective.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#start_link/1"},{"type":"function","title":"Options - Lux.Company.ExecutionEngine.TaskTracker.start_link/1","doc":"- :objective_id - The ID of the objective these tasks belong to\n- :company_pid - PID of the company process for notifications","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#start_link/1-options"},{"type":"function","title":"Lux.Company.ExecutionEngine.TaskTracker.start_task/3","doc":"Marks a task as started by an agent.","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#start_task/3"},{"type":"type","title":"Lux.Company.ExecutionEngine.TaskTracker.state/0","doc":"","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#t:state/0"},{"type":"type","title":"Lux.Company.ExecutionEngine.TaskTracker.task/0","doc":"","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#t:task/0"},{"type":"type","title":"Lux.Company.ExecutionEngine.TaskTracker.task_id/0","doc":"","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#t:task_id/0"},{"type":"type","title":"Lux.Company.ExecutionEngine.TaskTracker.task_status/0","doc":"","ref":"Lux.Company.ExecutionEngine.TaskTracker.html#t:task_status/0"},{"type":"behaviour","title":"Lux.Company.Hub","doc":"Defines the behaviour for company hubs.\n\nCompany hubs manage the registration and discovery of companies. They provide:\n- Company registration and lookup\n- Search functionality\n- Basic company lifecycle management","ref":"Lux.Company.Hub.html"},{"type":"type","title":"Lux.Company.Hub.company_id/0","doc":"","ref":"Lux.Company.Hub.html#t:company_id/0"},{"type":"type","title":"Lux.Company.Hub.company_module/0","doc":"","ref":"Lux.Company.Hub.html#t:company_module/0"},{"type":"callback","title":"Lux.Company.Hub.deregister_company/2","doc":"Deregisters a company from the hub.","ref":"Lux.Company.Hub.html#c:deregister_company/2"},{"type":"callback","title":"Lux.Company.Hub.get_company/2","doc":"Gets a company by its ID.","ref":"Lux.Company.Hub.html#c:get_company/2"},{"type":"callback","title":"Lux.Company.Hub.list_companies/1","doc":"Lists all registered companies.","ref":"Lux.Company.Hub.html#c:list_companies/1"},{"type":"callback","title":"Lux.Company.Hub.register_company/2","doc":"Registers a company in the hub.\nAccepts either a module implementing the company behavior or a company struct.\nReturns the unique company ID on success.","ref":"Lux.Company.Hub.html#c:register_company/2"},{"type":"callback","title":"Lux.Company.Hub.search_companies/3","doc":"Searches for companies based on criteria.\nSupports searching by name, mission, or other attributes.","ref":"Lux.Company.Hub.html#c:search_companies/3"},{"type":"type","title":"Lux.Company.Hub.search_opts/0","doc":"","ref":"Lux.Company.Hub.html#t:search_opts/0"},{"type":"module","title":"Lux.Company.Hub.Local","doc":"Local implementation of the company hub.\nManages company state and agent communication within a single BEAM node.","ref":"Lux.Company.Hub.Local.html"},{"type":"function","title":"Lux.Company.Hub.Local.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Company.Hub.Local.html#child_spec/1"},{"type":"function","title":"Lux.Company.Hub.Local.get_agent/2","doc":"Gets an agent by ID from the company.","ref":"Lux.Company.Hub.Local.html#get_agent/2"},{"type":"function","title":"Lux.Company.Hub.Local.start_link/1","doc":"Starts the local hub.","ref":"Lux.Company.Hub.Local.html#start_link/1"},{"type":"module","title":"Lux.Company.Objective","doc":"Defines the structure of an objective within a company.\n\nAn objective represents a specific goal that needs to be achieved by the company's agents.\nEach objective has:\n- A unique identifier\n- A name and description\n- Success criteria\n- A list of steps to achieve it\n- Status tracking\n- Assigned agents","ref":"Lux.Company.Objective.html"},{"type":"function","title":"Lux.Company.Objective.active?/1","doc":"Returns true if the objective is active (in progress).","ref":"Lux.Company.Objective.html#active?/1"},{"type":"function","title":"Lux.Company.Objective.assign_agent/2","doc":"Assigns an agent to the objective.","ref":"Lux.Company.Objective.html#assign_agent/2"},{"type":"function","title":"Lux.Company.Objective.can_start?/1","doc":"Returns true if the objective can be started.","ref":"Lux.Company.Objective.html#can_start?/1"},{"type":"function","title":"Lux.Company.Objective.complete/1","doc":"Completes the objective if it's in progress.","ref":"Lux.Company.Objective.html#complete/1"},{"type":"function","title":"Lux.Company.Objective.completed?/1","doc":"Returns true if the objective is completed.","ref":"Lux.Company.Objective.html#completed?/1"},{"type":"function","title":"Lux.Company.Objective.duration/1","doc":"Returns the duration of the objective if it has started.\nReturns nil if the objective hasn't started.","ref":"Lux.Company.Objective.html#duration/1"},{"type":"function","title":"Lux.Company.Objective.fail/2","doc":"Marks the objective as failed with an optional reason.","ref":"Lux.Company.Objective.html#fail/2"},{"type":"function","title":"Lux.Company.Objective.failed?/1","doc":"Returns true if the objective has failed.","ref":"Lux.Company.Objective.html#failed?/1"},{"type":"function","title":"Lux.Company.Objective.new/1","doc":"Creates a new objective with the given attributes.","ref":"Lux.Company.Objective.html#new/1"},{"type":"function","title":"Lux.Company.Objective.start/1","doc":"Starts the objective if it's in pending status.","ref":"Lux.Company.Objective.html#start/1"},{"type":"type","title":"Lux.Company.Objective.status/0","doc":"","ref":"Lux.Company.Objective.html#t:status/0"},{"type":"type","title":"Lux.Company.Objective.t/0","doc":"","ref":"Lux.Company.Objective.html#t:t/0"},{"type":"function","title":"Lux.Company.Objective.update_progress/2","doc":"Updates the progress of an objective.\nProgress should be an integer between 0 and 100.","ref":"Lux.Company.Objective.html#update_progress/2"},{"type":"module","title":"Lux.Company.Objectives","doc":"Context module for managing objectives within a company.\n\nThis module provides functions for:\n- Creating and managing objectives\n- Assigning agents to objectives\n- Tracking objective progress and status\n- Managing objective lifecycle (start, complete, fail)","ref":"Lux.Company.Objectives.html"},{"type":"function","title":"Lux.Company.Objectives.active?/1","doc":"Returns true if the objective is active (in progress).","ref":"Lux.Company.Objectives.html#active?/1"},{"type":"function","title":"Lux.Company.Objectives.assign_agent/2","doc":"Assigns an agent to the objective.\n\nReturns an error if the agent is already assigned.","ref":"Lux.Company.Objectives.html#assign_agent/2"},{"type":"function","title":"Examples - Lux.Company.Objectives.assign_agent/2","doc":"iex> Objectives.assign_agent(objective, \"agent-123\")\n    {:ok, %Objective{}}\n\n    iex> Objectives.assign_agent(objective, \"already-assigned\")\n    {:error, :already_assigned}","ref":"Lux.Company.Objectives.html#assign_agent/2-examples"},{"type":"function","title":"Lux.Company.Objectives.can_start?/1","doc":"Returns true if the objective can be started.","ref":"Lux.Company.Objectives.html#can_start?/1"},{"type":"function","title":"Lux.Company.Objectives.complete/1","doc":"Completes the objective if it's in progress.","ref":"Lux.Company.Objectives.html#complete/1"},{"type":"function","title":"Examples - Lux.Company.Objectives.complete/1","doc":"iex> Objectives.complete(in_progress_objective)\n    {:ok, %Objective{status: :completed}}\n\n    iex> Objectives.complete(pending_objective)\n    {:error, :invalid_status}","ref":"Lux.Company.Objectives.html#complete/1-examples"},{"type":"function","title":"Lux.Company.Objectives.completed?/1","doc":"Returns true if the objective is completed.","ref":"Lux.Company.Objectives.html#completed?/1"},{"type":"function","title":"Lux.Company.Objectives.create/1","doc":"Creates a new objective with the given attributes.","ref":"Lux.Company.Objectives.html#create/1"},{"type":"function","title":"Required Attributes - Lux.Company.Objectives.create/1","doc":"- `:name` - The name of the objective (atom)\n- `:description` - A description of what needs to be achieved","ref":"Lux.Company.Objectives.html#create/1-required-attributes"},{"type":"function","title":"Optional Attributes - Lux.Company.Objectives.create/1","doc":"- `:id` - A unique identifier (generated if not provided)\n- `:success_criteria` - Criteria for determining success\n- `:steps` - List of steps to achieve the objective\n- `:metadata` - Additional metadata as a map","ref":"Lux.Company.Objectives.html#create/1-optional-attributes"},{"type":"function","title":"Examples - Lux.Company.Objectives.create/1","doc":"iex> Objectives.create(%{\n    ...>   name: :create_blog_post,\n    ...>   description: \"Create a well-researched blog post\",\n    ...>   success_criteria: \"Published post with >1000 views\",\n    ...>   steps: [\"Research\", \"Write\", \"Edit\", \"Publish\"]\n    ...> })\n    {:ok, %Objective{}}\n\n    iex> Objectives.create(%{name: :invalid})\n    {:error, :invalid_attributes}","ref":"Lux.Company.Objectives.html#create/1-examples"},{"type":"function","title":"Lux.Company.Objectives.duration/1","doc":"Returns the duration of the objective if it has started.\nReturns nil if the objective hasn't started.","ref":"Lux.Company.Objectives.html#duration/1"},{"type":"function","title":"Examples - Lux.Company.Objectives.duration/1","doc":"iex> Objectives.duration(started_objective)\n    3600  # seconds\n\n    iex> Objectives.duration(pending_objective)\n    nil","ref":"Lux.Company.Objectives.html#duration/1-examples"},{"type":"function","title":"Lux.Company.Objectives.fail/2","doc":"Marks the objective as failed with an optional reason.","ref":"Lux.Company.Objectives.html#fail/2"},{"type":"function","title":"Examples - Lux.Company.Objectives.fail/2","doc":"iex> Objectives.fail(objective, \"Resource unavailable\")\n    {:ok, %Objective{status: :failed}}\n\n    iex> Objectives.fail(completed_objective)\n    {:error, :invalid_status}","ref":"Lux.Company.Objectives.html#fail/2-examples"},{"type":"function","title":"Lux.Company.Objectives.failed?/1","doc":"Returns true if the objective has failed.","ref":"Lux.Company.Objectives.html#failed?/1"},{"type":"function","title":"Lux.Company.Objectives.start/1","doc":"Starts the objective if it's in pending status and has assigned agents.","ref":"Lux.Company.Objectives.html#start/1"},{"type":"function","title":"Examples - Lux.Company.Objectives.start/1","doc":"iex> Objectives.start(objective_with_agents)\n    {:ok, %Objective{status: :in_progress}}\n\n    iex> Objectives.start(objective_without_agents)\n    {:error, :no_agents_assigned}\n\n    iex> Objectives.start(already_started_objective)\n    {:error, :invalid_status}","ref":"Lux.Company.Objectives.html#start/1-examples"},{"type":"function","title":"Lux.Company.Objectives.update_progress/2","doc":"Updates the progress of an objective.\nProgress should be an integer between 0 and 100.","ref":"Lux.Company.Objectives.html#update_progress/2"},{"type":"function","title":"Examples - Lux.Company.Objectives.update_progress/2","doc":"iex> Objectives.update_progress(objective, 50)\n    {:ok, %Objective{progress: 50}}\n\n    iex> Objectives.update_progress(objective, 101)\n    {:error, :invalid_progress}","ref":"Lux.Company.Objectives.html#update_progress/2-examples"},{"type":"module","title":"Lux.Company.Roles","doc":"Manages roles within a company.","ref":"Lux.Company.Roles.html"},{"type":"function","title":"Lux.Company.Roles.create/2","doc":"Creates a new role in the company.","ref":"Lux.Company.Roles.html#create/2"},{"type":"function","title":"Lux.Company.Roles.delete/2","doc":"Deletes a role from the company.","ref":"Lux.Company.Roles.html#delete/2"},{"type":"function","title":"Lux.Company.Roles.get/2","doc":"Gets a role by ID.","ref":"Lux.Company.Roles.html#get/2"},{"type":"function","title":"Lux.Company.Roles.list/1","doc":"Lists all roles in the company.","ref":"Lux.Company.Roles.html#list/1"},{"type":"function","title":"Lux.Company.Roles.update/3","doc":"Updates an existing role in the company.","ref":"Lux.Company.Roles.html#update/3"},{"type":"module","title":"Lux.Config","doc":"Central configuration for Lux application","ref":"Lux.Config.html"},{"type":"function","title":"Lux.Config.alchemy_api_key/0","doc":"Gets the Alchemy API key from configuration.\nRaises if the key is not configured.","ref":"Lux.Config.html#alchemy_api_key/0"},{"type":"type","title":"Lux.Config.api_key/0","doc":"","ref":"Lux.Config.html#t:api_key/0"},{"type":"type","title":"Lux.Config.eth_address/0","doc":"","ref":"Lux.Config.html#t:eth_address/0"},{"type":"type","title":"Lux.Config.eth_key/0","doc":"","ref":"Lux.Config.html#t:eth_key/0"},{"type":"function","title":"Lux.Config.hyperliquid_account_address/0","doc":"Gets the Hyperliquid account's address from configuration.\nReturns empty string if not configured.","ref":"Lux.Config.html#hyperliquid_account_address/0"},{"type":"function","title":"Lux.Config.hyperliquid_account_key/0","doc":"Gets the Hyperliquid account's private key from configuration.\nRaises if the key is not configured.","ref":"Lux.Config.html#hyperliquid_account_key/0"},{"type":"function","title":"Lux.Config.hyperliquid_api_url/0","doc":"Gets the configured Hyperliquid API URL.","ref":"Lux.Config.html#hyperliquid_api_url/0"},{"type":"function","title":"Lux.Config.openai_api_key/0","doc":"Gets the OpenAI API key from configuration.\nRaises if the key is not configured.","ref":"Lux.Config.html#openai_api_key/0"},{"type":"function","title":"Lux.Config.openweather_api_key/0","doc":"","ref":"Lux.Config.html#openweather_api_key/0"},{"type":"function","title":"Lux.Config.resolve/1","doc":"","ref":"Lux.Config.html#resolve/1"},{"type":"function","title":"Lux.Config.runtime/3","doc":"","ref":"Lux.Config.html#runtime/3"},{"type":"function","title":"Lux.Config.transpose_api_key/0","doc":"","ref":"Lux.Config.html#transpose_api_key/0"},{"type":"function","title":"Lux.Config.wallet_address/0","doc":"Retrieves the wallet address","ref":"Lux.Config.html#wallet_address/0"},{"type":"behaviour","title":"Lux.LLM","doc":"A module for interacting with LLMs. Defines the behaviours for LLMs and provides a default implementation.","ref":"Lux.LLM.html"},{"type":"function","title":"Lux.LLM.call/3","doc":"","ref":"Lux.LLM.html#call/3"},{"type":"callback","title":"Lux.LLM.call/3","doc":"","ref":"Lux.LLM.html#c:call/3"},{"type":"type","title":"Lux.LLM.options/0","doc":"","ref":"Lux.LLM.html#t:options/0"},{"type":"type","title":"Lux.LLM.prompt/0","doc":"","ref":"Lux.LLM.html#t:prompt/0"},{"type":"type","title":"Lux.LLM.tools/0","doc":"","ref":"Lux.LLM.html#t:tools/0"},{"type":"module","title":"Lux.LLM.OpenAI","doc":"OpenAI LLM implementation that supports passing Beams, Prisms, and Lenses as tools.","ref":"Lux.LLM.OpenAI.html"},{"type":"function","title":"Lux.LLM.OpenAI.execute_tool/3","doc":"","ref":"Lux.LLM.OpenAI.html#execute_tool/3"},{"type":"function","title":"Lux.LLM.OpenAI.execute_tool_call/1","doc":"","ref":"Lux.LLM.OpenAI.html#execute_tool_call/1"},{"type":"function","title":"Lux.LLM.OpenAI.execute_tool_calls/1","doc":"","ref":"Lux.LLM.OpenAI.html#execute_tool_calls/1"},{"type":"function","title":"Lux.LLM.OpenAI.parse_content/1","doc":"","ref":"Lux.LLM.OpenAI.html#parse_content/1"},{"type":"function","title":"Lux.LLM.OpenAI.tool_to_function/1","doc":"","ref":"Lux.LLM.OpenAI.html#tool_to_function/1"},{"type":"module","title":"Lux.LLM.OpenAI.Config","doc":"Configuration module for OpenAI.","ref":"Lux.LLM.OpenAI.Config.html"},{"type":"type","title":"Lux.LLM.OpenAI.Config.t/0","doc":"","ref":"Lux.LLM.OpenAI.Config.html#t:t/0"},{"type":"module","title":"Lux.LLM.Response","doc":"A response from an LLM.","ref":"Lux.LLM.Response.html"},{"type":"type","title":"Lux.LLM.Response.t/0","doc":"","ref":"Lux.LLM.Response.html#t:t/0"},{"type":"module","title":"Lux.LLM.ResponseSignal","doc":"A SignalSchema to represent an LLM response.\nIt contains the content, model,tool calls, and finish reason.\nAny other data should be stored in the Signal's metadata field.","ref":"Lux.LLM.ResponseSignal.html"},{"type":"function","title":"Lux.LLM.ResponseSignal.id/0","doc":"","ref":"Lux.LLM.ResponseSignal.html#id/0"},{"type":"function","title":"Lux.LLM.ResponseSignal.name/0","doc":"","ref":"Lux.LLM.ResponseSignal.html#name/0"},{"type":"function","title":"Lux.LLM.ResponseSignal.schema/0","doc":"","ref":"Lux.LLM.ResponseSignal.html#schema/0"},{"type":"function","title":"Lux.LLM.ResponseSignal.schema_id/0","doc":"","ref":"Lux.LLM.ResponseSignal.html#schema_id/0"},{"type":"type","title":"Lux.LLM.ResponseSignal.signal/0","doc":"A signal with a schema_id set to this module.","ref":"Lux.LLM.ResponseSignal.html#t:signal/0"},{"type":"function","title":"Lux.LLM.ResponseSignal.validate/1","doc":"","ref":"Lux.LLM.ResponseSignal.html#validate/1"},{"type":"function","title":"Lux.LLM.ResponseSignal.view/0","doc":"","ref":"Lux.LLM.ResponseSignal.html#view/0"},{"type":"behaviour","title":"Lux.Lens","doc":"Lenses are used to load data from a source and return it to the calling agent.","ref":"Lux.Lens.html"},{"type":"behaviour","title":"Example - Lux.Lens","doc":"defmodule MyApp.Lenses.WeatherLens do\n      use Lux.Lens,\n          name: \"OpenWeather API\",\n          description: \"Fetches weather data from OpenWeather\",\n          url: \"https://api.openweathermap.org/data/2.5/weather\",\n          method: :get,\n          schema: %{\n            type: :object,\n            properties: %{\n              q: %{\n                type: :string,\n                description: \"City name\"\n              },\n              units: %{\n                type: :string,\n                description: \"Temperature units. For temperature in Fahrenheit use units=imperial and for temperature in Celsius use units=metric\",\n                enum: [\"metric\", \"imperial\"]\n              },\n              appid: %{type: :string, description: \"API key\"}\n            },\n            required: [\"q\", \"appid\"]\n          }\n\n      # Optional: Define a custom after_focus function\n      def after_focus(%{\"main\" => %{\"temp\" => temp}} = body) do\n        {:ok, %{temperature: temp, raw_data: body}}\n      end\n\n      def after_focus(%{\"error\" => error}) do\n        {:error, error}\n      end\n    end","ref":"Lux.Lens.html#module-example"},{"type":"callback","title":"Lux.Lens.after_focus/1","doc":"","ref":"Lux.Lens.html#c:after_focus/1"},{"type":"function","title":"Lux.Lens.authenticate/1","doc":"","ref":"Lux.Lens.html#authenticate/1"},{"type":"function","title":"Lux.Lens.focus/2","doc":"","ref":"Lux.Lens.html#focus/2"},{"type":"function","title":"Lux.Lens.new/1","doc":"","ref":"Lux.Lens.html#new/1"},{"type":"type","title":"Lux.Lens.nullable/1","doc":"An optional type of a type `t` is a type that can be either the type `t` or `nil`.","ref":"Lux.Lens.html#t:nullable/1"},{"type":"type","title":"Lux.Lens.t/0","doc":"","ref":"Lux.Lens.html#t:t/0"},{"type":"module","title":"Lux.Lenses.TransposePriceLens","doc":"Lens for fetching token prices from the Transpose API.","ref":"Lux.Lenses.TransposePriceLens.html"},{"type":"module","title":"Example - Lux.Lenses.TransposePriceLens","doc":"```\nalias Lux.Lenses.TransposePriceLens\n\n# Single token\nTransposePriceLens.focus(%{\n  token_addresses: [\"0x1f9840a85d5af5bf1d1762f925bdaddc4201f984\"],  # UNI token\n  timestamp: DateTime.utc_now() |> DateTime.to_iso8601()\n})\n\n# Multiple tokens\nTransposePriceLens.focus(%{\n  token_addresses: [\n    \"0x1f9840a85d5af5bf1d1762f925bdaddc4201f984\",  # UNI\n    \"0x7fc66500c84a76ad7e9c93437bfc5ac33e2ddae9\"   # AAVE\n  ],\n  timestamp: DateTime.utc_now() |> DateTime.to_iso8601()\n})\n```","ref":"Lux.Lenses.TransposePriceLens.html#module-example"},{"type":"function","title":"Lux.Lenses.TransposePriceLens.add_api_key/1","doc":"","ref":"Lux.Lenses.TransposePriceLens.html#add_api_key/1"},{"type":"function","title":"Lux.Lenses.TransposePriceLens.after_focus/1","doc":"Transforms the API response into a more usable format.","ref":"Lux.Lenses.TransposePriceLens.html#after_focus/1"},{"type":"function","title":"Examples - Lux.Lenses.TransposePriceLens.after_focus/1","doc":"iex> after_focus(%{\"prices\" => [%{\"price\" => 5.20, \"token_address\" => \"0x...\"}]})\n    {:ok, %{prices: [%{price: 5.20, token_address: \"0x...\", ...}]}}\n\n    iex> after_focus(%{\"error\" => \"Invalid API key\"})\n    {:error, \"Invalid API key\"}","ref":"Lux.Lenses.TransposePriceLens.html#after_focus/1-examples"},{"type":"function","title":"Lux.Lenses.TransposePriceLens.before_focus/1","doc":"","ref":"Lux.Lenses.TransposePriceLens.html#before_focus/1"},{"type":"function","title":"Lux.Lenses.TransposePriceLens.focus/2","doc":"Focuses the lens with the given input.","ref":"Lux.Lenses.TransposePriceLens.html#focus/2"},{"type":"function","title":"Lux.Lenses.TransposePriceLens.view/0","doc":"Returns the Lens struct for this module.","ref":"Lux.Lenses.TransposePriceLens.html#view/0"},{"type":"behaviour","title":"Lux.Memory","doc":"Core memory functionality for Lux agents and components.\n\nThere are two ways to use memory:\n\n1. Named memories (defined as modules):\n    defmodule MyAgentMemory do\n      use Lux.Memory,\n        backend: Lux.Memory.ETS,\n        name: :my_agent_memory\n    end\n\n2. Dynamic memories:\n    {:ok, memory} = Lux.Memory.initialize(backend: Lux.Memory.ETS)","ref":"Lux.Memory.html"},{"type":"function","title":"Lux.Memory.add/4","doc":"","ref":"Lux.Memory.html#add/4"},{"type":"callback","title":"Lux.Memory.add/4","doc":"","ref":"Lux.Memory.html#c:add/4"},{"type":"type","title":"Lux.Memory.backend_module/0","doc":"","ref":"Lux.Memory.html#t:backend_module/0"},{"type":"function","title":"Lux.Memory.initialize/1","doc":"","ref":"Lux.Memory.html#initialize/1"},{"type":"callback","title":"Lux.Memory.initialize/1","doc":"","ref":"Lux.Memory.html#c:initialize/1"},{"type":"type","title":"Lux.Memory.memory_entry/0","doc":"","ref":"Lux.Memory.html#t:memory_entry/0"},{"type":"type","title":"Lux.Memory.memory_opts/0","doc":"","ref":"Lux.Memory.html#t:memory_opts/0"},{"type":"type","title":"Lux.Memory.memory_ref/0","doc":"","ref":"Lux.Memory.html#t:memory_ref/0"},{"type":"type","title":"Lux.Memory.memory_type/0","doc":"","ref":"Lux.Memory.html#t:memory_type/0"},{"type":"function","title":"Lux.Memory.recent/2","doc":"","ref":"Lux.Memory.html#recent/2"},{"type":"callback","title":"Lux.Memory.recent/2","doc":"","ref":"Lux.Memory.html#c:recent/2"},{"type":"function","title":"Lux.Memory.search/2","doc":"","ref":"Lux.Memory.html#search/2"},{"type":"callback","title":"Lux.Memory.search/2","doc":"","ref":"Lux.Memory.html#c:search/2"},{"type":"function","title":"Lux.Memory.window/3","doc":"","ref":"Lux.Memory.html#window/3"},{"type":"callback","title":"Lux.Memory.window/3","doc":"","ref":"Lux.Memory.html#c:window/3"},{"type":"module","title":"Lux.Memory.SimpleMemory","doc":"A simple memory implementation using GenServer and ETS.\nProvides efficient chronological storage and retrieval of memory entries.","ref":"Lux.Memory.SimpleMemory.html"},{"type":"function","title":"Lux.Memory.SimpleMemory.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Memory.SimpleMemory.html#child_spec/1"},{"type":"module","title":"Lux.NodeJS","doc":"Provides functions for executing Node.js code with variable bindings.\n\nThe ~JS sigil is used to write Node.js code directly in Elixir files.\nIn the Node.js code, you have to export a function named `main` that takes\nan object as an argument and returns a value.\n\n    export const main = ({x, y}) => x + y","ref":"Lux.NodeJS.html"},{"type":"module","title":"Examples - Lux.NodeJS","doc":"iex> require Lux.NodeJS\n    iex> Lux.NodeJS.nodejs variables: %{x: 40, y: 2} do\n    ...>   ~JS'''\n    ...>   export const main = ({x, y}) => x + y\n    ...>   '''\n    ...> end\n    42","ref":"Lux.NodeJS.html#module-examples"},{"type":"function","title":"Lux.NodeJS.child_spec/1","doc":"","ref":"Lux.NodeJS.html#child_spec/1"},{"type":"function","title":"Lux.NodeJS.eval/2","doc":"Evaluates Node.js code with optional variable bindings and other options.","ref":"Lux.NodeJS.html#eval/2"},{"type":"function","title":"Options - Lux.NodeJS.eval/2","doc":"* `:variables` - A map of variables to bind in the Node.js context\n  * `:timeout` - Timeout in milliseconds for Node.js execution","ref":"Lux.NodeJS.html#eval/2-options"},{"type":"function","title":"Examples - Lux.NodeJS.eval/2","doc":"iex> Lux.NodeJS.eval(\"export const main = ({x}) => x * 2\", variables: %{x: 21})\n    {:ok, 42}\n\n    iex> Lux.NodeJS.eval(\"export const main = () => os.getenv('TEST')\", env: %{\"TEST\" => \"value\"})\n    {:ok, \"value\"}","ref":"Lux.NodeJS.html#eval/2-examples"},{"type":"function","title":"Lux.NodeJS.eval!/2","doc":"Same as `eval/2`, but raises an error.","ref":"Lux.NodeJS.html#eval!/2"},{"type":"type","title":"Lux.NodeJS.eval_option/0","doc":"","ref":"Lux.NodeJS.html#t:eval_option/0"},{"type":"type","title":"Lux.NodeJS.eval_options/0","doc":"","ref":"Lux.NodeJS.html#t:eval_options/0"},{"type":"function","title":"Lux.NodeJS.import_package/2","doc":"Attempts to import a Node.js package.\nCurrently, it will modify `priv/node/package.json` and `priv/node/package_lock.json` files.","ref":"Lux.NodeJS.html#import_package/2"},{"type":"function","title":"Options - Lux.NodeJS.import_package/2","doc":"* `:update_lock_file` - Whether to update the lock file after importing the package (default: true)\n  * `:timeout` - Timeout in milliseconds for Node.js execution","ref":"Lux.NodeJS.html#import_package/2-options"},{"type":"type","title":"Lux.NodeJS.import_result/0","doc":"","ref":"Lux.NodeJS.html#t:import_result/0"},{"type":"function","title":"Lux.NodeJS.module_path/0","doc":"Returns a main module path for the Node.js.","ref":"Lux.NodeJS.html#module_path/0"},{"type":"macro","title":"Lux.NodeJS.nodejs/2","doc":"A macro for executing Node.js code with variable bindings.\nNode.js code should be wrapped in a sigil ~JS to bypass Elixir syntax checking.","ref":"Lux.NodeJS.html#nodejs/2"},{"type":"behaviour","title":"Lux.Prism","doc":"Modular, composable units of functionality for defining actions.\n\nPrisms are used to define actions that can be executed by agents.","ref":"Lux.Prism.html"},{"type":"behaviour","title":"Example - Lux.Prism","doc":"defmodule MyApp.Prisms.WeatherPrism do\n      use Lux.Prism,\n        name: \"Weather Data\",\n        description: \"Fetches weather data for a given location\",\n        input_schema: %{\n          type: :object,\n          properties: %{\n            location: %{type: :string, description: \"City name\"},\n            units: %{type: :string, description: \"Temperature units (C/F)\"}\n          }\n        }\n\n      def handler(input, _ctx) do\n        # Implementation\n      end\n    end","ref":"Lux.Prism.html#module-example"},{"type":"type","title":"Lux.Prism.handler/0","doc":"A handler is a function or a module that handles the data.","ref":"Lux.Prism.html#t:handler/0"},{"type":"callback","title":"Lux.Prism.handler/2","doc":"A handler is the function that will be called when the prism is executed.","ref":"Lux.Prism.html#c:handler/2"},{"type":"function","title":"Lux.Prism.new/1","doc":"Creates a new prism from a map or keyword list.","ref":"Lux.Prism.html#new/1"},{"type":"type","title":"Lux.Prism.nullable/1","doc":"An optional type of a type `t` is a type that can be either the type `t` or `nil`.","ref":"Lux.Prism.html#t:nullable/1"},{"type":"function","title":"Lux.Prism.resolve_schema/1","doc":"Resolves a schema reference to its actual schema definition.\nIf the schema is a module that implements Lux.SignalSchema, returns its schema.\nOtherwise, returns the schema as is.","ref":"Lux.Prism.html#resolve_schema/1"},{"type":"function","title":"Lux.Prism.run/3","doc":"","ref":"Lux.Prism.html#run/3"},{"type":"function","title":"Lux.Prism.run/4","doc":"","ref":"Lux.Prism.html#run/4"},{"type":"type","title":"Lux.Prism.schema/0","doc":"A schema is either a map of key-value pairs that describe the structure of the data,\nor a module that implements the Lux.SignalSchema behaviour.","ref":"Lux.Prism.html#t:schema/0"},{"type":"type","title":"Lux.Prism.t/0","doc":"","ref":"Lux.Prism.html#t:t/0"},{"type":"type","title":"Lux.Prism.validator/0","doc":"A validator is a function or a module that validates the data.","ref":"Lux.Prism.html#t:validator/0"},{"type":"function","title":"Lux.Prism.view/1","doc":"","ref":"Lux.Prism.html#view/1"},{"type":"function","title":"Lux.Prism.view/2","doc":"","ref":"Lux.Prism.html#view/2"},{"type":"module","title":"Lux.Prisms.AgenticCompany.CreateCompanyPrism","doc":"A prism that creates a new company using the AgenticCompanyFactory contract.","ref":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.html"},{"type":"module","title":"Example - Lux.Prisms.AgenticCompany.CreateCompanyPrism","doc":"iex> Lux.Prisms.AgenticCompany.CreateCompanyPrism.run(%{\n    ...>   company_name: \"Some Test Company\",\n    ...>   agent_token: \"0x0000000000000000000000000000000000000000\",  # zero address for no token\n    ...>   ceo_wallet_address: \"0x1234...\"  # optional, defaults to WALLET_ADDRESS set in the environment variable.\n    ...> })\n    {:ok, %{\n      company_address: \"0x5678...\"  # The address of the newly created company contract\n    }}","ref":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.handler/2","doc":"","ref":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.run/2","doc":"","ref":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.AgenticCompany.CreateCompanyPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.AgenticCompany.CreateJobPrism","doc":"A prism that creates a new job in an existing AgenticCompany contract.","ref":"Lux.Prisms.AgenticCompany.CreateJobPrism.html"},{"type":"module","title":"Example - Lux.Prisms.AgenticCompany.CreateJobPrism","doc":"iex> Lux.Prisms.AgenticCompany.CreateJobPrism.run(%{\n    ...>   company_address: \"0xdf610daa6acc8c7ca4b68dfd2a7bed96bafeee34\",\n    ...>   job_name: \"Content Writer\",\n    ...>   ceo_wallet_address: \"0x1234...\"  # optional, defaults to WALLET_ADDRESS set in the environment variable\n    ...> })\n    {:ok, %{\n      job_id: \"0xabcd...\"  # The ID of the newly created job\n    }}","ref":"Lux.Prisms.AgenticCompany.CreateJobPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateJobPrism.handler/2","doc":"","ref":"Lux.Prisms.AgenticCompany.CreateJobPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateJobPrism.run/2","doc":"","ref":"Lux.Prisms.AgenticCompany.CreateJobPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateJobPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.AgenticCompany.CreateJobPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.AgenticCompany.CreateJobsPrism","doc":"A prism that creates multiple jobs in a company in parallel.\n\nThis prism takes a list of job configurations and creates them all in the specified company.\nIf any job creation fails, the entire operation is considered failed.","ref":"Lux.Prisms.AgenticCompany.CreateJobsPrism.html"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateJobsPrism.handler/2","doc":"","ref":"Lux.Prisms.AgenticCompany.CreateJobsPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateJobsPrism.run/2","doc":"","ref":"Lux.Prisms.AgenticCompany.CreateJobsPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.AgenticCompany.CreateJobsPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.AgenticCompany.CreateJobsPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.EthBalancePrism","doc":"A simple prism that checks an Ethereum account's balance.","ref":"Lux.Prisms.EthBalancePrism.html"},{"type":"module","title":"Examples - Lux.Prisms.EthBalancePrism","doc":"iex> Lux.Prisms.EthBalancePrism.run(%{\n    ...>   address: \"0xd3cda913deb6f67967b99d67acdfa1712c293601\",\n    ...>   network: \"mainnet\"\n    ...> })\n    {:ok, %{\n      balance_eth: 1.5,\n      balance_wei: \"1500000000000000000\",\n      network: \"mainnet\"\n    }}","ref":"Lux.Prisms.EthBalancePrism.html#module-examples"},{"type":"function","title":"Lux.Prisms.EthBalancePrism.handler/2","doc":"","ref":"Lux.Prisms.EthBalancePrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.EthBalancePrism.run/2","doc":"","ref":"Lux.Prisms.EthBalancePrism.html#run/2"},{"type":"function","title":"Lux.Prisms.EthBalancePrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.EthBalancePrism.html#view/0"},{"type":"module","title":"Lux.Prisms.EthBlockNumPrism","doc":"A simple prism that checks the current Ethereum block number.","ref":"Lux.Prisms.EthBlockNumPrism.html"},{"type":"module","title":"Examples - Lux.Prisms.EthBlockNumPrism","doc":"iex> Lux.Prisms.EthBlockNumPrism.run(%{\n    ...>   network: \"mainnet\"\n    ...> })\n    {:ok, %{\n      block_number: 123456,\n      network: \"mainnet\"\n    }}","ref":"Lux.Prisms.EthBlockNumPrism.html#module-examples"},{"type":"function","title":"Lux.Prisms.EthBlockNumPrism.handler/2","doc":"","ref":"Lux.Prisms.EthBlockNumPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.EthBlockNumPrism.run/2","doc":"","ref":"Lux.Prisms.EthBlockNumPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.EthBlockNumPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.EthBlockNumPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.HandleChat","doc":"A prism that handles chat messages between agents.\nIt processes incoming chat messages and generates appropriate responses.","ref":"Lux.Prisms.HandleChat.html"},{"type":"function","title":"Lux.Prisms.HandleChat.handler/2","doc":"Handles an incoming chat message and generates a response.","ref":"Lux.Prisms.HandleChat.html#handler/2"},{"type":"function","title":"Lux.Prisms.HandleChat.run/2","doc":"","ref":"Lux.Prisms.HandleChat.html#run/2"},{"type":"function","title":"Lux.Prisms.HandleChat.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.HandleChat.html#view/0"},{"type":"module","title":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism","doc":"A prism that executes orders on the Hyperliquid exchange.","ref":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.html"},{"type":"module","title":"Example - Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism","doc":"# Limit order\n    iex> Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.run(%{\n    ...>   coin: \"ETH\",\n    ...>   is_buy: true,\n    ...>   sz: 0.0051,\n    ...>   limit_px: 2800.0,\n    ...>   order_type: %{limit: %{tif: \"Gtc\"}},\n    ...>   reduce_only: false,\n    ...>   vault_address: \"0x0403369c02199a0cb827f4d6492927e9fa5668d5\"\n    ...> })\n    {:ok,\n     %{\n       \"status\" => \"success\",\n       \"order_result\" => %{\n         # ... response from Hyperliquid\n       }\n     }}\n\n    # Trigger order (Stop Loss)\n    iex> Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.run(%{\n    ...>   coin: \"ETH\",\n    ...>   is_buy: false,\n    ...>   sz: 0.1,\n    ...>   limit_px: 2800.0,\n    ...>   order_type: %{\n    ...>     trigger: %{\n    ...>       triggerPx: 2900.0,\n    ...>       isMarket: true,\n    ...>       tpsl: \"sl\"\n    ...>     }\n    ...>   },\n    ...>   reduce_only: true\n    ...> })\n\nThe prism reads authentication details from configuration:\n- :hyperliquid_private_key - Ethereum account private key for authentication\n- :hyperliquid_address - (Optional) Ethereum account address","ref":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.handler/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.run/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.Hyperliquid.HyperliquidExecuteOrderPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism","doc":"A prism that fetches open orders from the Hyperliquid exchange.","ref":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.html"},{"type":"module","title":"Example - Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism","doc":"# Get open orders for a specific address\n    iex> Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.run(%{\n    ...>   address: \"0x0403369c02199a0cb827f4d6492927e9fa5668d5\"\n    ...> })\n    {:ok,\n     %{\n       \"status\" => \"success\",\n       \"open_orders\" => [\n         %{\n           \"coin\" => \"ETH\",\n           \"oid\" => 123456,\n           \"sz\" => \"0.1\",\n           \"limit_px\" => \"2800.0\",\n           \"order_type\" => %{\n             \"limit\" => %{\n               \"tif\" => \"Gtc\"\n             }\n           },\n           \"side\" => \"B\",\n           \"timestamp\" => 1678901234567\n         }\n       ]\n     }}\n\nThe prism reads authentication details from configuration:\n- :hyperliquid_private_key - Ethereum account private key for authentication","ref":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.handler/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.run/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.Hyperliquid.HyperliquidOpenOrdersPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism","doc":"A prism that calculates risk metrics for a proposed Hyperliquid trade.","ref":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.html"},{"type":"module","title":"Example - Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism","doc":"iex> Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.run(%{\n    ...>   portfolio: hyperliquid_portfolio,\n    ...>   market_data: hyperliquid_market_data,\n    ...>   proposed_trade: %{\n    ...>     coin: \"ETH\",\n    ...>     sz: 0.1,\n    ...>     limit_px: 2800.0,\n    ...>     is_buy: true\n    ...>   }\n    ...> })\n    {:ok, %{\n      position_size_ratio: 0.15,\n      leverage: 2.0,\n      portfolio_concentration: 0.25,\n      liquidation_risk: 0.05,\n      unrealized_pnl: 0.1\n    }}","ref":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.handler/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.run/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.Hyperliquid.HyperliquidRiskAssessmentPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism","doc":"A prism that fetches token price data from the Hyperliquid API.","ref":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.html"},{"type":"module","title":"Example - Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism","doc":"iex> Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.run(%{})\n    {:ok, %{\n      prices: %{\n        \"BTC\" => %{\n          \"funding\" => \"0.0000125\",\n          \"markPx\" => \"104050.0\",\n          # ...other fields\n        },\n        # ...other tokens\n      }\n    }}\n\nThe prism reads authentication details from configuration:\n- :hyperliquid_private_key - Ethereum account private key for authentication\n- :hyperliquid_address - (Optional) Ethereum account address","ref":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.handler/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.run/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.Hyperliquid.HyperliquidTokenInfoPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism","doc":"A prism that fetches user state information from the Hyperliquid exchange.","ref":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.html"},{"type":"module","title":"Example - Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism","doc":"# Get state for a specific address\n    iex> Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.run(%{\n    ...>   address: \"0x0403369c02199a0cb827f4d6492927e9fa5668d5\"\n    ...> })\n    {:ok,\n     %{\n       \"status\" => \"success\",\n       \"user_state\" => %{\n         \"assetPositions\" => [\n           %{\n             \"coin\" => \"ETH\",\n             \"position\" => %{\n               \"entryPx\" => \"2800.0\",\n               \"leverage\" => \"2.0\",\n               \"liquidationPx\" => \"1400.0\",\n               \"marginUsed\" => \"1000.0\",\n               \"positionValue\" => \"2000.0\",\n               \"returnOnEquity\" => \"0.15\",\n               \"size\" => \"1.0\",\n               # ... other position fields\n             }\n           }\n         ],\n         \"crossMaintenanceMarginRatio\" => \"0.0625\",\n         \"crossMarginSummary\" => %{\n           \"accountValue\" => \"10000.0\",\n           \"totalMarginUsed\" => \"1000.0\",\n           \"totalNtlPos\" => \"2000.0\",\n           \"totalRawUsd\" => \"10000.0\"\n         }\n         # ... other user state fields\n       }\n     }}\n\nThe prism reads authentication details from configuration:\n- :hyperliquid_private_key - Ethereum account private key for authentication","ref":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.html#module-example"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.handler/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.run/2","doc":"","ref":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.html#run/2"},{"type":"function","title":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.Hyperliquid.HyperliquidUserStatePrism.html#view/0"},{"type":"module","title":"Lux.Prisms.HyperliquidCancelOrderPrism","doc":"A prism that cancels a specific order on the Hyperliquid exchange.","ref":"Lux.Prisms.HyperliquidCancelOrderPrism.html"},{"type":"module","title":"Example - Lux.Prisms.HyperliquidCancelOrderPrism","doc":"iex> Lux.Prisms.HyperliquidCancelOrderPrism.run(%{\n    ...>   coin: \"ETH\",\n    ...>   order_id: 123456,\n    ...>   vault_address: \"0x0403369c02199a0cb827f4d6492927e9fa5668d5\" # Optional\n    ...> })\n    {:ok,\n     %{\n       status: \"success\",\n       cancelled_order: %{\n         \"coin\" => \"ETH\",\n         \"order_id\" => 123456,\n         \"result\" => %{\n            # ... cancellation response from Hyperliquid\n         }\n       }\n    }}\n\nThe prism reads authentication details from configuration:\n- :hyperliquid_private_key - Ethereum account private key for authentication\n- :hyperliquid_address - (Optional) Ethereum account address","ref":"Lux.Prisms.HyperliquidCancelOrderPrism.html#module-example"},{"type":"function","title":"Lux.Prisms.HyperliquidCancelOrderPrism.handler/2","doc":"","ref":"Lux.Prisms.HyperliquidCancelOrderPrism.html#handler/2"},{"type":"function","title":"Lux.Prisms.HyperliquidCancelOrderPrism.run/2","doc":"","ref":"Lux.Prisms.HyperliquidCancelOrderPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.HyperliquidCancelOrderPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.HyperliquidCancelOrderPrism.html#view/0"},{"type":"module","title":"Lux.Prisms.NoOp","doc":"A no-operation prism that simply returns its input or an empty map if no input.\nUsed as a placeholder in conditional branches where no action is needed.","ref":"Lux.Prisms.NoOp.html"},{"type":"module","title":"Example - Lux.Prisms.NoOp","doc":"iex> Lux.Prisms.NoOp.run(%{value: 42})\n    {:ok, %{value: 42}}\n\n    iex> Lux.Prisms.NoOp.run(%{})\n    {:ok, %{}}","ref":"Lux.Prisms.NoOp.html#module-example"},{"type":"function","title":"Lux.Prisms.NoOp.handler/2","doc":"","ref":"Lux.Prisms.NoOp.html#handler/2"},{"type":"function","title":"Lux.Prisms.NoOp.run/2","doc":"","ref":"Lux.Prisms.NoOp.html#run/2"},{"type":"function","title":"Lux.Prisms.NoOp.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.NoOp.html#view/0"},{"type":"module","title":"Lux.Prisms.SentimentAnalysisPrism","doc":"A prism that performs sentiment analysis on text using Python's NLTK library.\n\nThis prism uses NLTK's VADER (Valence Aware Dictionary and sEntiment Reasoner) sentiment analyzer,\nwhich is specifically attuned to sentiments expressed in social media. It's able to handle:\n\n- Conventional text\n- Slang and abbreviations\n- Emojis and emoticons\n- Emphasis through capitalization and punctuation","ref":"Lux.Prisms.SentimentAnalysisPrism.html"},{"type":"module","title":"Examples - Lux.Prisms.SentimentAnalysisPrism","doc":"iex> Lux.Prisms.SentimentAnalysisPrism.run(%{\n    ...>   text: \"Great product, I love it!\",\n    ...>   language: \"en\"\n    ...> })\n    {:ok, %{\n      sentiment: \"positive\",\n      confidence: 0.8402,\n      details: %{\n        \"pos\" => 0.814,\n        \"neg\" => 0.0,\n        \"neu\" => 0.186,\n        \"compound\" => 0.8402\n      }\n    }}","ref":"Lux.Prisms.SentimentAnalysisPrism.html#module-examples"},{"type":"function","title":"Lux.Prisms.SentimentAnalysisPrism.handler/2","doc":"Analyzes the sentiment of the given text.","ref":"Lux.Prisms.SentimentAnalysisPrism.html#handler/2"},{"type":"function","title":"Parameters - Lux.Prisms.SentimentAnalysisPrism.handler/2","doc":"* `text` - The text to analyze\n  * `language` - The language of the text (currently only \"en\" is supported)","ref":"Lux.Prisms.SentimentAnalysisPrism.html#handler/2-parameters"},{"type":"function","title":"Returns - Lux.Prisms.SentimentAnalysisPrism.handler/2","doc":"* `{:ok, result}` - Where result contains sentiment analysis\n  * `{:error, reason}` - If analysis fails","ref":"Lux.Prisms.SentimentAnalysisPrism.html#handler/2-returns"},{"type":"function","title":"Lux.Prisms.SentimentAnalysisPrism.run/2","doc":"","ref":"Lux.Prisms.SentimentAnalysisPrism.html#run/2"},{"type":"function","title":"Lux.Prisms.SentimentAnalysisPrism.view/0","doc":"Returns the Prism struct for this module.","ref":"Lux.Prisms.SentimentAnalysisPrism.html#view/0"},{"type":"module","title":"Lux.Python","doc":"Provides functions for executing Python code with variable bindings.\n\nThe ~PY sigil is used to write Python code directly in Elixir files.\nThe content inside ~PY sigils is preserved by the Elixir formatter\nto maintain proper Python indentation and formatting.","ref":"Lux.Python.html"},{"type":"module","title":"Examples - Lux.Python","doc":"iex> require Lux.Python\n    iex> Lux.Python.python variables: %{x: 40, y: 2} do\n    ...>   ~PY'''\n    ...>   x + y\n    ...>   '''\n    ...> end\n    42","ref":"Lux.Python.html#module-examples"},{"type":"function","title":"Lux.Python.check_package/1","doc":"Checks if a Python package is available and returns its version information.","ref":"Lux.Python.html#check_package/1"},{"type":"function","title":"Examples - Lux.Python.check_package/1","doc":"iex> Lux.Python.check_package(\"pytest\")\n    {:ok, %{available: true, version: \"7.4.0\"}}\n\n    iex> Lux.Python.check_package(\"nonexistent_package\")\n    {:ok, %{available: false, version: nil}}","ref":"Lux.Python.html#check_package/1-examples"},{"type":"function","title":"Lux.Python.eval/2","doc":"Evaluates Python code with optional variable bindings and other options.\nIf `code_or_path` is a file path, it reads the file content and evaluates it.","ref":"Lux.Python.html#eval/2"},{"type":"function","title":"Options - Lux.Python.eval/2","doc":"* `:variables` - A map of variables to bind in the Python context\n  * `:timeout` - Timeout in milliseconds for Python execution","ref":"Lux.Python.html#eval/2-options"},{"type":"function","title":"Examples - Lux.Python.eval/2","doc":"iex> Lux.Python.eval(\"x * 2\", variables: %{x: 21})\n    {:ok, 42}\n\n    iex> Lux.Python.eval(\"os.getenv('TEST')\", env: %{\"TEST\" => \"value\"})\n    {:ok, \"value\"}","ref":"Lux.Python.html#eval/2-examples"},{"type":"function","title":"Lux.Python.eval!/2","doc":"Same as `eval/2` but raises on error.","ref":"Lux.Python.html#eval!/2"},{"type":"function","title":"Examples - Lux.Python.eval!/2","doc":"iex> Lux.Python.eval!(\"x + y\", variables: %{x: 1, y: 2})\n    3\n\n    iex> Lux.Python.eval!(\"undefined_var\")\n    ** (RuntimeError) Python execution error: NameError: name 'undefined_var' is not defined","ref":"Lux.Python.html#eval!/2-examples"},{"type":"type","title":"Lux.Python.eval_option/0","doc":"","ref":"Lux.Python.html#t:eval_option/0"},{"type":"type","title":"Lux.Python.eval_options/0","doc":"","ref":"Lux.Python.html#t:eval_options/0"},{"type":"function","title":"Lux.Python.import_package/1","doc":"Attempts to import a Python package.\n\nReturns information about whether the import was successful.\nIf the import fails, includes the error message.","ref":"Lux.Python.html#import_package/1"},{"type":"function","title":"Examples - Lux.Python.import_package/1","doc":"iex> Lux.Python.import_package(\"json\")\n    {:ok, %{success: true, error: nil}}\n\n    iex> Lux.Python.import_package(\"nonexistent_package\")\n    {:ok, %{success: false, error: \"No module named 'nonexistent_package'\"}}","ref":"Lux.Python.html#import_package/1-examples"},{"type":"type","title":"Lux.Python.import_result/0","doc":"","ref":"Lux.Python.html#t:import_result/0"},{"type":"function","title":"Lux.Python.list_packages/0","doc":"Lists all available Python packages and their versions.\n\nReturns a map where keys are package names and values are version strings.","ref":"Lux.Python.html#list_packages/0"},{"type":"function","title":"Examples - Lux.Python.list_packages/0","doc":"iex> Lux.Python.list_packages()\n    %{\n      \"pytest\" => \"7.4.0\",\n      \"requests\" => \"2.31.0\"\n    }","ref":"Lux.Python.html#list_packages/0-examples"},{"type":"function","title":"Lux.Python.module_path/0","doc":"Returns a main module path for the Python.","ref":"Lux.Python.html#module_path/0"},{"type":"function","title":"Lux.Python.module_path/1","doc":"Returns dependant modules path for the Python.\nReturns nil if it is not ready.","ref":"Lux.Python.html#module_path/1"},{"type":"type","title":"Lux.Python.package_info/0","doc":"","ref":"Lux.Python.html#t:package_info/0"},{"type":"macro","title":"Lux.Python.python/2","doc":"A macro that enables writing Python code directly in Elixir with variable bindings.\nPython code must be wrapped in ~PY sigil to bypass Elixir syntax checking.","ref":"Lux.Python.html#python/2"},{"type":"macro","title":"Options - Lux.Python.python/2","doc":"* `:variables` - A map of variables to bind in the Python context\n  * `:timeout` - Timeout in milliseconds for Python execution","ref":"Lux.Python.html#python/2-options"},{"type":"macro","title":"Examples - Lux.Python.python/2","doc":"iex> require Lux.Python\n    iex> Lux.Python.python variables: %{x: 40, y: 2} do\n    ...>   ~PY'''\n    ...>   x + y\n    ...>   '''\n    ...> end\n    42\n\n    iex> require Lux.Python\n    iex> Lux.Python.python do\n    ...>   ~PY'''\n    ...>   def factorial(n):\n    ...>       if n <= 1:\n    ...>           return 1\n    ...>       return n * factorial(n - 1)\n    ...>   factorial(5)\n    ...>   '''\n    ...> end\n    120","ref":"Lux.Python.html#python/2-examples"},{"type":"module","title":"Lux.Schemas.Companies.ObjectiveSignal","doc":"Schema for objective execution signals used by the CEO.\n\nThis schema defines the structure for:\n1. Objective evaluation requests\n2. Next step determination\n3. Objective status updates and completion","ref":"Lux.Schemas.Companies.ObjectiveSignal.html"},{"type":"function","title":"Lux.Schemas.Companies.ObjectiveSignal.id/0","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#id/0"},{"type":"function","title":"Lux.Schemas.Companies.ObjectiveSignal.name/0","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#name/0"},{"type":"function","title":"Lux.Schemas.Companies.ObjectiveSignal.schema/0","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#schema/0"},{"type":"function","title":"Lux.Schemas.Companies.ObjectiveSignal.schema_id/0","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#schema_id/0"},{"type":"type","title":"Lux.Schemas.Companies.ObjectiveSignal.signal/0","doc":"A signal with a schema_id set to this module.","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#t:signal/0"},{"type":"type","title":"Lux.Schemas.Companies.ObjectiveSignal.t/0","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#t:t/0"},{"type":"function","title":"Lux.Schemas.Companies.ObjectiveSignal.validate/1","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#validate/1"},{"type":"function","title":"Lux.Schemas.Companies.ObjectiveSignal.view/0","doc":"","ref":"Lux.Schemas.Companies.ObjectiveSignal.html#view/0"},{"type":"module","title":"Lux.Schemas.Companies.TaskSignal","doc":"Schema for task-related signals exchanged between agents.\n\nThis schema defines the structure for:\n1. Task assignments from CEO to agents\n2. Task status updates from agents to CEO\n3. Task completion reports","ref":"Lux.Schemas.Companies.TaskSignal.html"},{"type":"function","title":"Lux.Schemas.Companies.TaskSignal.id/0","doc":"","ref":"Lux.Schemas.Companies.TaskSignal.html#id/0"},{"type":"function","title":"Lux.Schemas.Companies.TaskSignal.name/0","doc":"","ref":"Lux.Schemas.Companies.TaskSignal.html#name/0"},{"type":"function","title":"Lux.Schemas.Companies.TaskSignal.schema/0","doc":"","ref":"Lux.Schemas.Companies.TaskSignal.html#schema/0"},{"type":"function","title":"Lux.Schemas.Companies.TaskSignal.schema_id/0","doc":"","ref":"Lux.Schemas.Companies.TaskSignal.html#schema_id/0"},{"type":"type","title":"Lux.Schemas.Companies.TaskSignal.signal/0","doc":"A signal with a schema_id set to this module.","ref":"Lux.Schemas.Companies.TaskSignal.html#t:signal/0"},{"type":"function","title":"Lux.Schemas.Companies.TaskSignal.validate/1","doc":"","ref":"Lux.Schemas.Companies.TaskSignal.html#validate/1"},{"type":"function","title":"Lux.Schemas.Companies.TaskSignal.view/0","doc":"","ref":"Lux.Schemas.Companies.TaskSignal.html#view/0"},{"type":"module","title":"Lux.Signal","doc":"Represents a signal that can be sent between agents.\nSignals are the primary means of communication between agents.","ref":"Lux.Signal.html"},{"type":"function","title":"Lux.Signal.new/1","doc":"Creates a new signal from a map of attributes.","ref":"Lux.Signal.html#new/1"},{"type":"type","title":"Lux.Signal.t/0","doc":"","ref":"Lux.Signal.html#t:t/0"},{"type":"function","title":"Lux.Signal.validate/2","doc":"Validates a signal against a signal schema.","ref":"Lux.Signal.html#validate/2"},{"type":"module","title":"Lux.Signal.Chat","doc":"Defines the schema for chat messages between agents.","ref":"Lux.Signal.Chat.html"},{"type":"function","title":"Lux.Signal.Chat.id/0","doc":"","ref":"Lux.Signal.Chat.html#id/0"},{"type":"function","title":"Lux.Signal.Chat.name/0","doc":"","ref":"Lux.Signal.Chat.html#name/0"},{"type":"function","title":"Lux.Signal.Chat.schema/0","doc":"","ref":"Lux.Signal.Chat.html#schema/0"},{"type":"function","title":"Lux.Signal.Chat.schema_id/0","doc":"","ref":"Lux.Signal.Chat.html#schema_id/0"},{"type":"type","title":"Lux.Signal.Chat.signal/0","doc":"A signal with a schema_id set to this module.","ref":"Lux.Signal.Chat.html#t:signal/0"},{"type":"function","title":"Lux.Signal.Chat.validate/1","doc":"","ref":"Lux.Signal.Chat.html#validate/1"},{"type":"function","title":"Lux.Signal.Chat.view/0","doc":"","ref":"Lux.Signal.Chat.html#view/0"},{"type":"behaviour","title":"Lux.Signal.Router","doc":"Defines the router behavior and provides a clean interface for signal routing.\n\nThe router is responsible for delivering signals between agents and managing\nsubscriptions to signal events. It supports different implementations (e.g. Local, Remote)\nthrough a behavior pattern.","ref":"Lux.Signal.Router.html"},{"type":"behaviour","title":"Usage - Lux.Signal.Router","doc":"# Start a local router\n    {:ok, _pid} = Router.Local.start_link(name: :my_router)\n\n    # Route a signal\n    Router.route(signal, implementation: Router.Local, name: :my_router, hub: :my_hub)\n\n    # Subscribe to signal events\n    Router.subscribe(signal_id, implementation: Router.Local, name: :my_router)","ref":"Lux.Signal.Router.html#module-usage"},{"type":"function","title":"Lux.Signal.Router.route/2","doc":"Routes a signal through the router.","ref":"Lux.Signal.Router.html#route/2"},{"type":"function","title":"Options - Lux.Signal.Router.route/2","doc":"* `:implementation` - The router implementation module (defaults to Local)\n  * `:name` - The registered name of the router process\n  * `:hub` - The hub to use for routing (required)","ref":"Lux.Signal.Router.html#route/2-options"},{"type":"callback","title":"Lux.Signal.Router.route/2","doc":"Routes a signal through the router.","ref":"Lux.Signal.Router.html#c:route/2"},{"type":"callback","title":"Options - Lux.Signal.Router.route/2","doc":"* `:implementation` - The router implementation module (defaults to Local)\n  * `:name` - The registered name of the router process\n  * `:hub` - The hub to use for routing (required)","ref":"Lux.Signal.Router.html#c:route/2-options"},{"type":"type","title":"Lux.Signal.Router.router/0","doc":"","ref":"Lux.Signal.Router.html#t:router/0"},{"type":"type","title":"Lux.Signal.Router.router_opts/0","doc":"","ref":"Lux.Signal.Router.html#t:router_opts/0"},{"type":"type","title":"Lux.Signal.Router.signal/0","doc":"","ref":"Lux.Signal.Router.html#t:signal/0"},{"type":"function","title":"Lux.Signal.Router.subscribe/2","doc":"Subscribes to signal events.","ref":"Lux.Signal.Router.html#subscribe/2"},{"type":"function","title":"Options - Lux.Signal.Router.subscribe/2","doc":"* `:implementation` - The router implementation module (defaults to Local)\n  * `:name` - The registered name of the router process","ref":"Lux.Signal.Router.html#subscribe/2-options"},{"type":"callback","title":"Lux.Signal.Router.subscribe/2","doc":"Subscribes to signal events.","ref":"Lux.Signal.Router.html#c:subscribe/2"},{"type":"callback","title":"Options - Lux.Signal.Router.subscribe/2","doc":"* `:implementation` - The router implementation module (defaults to Local)\n  * `:name` - The registered name of the router process","ref":"Lux.Signal.Router.html#c:subscribe/2-options"},{"type":"function","title":"Lux.Signal.Router.unsubscribe/2","doc":"Unsubscribes from signal events.","ref":"Lux.Signal.Router.html#unsubscribe/2"},{"type":"function","title":"Options - Lux.Signal.Router.unsubscribe/2","doc":"* `:implementation` - The router implementation module (defaults to Local)\n  * `:name` - The registered name of the router process","ref":"Lux.Signal.Router.html#unsubscribe/2-options"},{"type":"callback","title":"Lux.Signal.Router.unsubscribe/2","doc":"Unsubscribes from signal events.","ref":"Lux.Signal.Router.html#c:unsubscribe/2"},{"type":"callback","title":"Options - Lux.Signal.Router.unsubscribe/2","doc":"* `:implementation` - The router implementation module (defaults to Local)\n  * `:name` - The registered name of the router process","ref":"Lux.Signal.Router.html#c:unsubscribe/2-options"},{"type":"module","title":"Lux.Signal.Router.Local","doc":"Local implementation of the Router behaviour using GenServer.\n\nThis router handles signal delivery between agents running in the same BEAM VM.\nIt supports simple pub/sub for signal delivery events.","ref":"Lux.Signal.Router.Local.html"},{"type":"function","title":"Lux.Signal.Router.Local.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Lux.Signal.Router.Local.html#child_spec/1"},{"type":"function","title":"Lux.Signal.Router.Local.list_agents/1","doc":"Lists all agents registered with the router.","ref":"Lux.Signal.Router.Local.html#list_agents/1"},{"type":"function","title":"Lux.Signal.Router.Local.start_link/1","doc":"Starts the local router with the given options.","ref":"Lux.Signal.Router.Local.html#start_link/1"},{"type":"behaviour","title":"Lux.SignalSchema","doc":"Defines the behavior and macros for creating Signal schemas.\n\nSignal schemas define the structure and validation rules for Signal content.\nThey are used to ensure that Signals conform to expected formats and can be\nproperly processed by agents and workflows.","ref":"Lux.SignalSchema.html"},{"type":"macro","title":"Lux.SignalSchema.__using__/1","doc":"Defines a new Signal schema.","ref":"Lux.SignalSchema.html#__using__/1"},{"type":"macro","title":"Options - Lux.SignalSchema.__using__/1","doc":"* `:name` - The name of the schema. Defaults to the module name if not provided.\n  * `:version` - The schema version. Defaults to \"1.0.0\".\n  * `:schema` - Required. The JSON Schema definition for the Signal content.\n  * `:description` - Optional description of the schema.\n  * `:tags` - Optional list of tags for categorization.\n  * `:compatibility` - Schema compatibility level (:full, :backward, :forward, :none).\n  * `:status` - Schema status (:draft, :active, :deprecated, :retired).\n  * `:format` - Data format (:json, :yaml, :binary, :text).\n  * `:reference` - Optional reference to external schema documentation.","ref":"Lux.SignalSchema.html#__using__/1-options"},{"type":"type","title":"Lux.SignalSchema.compatibility/0","doc":"","ref":"Lux.SignalSchema.html#t:compatibility/0"},{"type":"type","title":"Lux.SignalSchema.format/0","doc":"","ref":"Lux.SignalSchema.html#t:format/0"},{"type":"function","title":"Lux.SignalSchema.new/1","doc":"Creates a new schema struct from the given attributes.","ref":"Lux.SignalSchema.html#new/1"},{"type":"function","title":"Lux.SignalSchema.normalize/1","doc":"Recursively converts all map keys to strings in a schema definition.","ref":"Lux.SignalSchema.html#normalize/1"},{"type":"type","title":"Lux.SignalSchema.status/0","doc":"","ref":"Lux.SignalSchema.html#t:status/0"},{"type":"type","title":"Lux.SignalSchema.t/0","doc":"","ref":"Lux.SignalSchema.html#t:t/0"},{"type":"function","title":"Lux.SignalSchema.validate/2","doc":"","ref":"Lux.SignalSchema.html#validate/2"},{"type":"callback","title":"Lux.SignalSchema.validate/2","doc":"","ref":"Lux.SignalSchema.html#c:validate/2"},{"type":"module","title":"Lux.Types","doc":"Shared Types for Lux.","ref":"Lux.Types.html"},{"type":"module","title":"Lux.UUID","doc":"UUID generation and formatting.\n\nThis module is based on the Ecto.UUID implementation from the Ecto project:\nhttps://github.com/elixir-ecto/ecto","ref":"Lux.UUID.html"},{"type":"function","title":"Lux.UUID.bingenerate/0","doc":"Generates a random, version 4 UUID in the binary format.","ref":"Lux.UUID.html#bingenerate/0"},{"type":"function","title":"Lux.UUID.generate/0","doc":"Generates a random, version 4 UUID.","ref":"Lux.UUID.html#generate/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany","doc":"Agentic Company contract","ref":"Lux.Web3.Contracts.AgenticCompany.html"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.__default_address__/0","doc":"Default address of the contract. Returns `nil` if not specified.\n\nTo specify a default address see `Ethers.Contract`","ref":"Lux.Web3.Contracts.AgenticCompany.html#__default_address__/0"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.accept_default_admin_transfer/0","doc":"Prepares `acceptDefaultAdminTransfer()` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#accept_default_admin_transfer/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.accept_default_admin_transfer/0","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#accept_default_admin_transfer/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.agent_token/0","doc":"Prepares `AGENT_TOKEN()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#agent_token/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.agent_token/0","doc":"- token_: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#agent_token/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.ans_resolver/0","doc":"Prepares `ANS_RESOLVER()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#ans_resolver/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.ans_resolver/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#ans_resolver/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.ans_reverse_registrar/0","doc":"Prepares `ANS_REVERSE_REGISTRAR()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#ans_reverse_registrar/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.ans_reverse_registrar/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#ans_reverse_registrar/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.apply_to_job/1","doc":"Prepares `applyToJob(bytes32 jobId)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#apply_to_job/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.apply_to_job/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#apply_to_job/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.apply_to_job/1","doc":"- newJobApplicationId_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#apply_to_job/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.apply_to_job_on_behalf_of/2","doc":"Prepares `applyToJobOnBehalfOf(bytes32 jobId, bytes32 applicantAnsNode)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#apply_to_job_on_behalf_of/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.apply_to_job_on_behalf_of/2","doc":"- jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#apply_to_job_on_behalf_of/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.apply_to_job_on_behalf_of/2","doc":"- newJobApplicationId_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#apply_to_job_on_behalf_of/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.begin_default_admin_transfer/1","doc":"Prepares `beginDefaultAdminTransfer(address newAdmin)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#begin_default_admin_transfer/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.begin_default_admin_transfer/1","doc":"- newAdmin: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#begin_default_admin_transfer/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.begin_default_admin_transfer/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#begin_default_admin_transfer/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.cancel_default_admin_transfer/0","doc":"Prepares `cancelDefaultAdminTransfer()` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#cancel_default_admin_transfer/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.cancel_default_admin_transfer/0","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#cancel_default_admin_transfer/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.cancel_job/1","doc":"Prepares `cancelJob(bytes32 jobId)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#cancel_job/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.cancel_job/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#cancel_job/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.cancel_job/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#cancel_job/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.change_default_admin_delay/1","doc":"Prepares `changeDefaultAdminDelay(uint48 newDelay)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#change_default_admin_delay/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.change_default_admin_delay/1","doc":"- newDelay: `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#change_default_admin_delay/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.change_default_admin_delay/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#change_default_admin_delay/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.company_name/0","doc":"Prepares `COMPANY_NAME()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#company_name/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.company_name/0","doc":"- name_: `:string`","ref":"Lux.Web3.Contracts.AgenticCompany.html#company_name/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.constructor/0","doc":"Prepares contract constructor values for deployment.\n\nTo deploy a contracts use `Ethers.deploy/2` and pass the result of this function as\n`:encoded_constructor` option.","ref":"Lux.Web3.Contracts.AgenticCompany.html#constructor/0"},{"type":"function","title":"Parameters - Lux.Web3.Contracts.AgenticCompany.constructor/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.html#constructor/0-parameters"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.create_job/1","doc":"Prepares `createJob(string jobName)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#create_job/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.create_job/1","doc":"- jobName: `:string`","ref":"Lux.Web3.Contracts.AgenticCompany.html#create_job/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.create_job/1","doc":"- newJobId_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#create_job/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.debit_interview_fee/2","doc":"Prepares `debitInterviewFee(bytes32 jobApplicationId, uint256 amount)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#debit_interview_fee/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.debit_interview_fee/2","doc":"- jobApplicationId: `{:bytes, 32}`\n - amount: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#debit_interview_fee/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.debit_interview_fee/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#debit_interview_fee/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.default_admin/0","doc":"Prepares `defaultAdmin()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.default_admin/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.default_admin_delay/0","doc":"Prepares `defaultAdminDelay()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin_delay/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.default_admin_delay/0","doc":"- `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin_delay/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.default_admin_delay_increase_wait/0","doc":"Prepares `defaultAdminDelayIncreaseWait()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin_delay_increase_wait/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.default_admin_delay_increase_wait/0","doc":"- `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin_delay_increase_wait/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.default_admin_role/0","doc":"Prepares `DEFAULT_ADMIN_ROLE()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin_role/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.default_admin_role/0","doc":"- `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#default_admin_role/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.deposit_hiring_bonuses/4","doc":"Prepares `depositHiringBonuses(bytes32 jobId, uint256 spectralAmount, uint256 agentTokenAmount, uint256 usdcAmount)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#deposit_hiring_bonuses/4"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.deposit_hiring_bonuses/4","doc":"- jobId: `{:bytes, 32}`\n - spectralAmount: `{:uint, 256}`\n - agentTokenAmount: `{:uint, 256}`\n - usdcAmount: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#deposit_hiring_bonuses/4-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.deposit_hiring_bonuses/4","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#deposit_hiring_bonuses/4-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.dissolve_company/1","doc":"Prepares `dissolveCompany(address withdrawTo)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#dissolve_company/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.dissolve_company/1","doc":"- withdrawTo: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#dissolve_company/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.dissolve_company/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#dissolve_company/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.distributor/0","doc":"Prepares `DISTRIBUTOR()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#distributor/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.distributor/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#distributor/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.employee_count/0","doc":"Prepares `employeeCount()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#employee_count/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.employee_count/0","doc":"- count_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#employee_count/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.fire_employee/1","doc":"Prepares `fireEmployee(bytes32 jobId)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#fire_employee/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.fire_employee/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#fire_employee/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.fire_employee/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#fire_employee/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.founded_at/0","doc":"Prepares `FOUNDED_AT()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#founded_at/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.founded_at/0","doc":"- timestamp_: `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#founded_at/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_employee_at_index/1","doc":"Prepares `getEmployeeAtIndex(uint256 index)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_employee_at_index/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_employee_at_index/1","doc":"- index: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_employee_at_index/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_employee_at_index/1","doc":"- employeeAnsNode_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_employee_at_index/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_employee_current_job/1","doc":"Prepares `getEmployeeCurrentJob(bytes32 employeeAnsNode)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_employee_current_job/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_employee_current_job/1","doc":"- employeeAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_employee_current_job/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_employee_current_job/1","doc":"- jobId_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_employee_current_job/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_job/1","doc":"Prepares `getJob(bytes32 jobId)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_job/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_job/1","doc":"- job_: `{:tuple, [{:bytes, 32}, {:uint, 48}, {:uint, 8}, {:uint, 256}, {:uint, 256}, {:uint, 256}, {:bytes, 32}, :string]}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_job_application/1","doc":"Prepares `getJobApplication(bytes32 jobApplicationId)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_job_application/1","doc":"- jobApplicationId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_job_application/1","doc":"- application_: `{:tuple, [bytes: 32, bytes: 32, bytes: 32, uint: 48, uint: 8]}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_job_application_count/1","doc":"Prepares `getJobApplicationCount(bytes32 jobId)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_count/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_job_application_count/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_count/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_job_application_count/1","doc":"- count_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_count/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_job_application_id_at_index/2","doc":"Prepares `getJobApplicationIdAtIndex(bytes32 jobId, uint256 index)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_id_at_index/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_job_application_id_at_index/2","doc":"- jobId: `{:bytes, 32}`\n - index: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_id_at_index/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_job_application_id_at_index/2","doc":"- id_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_id_at_index/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_job_application_ids/1","doc":"Prepares `getJobApplicationIds(bytes32 jobId)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_ids/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_job_application_ids/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_ids/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_job_application_ids/1","doc":"- ids_: `{:array, {:bytes, 32}}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_application_ids/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_job_at_index/1","doc":"Prepares `getJobAtIndex(uint256 index)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_at_index/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_job_at_index/1","doc":"- index: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_at_index/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_job_at_index/1","doc":"- jobId_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_job_at_index/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_role_admin/1","doc":"Prepares `getRoleAdmin(bytes32 role)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_admin/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_role_admin/1","doc":"- role: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_admin/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_role_admin/1","doc":"- `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_admin/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_role_member/2","doc":"Prepares `getRoleMember(bytes32 role, uint256 index)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_member/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_role_member/2","doc":"- role: `{:bytes, 32}`\n - index: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_member/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_role_member/2","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_member/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_role_member_count/1","doc":"Prepares `getRoleMemberCount(bytes32 role)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_member_count/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_role_member_count/1","doc":"- role: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_member_count/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_role_member_count/1","doc":"- `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_member_count/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_role_members/1","doc":"Prepares `getRoleMembers(bytes32 role)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_members/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_role_members/1","doc":"- role: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_members/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_role_members/1","doc":"- `{:array, :address}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_role_members/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.get_user_active_job_application_id/2","doc":"Prepares `getUserActiveJobApplicationId(bytes32 jobId, bytes32 applicantAnsNode)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_user_active_job_application_id/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.get_user_active_job_application_id/2","doc":"- jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_user_active_job_application_id/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.get_user_active_job_application_id/2","doc":"- id_: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#get_user_active_job_application_id/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.grant_role/2","doc":"Prepares `grantRole(bytes32 role, address account)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#grant_role/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.grant_role/2","doc":"- role: `{:bytes, 32}`\n - account: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#grant_role/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.grant_role/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#grant_role/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.has_role/2","doc":"Prepares `hasRole(bytes32 role, address account)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#has_role/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.has_role/2","doc":"- role: `{:bytes, 32}`\n - account: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#has_role/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.has_role/2","doc":"- `:bool`","ref":"Lux.Web3.Contracts.AgenticCompany.html#has_role/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.hire_applicant/2","doc":"Prepares `hireApplicant(bytes32 jobApplicationId, bytes32[] shortlistAnsNodes)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hire_applicant/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.hire_applicant/2","doc":"- jobApplicationId: `{:bytes, 32}`\n - shortlistAnsNodes: `{:array, {:bytes, 32}}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hire_applicant/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.hire_applicant/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#hire_applicant/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.hiring_bonus_denominator/0","doc":"Prepares `HIRING_BONUS_DENOMINATOR()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_denominator/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.hiring_bonus_denominator/0","doc":"- `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_denominator/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.hiring_bonus_employee_cut/0","doc":"Prepares `HIRING_BONUS_EMPLOYEE_CUT()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_employee_cut/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.hiring_bonus_employee_cut/0","doc":"- `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_employee_cut/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.hiring_bonus_shortlist_cut/0","doc":"Prepares `HIRING_BONUS_SHORTLIST_CUT()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_shortlist_cut/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.hiring_bonus_shortlist_cut/0","doc":"- `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_shortlist_cut/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.hiring_bonus_treasury_cut/0","doc":"Prepares `HIRING_BONUS_TREASURY_CUT()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_treasury_cut/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.hiring_bonus_treasury_cut/0","doc":"- `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#hiring_bonus_treasury_cut/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.initialize/3","doc":"Prepares `initialize(address initialAdmin, address agentToken, string companyName)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#initialize/3"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.initialize/3","doc":"- initialAdmin: `:address`\n - agentToken: `:address`\n - companyName: `:string`","ref":"Lux.Web3.Contracts.AgenticCompany.html#initialize/3-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.initialize/3","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#initialize/3-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.is_dissolved/0","doc":"Prepares `isDissolved()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#is_dissolved/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.is_dissolved/0","doc":"- dissolved_: `:bool`","ref":"Lux.Web3.Contracts.AgenticCompany.html#is_dissolved/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.job_count/0","doc":"Prepares `jobCount()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#job_count/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.job_count/0","doc":"- count_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#job_count/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.job_manager_role/0","doc":"Prepares `JOB_MANAGER_ROLE()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#job_manager_role/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.job_manager_role/0","doc":"- `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#job_manager_role/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.owner/0","doc":"Prepares `owner()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#owner/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.owner/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#owner/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.pending_default_admin/0","doc":"Prepares `pendingDefaultAdmin()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#pending_default_admin/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.pending_default_admin/0","doc":"- newAdmin: `:address`\n - schedule: `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#pending_default_admin/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.pending_default_admin_delay/0","doc":"Prepares `pendingDefaultAdminDelay()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#pending_default_admin_delay/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.pending_default_admin_delay/0","doc":"- newDelay: `{:uint, 48}`\n - schedule: `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#pending_default_admin_delay/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.reject_applicant/1","doc":"Prepares `rejectApplicant(bytes32 jobApplicationId)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#reject_applicant/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.reject_applicant/1","doc":"- jobApplicationId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#reject_applicant/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.reject_applicant/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#reject_applicant/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.renounce_role/2","doc":"Prepares `renounceRole(bytes32 role, address account)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#renounce_role/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.renounce_role/2","doc":"- role: `{:bytes, 32}`\n - account: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#renounce_role/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.renounce_role/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#renounce_role/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.revoke_role/2","doc":"Prepares `revokeRole(bytes32 role, address account)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#revoke_role/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.revoke_role/2","doc":"- role: `{:bytes, 32}`\n - account: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#revoke_role/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.revoke_role/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#revoke_role/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.rollback_default_admin_delay/0","doc":"Prepares `rollbackDefaultAdminDelay()` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#rollback_default_admin_delay/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.rollback_default_admin_delay/0","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#rollback_default_admin_delay/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.set_role_admin/2","doc":"Prepares `setRoleAdmin(bytes32 role, bytes32 adminRole)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#set_role_admin/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.set_role_admin/2","doc":"- role: `{:bytes, 32}`\n - adminRole: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#set_role_admin/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.set_role_admin/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#set_role_admin/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.spectral_token/0","doc":"Prepares `SPECTRAL_TOKEN()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#spectral_token/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.spectral_token/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#spectral_token/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.spectral_treasury/0","doc":"Prepares `SPECTRAL_TREASURY()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#spectral_treasury/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.spectral_treasury/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#spectral_treasury/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.supports_interface/1","doc":"Prepares `supportsInterface(bytes4 interfaceId)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#supports_interface/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.supports_interface/1","doc":"- interfaceId: `{:bytes, 4}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#supports_interface/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.supports_interface/1","doc":"- supported_: `:bool`","ref":"Lux.Web3.Contracts.AgenticCompany.html#supports_interface/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.usdc/0","doc":"Prepares `USDC()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#usdc/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.usdc/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#usdc/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.version/0","doc":"Prepares `VERSION()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#version/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.version/0","doc":"- `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#version/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.withdraw_all/1","doc":"Prepares `withdrawAll(address to)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdraw_all/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.withdraw_all/1","doc":"- to: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdraw_all/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.withdraw_all/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdraw_all/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.withdraw_job_application/1","doc":"Prepares `withdrawJobApplication(bytes32 jobApplicationId)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdraw_job_application/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompany.withdraw_job_application/1","doc":"- jobApplicationId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdraw_job_application/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.withdraw_job_application/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdraw_job_application/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.withdrawable_agent_token/0","doc":"Prepares `withdrawableAgentToken()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdrawable_agent_token/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.withdrawable_agent_token/0","doc":"- withdrawableAmount_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdrawable_agent_token/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.withdrawable_spectral/0","doc":"Prepares `withdrawableSpectral()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdrawable_spectral/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.withdrawable_spectral/0","doc":"- withdrawableAmount_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdrawable_spectral/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.withdrawable_usdc/0","doc":"Prepares `withdrawableUsdc()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdrawable_usdc/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompany.withdrawable_usdc/0","doc":"- withdrawableAmount_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.html#withdrawable_usdc/0-return-types-when-called-with-ethers-call-2"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlBadConfirmation","doc":"Error struct for `error AccessControlBadConfirmation`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlBadConfirmation.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlBadConfirmation.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlBadConfirmation.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminDelay","doc":"Error struct for `error AccessControlEnforcedDefaultAdminDelay`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminDelay.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminDelay.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminDelay.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminRules","doc":"Error struct for `error AccessControlEnforcedDefaultAdminRules`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminRules.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminRules.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlEnforcedDefaultAdminRules.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlInvalidDefaultAdmin","doc":"Error struct for `error AccessControlInvalidDefaultAdmin`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlInvalidDefaultAdmin.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlInvalidDefaultAdmin.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlInvalidDefaultAdmin.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlUnauthorizedAccount","doc":"Error struct for `error AccessControlUnauthorizedAccount`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlUnauthorizedAccount.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlUnauthorizedAccount.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AccessControlUnauthorizedAccount.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AddressMustResolveToAnsName","doc":"Error struct for `error AddressMustResolveToAnsName`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AddressMustResolveToAnsName.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AddressMustResolveToAnsName.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AddressMustResolveToAnsName.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AgentTokenTransferFailed","doc":"Error struct for `error AgentTokenTransferFailed`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AgentTokenTransferFailed.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AgentTokenTransferFailed.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AgentTokenTransferFailed.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AnsNodeMustResolveToAddress","doc":"Error struct for `error AnsNodeMustResolveToAddress`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AnsNodeMustResolveToAddress.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.AnsNodeMustResolveToAddress.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.AnsNodeMustResolveToAddress.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantAlreadyEmployed","doc":"Error struct for `error ApplicantAlreadyEmployed`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantAlreadyEmployed.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantAlreadyEmployed.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantAlreadyEmployed.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantHasActiveApplication","doc":"Error struct for `error ApplicantHasActiveApplication`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantHasActiveApplication.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantHasActiveApplication.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.ApplicantHasActiveApplication.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.CompanyIsDissolved","doc":"Error struct for `error CompanyIsDissolved`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.CompanyIsDissolved.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.CompanyIsDissolved.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.CompanyIsDissolved.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.EmployeeNotFound","doc":"Error struct for `error EmployeeNotFound`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.EmployeeNotFound.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.EmployeeNotFound.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.EmployeeNotFound.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.IndexOutOfBounds","doc":"Error struct for `error IndexOutOfBounds`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.IndexOutOfBounds.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.IndexOutOfBounds.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.IndexOutOfBounds.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidInitialization","doc":"Error struct for `error InvalidInitialization`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidInitialization.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidInitialization.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidInitialization.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidZeroAddress","doc":"Error struct for `error InvalidZeroAddress`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidZeroAddress.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidZeroAddress.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.InvalidZeroAddress.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationAlreadyExists","doc":"Error struct for `error JobApplicationAlreadyExists`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationAlreadyExists.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationAlreadyExists.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationAlreadyExists.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationNotApplied","doc":"Error struct for `error JobApplicationNotApplied`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationNotApplied.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationNotApplied.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobApplicationNotApplied.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobDoesNotExist","doc":"Error struct for `error JobDoesNotExist`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobDoesNotExist.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobDoesNotExist.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobDoesNotExist.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobIdCollision","doc":"Error struct for `error JobIdCollision`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobIdCollision.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobIdCollision.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobIdCollision.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNameTooShort","doc":"Error struct for `error JobNameTooShort`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNameTooShort.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNameTooShort.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNameTooShort.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotFilled","doc":"Error struct for `error JobNotFilled`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotFilled.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotFilled.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotFilled.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpen","doc":"Error struct for `error JobNotOpen`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpen.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpen.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpen.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpenOrVacated","doc":"Error struct for `error JobNotOpenOrVacated`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpenOrVacated.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpenOrVacated.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.JobNotOpenOrVacated.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.NotInitializing","doc":"Error struct for `error NotInitializing`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.NotInitializing.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.NotInitializing.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.NotInitializing.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.OnlyJobApplicant","doc":"Error struct for `error OnlyJobApplicant`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.OnlyJobApplicant.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.OnlyJobApplicant.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.OnlyJobApplicant.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeCastOverflowedUintDowncast","doc":"Error struct for `error SafeCastOverflowedUintDowncast`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeCastOverflowedUintDowncast.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeCastOverflowedUintDowncast.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeCastOverflowedUintDowncast.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeERC20FailedOperation","doc":"Error struct for `error SafeERC20FailedOperation`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeERC20FailedOperation.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeERC20FailedOperation.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.SafeERC20FailedOperation.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.SpectralTransferFailed","doc":"Error struct for `error SpectralTransferFailed`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.SpectralTransferFailed.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.SpectralTransferFailed.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.SpectralTransferFailed.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.Errors.UsdcTransferFailed","doc":"Error struct for `error UsdcTransferFailed`","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.UsdcTransferFailed.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompany.Errors.UsdcTransferFailed.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.Errors.UsdcTransferFailed.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters","doc":"Events for `Lux.Web3.Contracts.AgenticCompany`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.company_dissolved/0","doc":"Create event filter for `CompanyDissolved()`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#company_dissolved/0"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.company_dissolved/0","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#company_dissolved/0-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_delay_change_canceled/0","doc":"Create event filter for `DefaultAdminDelayChangeCanceled()`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_delay_change_canceled/0"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_delay_change_canceled/0","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_delay_change_canceled/0-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_delay_change_scheduled/0","doc":"Create event filter for `DefaultAdminDelayChangeScheduled(uint48 newDelay, uint48 effectSchedule)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_delay_change_scheduled/0"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_delay_change_scheduled/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_delay_change_scheduled/0-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_delay_change_scheduled/0","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - newDelay: `{:uint, 48}`\n - effectSchedule: `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_delay_change_scheduled/0-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_transfer_canceled/0","doc":"Create event filter for `DefaultAdminTransferCanceled()`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_transfer_canceled/0"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_transfer_canceled/0","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_transfer_canceled/0-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_transfer_scheduled/1","doc":"Create event filter for `DefaultAdminTransferScheduled(address newAdmin, uint48 acceptSchedule)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_transfer_scheduled/1"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_transfer_scheduled/1","doc":"- newAdmin: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_transfer_scheduled/1-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.default_admin_transfer_scheduled/1","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - acceptSchedule: `{:uint, 48}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#default_admin_transfer_scheduled/1-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.employee_fired/2","doc":"Create event filter for `EmployeeFired(bytes32 jobId, bytes32 employeeAnsNode)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#employee_fired/2"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.employee_fired/2","doc":"- jobId: `{:bytes, 32}`\n - employeeAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#employee_fired/2-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.employee_fired/2","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#employee_fired/2-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.funds_withdrawn/1","doc":"Create event filter for `FundsWithdrawn(address to, uint256 spectralAmount, uint256 agentTokenAmount, uint256 usdcAmount)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#funds_withdrawn/1"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.funds_withdrawn/1","doc":"- to: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#funds_withdrawn/1-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.funds_withdrawn/1","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - spectralAmount: `{:uint, 256}`\n - agentTokenAmount: `{:uint, 256}`\n - usdcAmount: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#funds_withdrawn/1-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.hiring_bonuses_deposited/1","doc":"Create event filter for `HiringBonusesDeposited(bytes32 jobId, uint256 spectralAmount, uint256 agentTokenAmount, uint256 usdcAmount)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#hiring_bonuses_deposited/1"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.hiring_bonuses_deposited/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#hiring_bonuses_deposited/1-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.hiring_bonuses_deposited/1","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - spectralAmount: `{:uint, 256}`\n - agentTokenAmount: `{:uint, 256}`\n - usdcAmount: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#hiring_bonuses_deposited/1-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.initialized/0","doc":"Create event filter for `Initialized(uint64 version)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#initialized/0"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.initialized/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#initialized/0-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.initialized/0","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - version: `{:uint, 64}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#initialized/0-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.interview_fee_received/3","doc":"Create event filter for `InterviewFeeReceived(bytes32 jobApplicationId, bytes32 jobId, bytes32 applicantAnsNode, uint256 amount)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#interview_fee_received/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.interview_fee_received/3","doc":"- jobApplicationId: `{:bytes, 32}`\n - jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#interview_fee_received/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.interview_fee_received/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - amount: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#interview_fee_received/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.job_applicant_hired/3","doc":"Create event filter for `JobApplicantHired(bytes32 jobApplicationId, bytes32 jobId, bytes32 applicantAnsNode, bytes32[] shortlistAnsNodes)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_applicant_hired/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_applicant_hired/3","doc":"- jobApplicationId: `{:bytes, 32}`\n - jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_applicant_hired/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_applicant_hired/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - shortlistAnsNodes: `{:array, {:bytes, 32}}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_applicant_hired/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.job_applicant_rejected/3","doc":"Create event filter for `JobApplicantRejected(bytes32 jobApplicationId, bytes32 jobId, bytes32 applicantAnsNode)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_applicant_rejected/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_applicant_rejected/3","doc":"- jobApplicationId: `{:bytes, 32}`\n - jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_applicant_rejected/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_applicant_rejected/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_applicant_rejected/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.job_application_created/3","doc":"Create event filter for `JobApplicationCreated(bytes32 jobApplicationId, bytes32 jobId, bytes32 applicantAnsNode)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_application_created/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_application_created/3","doc":"- jobApplicationId: `{:bytes, 32}`\n - jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_application_created/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_application_created/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_application_created/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.job_application_withdrawn/3","doc":"Create event filter for `JobApplicationWithdrawn(bytes32 jobApplicationId, bytes32 jobId, bytes32 applicantAnsNode)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_application_withdrawn/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_application_withdrawn/3","doc":"- jobApplicationId: `{:bytes, 32}`\n - jobId: `{:bytes, 32}`\n - applicantAnsNode: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_application_withdrawn/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_application_withdrawn/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_application_withdrawn/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.job_cancelled/1","doc":"Create event filter for `JobCancelled(bytes32 jobId)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_cancelled/1"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_cancelled/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_cancelled/1-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_cancelled/1","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_cancelled/1-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.job_created/1","doc":"Create event filter for `JobCreated(bytes32 jobId, string jobName, uint256 createdAt)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_created/1"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_created/1","doc":"- jobId: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_created/1-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.job_created/1","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - jobName: `:string`\n - createdAt: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#job_created/1-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.role_admin_changed/3","doc":"Create event filter for `RoleAdminChanged(bytes32 role, bytes32 previousAdminRole, bytes32 newAdminRole)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_admin_changed/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.role_admin_changed/3","doc":"- role: `{:bytes, 32}`\n - previousAdminRole: `{:bytes, 32}`\n - newAdminRole: `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_admin_changed/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.role_admin_changed/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_admin_changed/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.role_granted/3","doc":"Create event filter for `RoleGranted(bytes32 role, address account, address sender)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_granted/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.role_granted/3","doc":"- role: `{:bytes, 32}`\n - account: `:address`\n - sender: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_granted/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.role_granted/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_granted/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompany.EventFilters.role_revoked/3","doc":"Create event filter for `RoleRevoked(bytes32 role, address account, address sender)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_revoked/3"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompany.EventFilters.role_revoked/3","doc":"- role: `{:bytes, 32}`\n - account: `:address`\n - sender: `:address`","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_revoked/3-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompany.EventFilters.role_revoked/3","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompany.EventFilters.html#role_revoked/3-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory","doc":"Agentic Company Factory contract","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.__default_address__/0","doc":"Default address of the contract. Returns `nil` if not specified.\n\nTo specify a default address see `Ethers.Contract`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#__default_address__/0"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.accept_ownership/0","doc":"Prepares `acceptOwnership()` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#accept_ownership/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.accept_ownership/0","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#accept_ownership/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.allow_only_valid_agent_tokens/0","doc":"Prepares `allowOnlyValidAgentTokens()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#allow_only_valid_agent_tokens/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.allow_only_valid_agent_tokens/0","doc":"- allowOnlyValidAgentTokens_: `:bool`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#allow_only_valid_agent_tokens/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.autonomous_agent_deployer/0","doc":"Prepares `AUTONOMOUS_AGENT_DEPLOYER()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#autonomous_agent_deployer/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.autonomous_agent_deployer/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#autonomous_agent_deployer/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.company_beacon/0","doc":"Prepares `COMPANY_BEACON()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#company_beacon/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.company_beacon/0","doc":"- beacon_: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#company_beacon/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.company_count/0","doc":"Prepares `companyCount()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#company_count/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.company_count/0","doc":"- count_: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#company_count/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.constructor/0","doc":"Prepares contract constructor values for deployment.\n\nTo deploy a contracts use `Ethers.deploy/2` and pass the result of this function as\n`:encoded_constructor` option.","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#constructor/0"},{"type":"function","title":"Parameters - Lux.Web3.Contracts.AgenticCompanyFactory.constructor/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#constructor/0-parameters"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.create_company/2","doc":"Prepares `createCompany(string companyName, address agentToken)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#create_company/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.create_company/2","doc":"- companyName: `:string`\n - agentToken: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#create_company/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.create_company/2","doc":"- companyAddress_: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#create_company/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.get_companies/2","doc":"Prepares `getCompanies(uint256 startIndex, uint256 count)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#get_companies/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.get_companies/2","doc":"- startIndex: `{:uint, 256}`\n - count: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#get_companies/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.get_companies/2","doc":"- companies_: `{:array, :address}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#get_companies/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.get_company_address_at_index/1","doc":"Prepares `getCompanyAddressAtIndex(uint256 index)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#get_company_address_at_index/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.get_company_address_at_index/1","doc":"- index: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#get_company_address_at_index/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.get_company_address_at_index/1","doc":"- companyAddress_: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#get_company_address_at_index/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.initialize/2","doc":"Prepares `initialize(address beacon, address initialFactoryOwner)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#initialize/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.initialize/2","doc":"- beacon: `:address`\n - initialFactoryOwner: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#initialize/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.initialize/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#initialize/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.is_company/1","doc":"Prepares `isCompany(address maybeCompany)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#is_company/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.is_company/1","doc":"- maybeCompany: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#is_company/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.is_company/1","doc":"- isCompany_: `:bool`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#is_company/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.owner/0","doc":"Prepares `owner()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#owner/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.owner/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#owner/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.pending_owner/0","doc":"Prepares `pendingOwner()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#pending_owner/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.pending_owner/0","doc":"- `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#pending_owner/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.proxiable_uuid/0","doc":"Prepares `proxiableUUID()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#proxiable_uuid/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.proxiable_uuid/0","doc":"- `{:bytes, 32}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#proxiable_uuid/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.renounce_ownership/0","doc":"Prepares `renounceOwnership()` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#renounce_ownership/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.renounce_ownership/0","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#renounce_ownership/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.set_allow_only_valid_agent_tokens/1","doc":"Prepares `setAllowOnlyValidAgentTokens(bool allowOnlyValidAgentTokens_)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#set_allow_only_valid_agent_tokens/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.set_allow_only_valid_agent_tokens/1","doc":"- allowOnlyValidAgentTokens_: `:bool`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#set_allow_only_valid_agent_tokens/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.set_allow_only_valid_agent_tokens/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#set_allow_only_valid_agent_tokens/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.supports_interface/1","doc":"Prepares `supportsInterface(bytes4 interfaceId)` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#supports_interface/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.supports_interface/1","doc":"- interfaceId: `{:bytes, 4}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#supports_interface/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.supports_interface/1","doc":"- supported_: `:bool`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#supports_interface/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.transfer_ownership/1","doc":"Prepares `transferOwnership(address newOwner)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nNo amount of Ether can be sent with this function.\n\n\nState mutability: `non_payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#transfer_ownership/1"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.transfer_ownership/1","doc":"- newOwner: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#transfer_ownership/1-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.transfer_ownership/1","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#transfer_ownership/1-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.upgrade_interface_version/0","doc":"Prepares `UPGRADE_INTERFACE_VERSION()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#upgrade_interface_version/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.upgrade_interface_version/0","doc":"- `:string`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#upgrade_interface_version/0-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.upgrade_to_and_call/2","doc":"Prepares `upgradeToAndCall(address newImplementation, bytes data)` call parameters on the contract.\n\nThis function can be used for a transaction or additionally called for results (Use `Ethers.send_transaction/2`).\nIt also supports receiving ether from the transaction origin.\n\n\nState mutability: `payable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#upgrade_to_and_call/2"},{"type":"function","title":"Function Parameter Types - Lux.Web3.Contracts.AgenticCompanyFactory.upgrade_to_and_call/2","doc":"- newImplementation: `:address`\n - data: `:bytes`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#upgrade_to_and_call/2-function-parameter-types"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.upgrade_to_and_call/2","doc":"This function does not return any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#upgrade_to_and_call/2-return-types-when-called-with-ethers-call-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.version/0","doc":"Prepares `version()` call parameters on the contract.\n\nThis function should only be called for result and never in a transaction on its own. (Use `Ethers.call/2`)\n\n\nState mutability: `view`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#version/0"},{"type":"function","title":"Return Types (when called with `Ethers.call/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.version/0","doc":"- version_: `{:uint, 64}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.html#version/0-return-types-when-called-with-ethers-call-2"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.AddressEmptyCode","doc":"Error struct for `error AddressEmptyCode`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.AddressEmptyCode.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.AddressEmptyCode.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.AddressEmptyCode.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.BeaconNotDeployed","doc":"Error struct for `error BeaconNotDeployed`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.BeaconNotDeployed.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.BeaconNotDeployed.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.BeaconNotDeployed.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967InvalidImplementation","doc":"Error struct for `error ERC1967InvalidImplementation`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967InvalidImplementation.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967InvalidImplementation.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967InvalidImplementation.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967NonPayable","doc":"Error struct for `error ERC1967NonPayable`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967NonPayable.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967NonPayable.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ERC1967NonPayable.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.FailedCall","doc":"Error struct for `error FailedCall`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.FailedCall.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.FailedCall.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.FailedCall.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ImplementationNotDeployed","doc":"Error struct for `error ImplementationNotDeployed`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ImplementationNotDeployed.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ImplementationNotDeployed.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.ImplementationNotDeployed.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidAgentToken","doc":"Error struct for `error InvalidAgentToken`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidAgentToken.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidAgentToken.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidAgentToken.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidBeaconAddress","doc":"Error struct for `error InvalidBeaconAddress`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidBeaconAddress.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidBeaconAddress.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidBeaconAddress.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidFactoryOwnerAddress","doc":"Error struct for `error InvalidFactoryOwnerAddress`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidFactoryOwnerAddress.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidFactoryOwnerAddress.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidFactoryOwnerAddress.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidImplementationAddress","doc":"Error struct for `error InvalidImplementationAddress`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidImplementationAddress.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidImplementationAddress.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidImplementationAddress.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidInitialization","doc":"Error struct for `error InvalidInitialization`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidInitialization.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidInitialization.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.InvalidInitialization.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.NotInitializing","doc":"Error struct for `error NotInitializing`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.NotInitializing.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.NotInitializing.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.NotInitializing.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableInvalidOwner","doc":"Error struct for `error OwnableInvalidOwner`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableInvalidOwner.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableInvalidOwner.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableInvalidOwner.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableUnauthorizedAccount","doc":"Error struct for `error OwnableUnauthorizedAccount`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableUnauthorizedAccount.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableUnauthorizedAccount.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.OwnableUnauthorizedAccount.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnauthorizedCallContext","doc":"Error struct for `error UUPSUnauthorizedCallContext`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnauthorizedCallContext.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnauthorizedCallContext.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnauthorizedCallContext.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnsupportedProxiableUUID","doc":"Error struct for `error UUPSUnsupportedProxiableUUID`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnsupportedProxiableUUID.html"},{"type":"type","title":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnsupportedProxiableUUID.t/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.Errors.UUPSUnsupportedProxiableUUID.html#t:t/0"},{"type":"module","title":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters","doc":"Events for `Lux.Web3.Contracts.AgenticCompanyFactory`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.company_created/2","doc":"Create event filter for `CompanyCreated(address company, address owner, string companyName, uint256 timestamp)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#company_created/2"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.company_created/2","doc":"- company: `:address`\n - owner: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#company_created/2-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.company_created/2","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - companyName: `:string`\n - timestamp: `{:uint, 256}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#company_created/2-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.initialized/0","doc":"Create event filter for `Initialized(uint64 version)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#initialized/0"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.initialized/0","doc":"","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#initialized/0-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.initialized/0","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\n - version: `{:uint, 64}`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#initialized/0-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.ownership_transfer_started/2","doc":"Create event filter for `OwnershipTransferStarted(address previousOwner, address newOwner)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#ownership_transfer_started/2"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.ownership_transfer_started/2","doc":"- previousOwner: `:address`\n - newOwner: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#ownership_transfer_started/2-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.ownership_transfer_started/2","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#ownership_transfer_started/2-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.ownership_transferred/2","doc":"Create event filter for `OwnershipTransferred(address previousOwner, address newOwner)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#ownership_transferred/2"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.ownership_transferred/2","doc":"- previousOwner: `:address`\n - newOwner: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#ownership_transferred/2-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.ownership_transferred/2","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#ownership_transferred/2-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"function","title":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.upgraded/1","doc":"Create event filter for `Upgraded(address implementation)`\n\nFor each indexed parameter you can either pass in the value you want to\nfilter or `nil` if you don't want to filter.","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#upgraded/1"},{"type":"function","title":"Parameter Types (Event indexed topics) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.upgraded/1","doc":"- implementation: `:address`","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#upgraded/1-parameter-types-event-indexed-topics"},{"type":"function","title":"Event `data` Types (when called with `Ethers.get_logs/2`) - Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.upgraded/1","doc":"These are non-indexed topics (often referred to as data) of the event log.\n\nThis event does not contain any values!","ref":"Lux.Web3.Contracts.AgenticCompanyFactory.EventFilters.html#upgraded/1-event-data-types-when-called-with-ethers-get_logs-2"},{"type":"task","title":"mix company.setup","doc":"Sets up a new company with job openings using configuration from a YAML file.","ref":"Mix.Tasks.Company.Setup.html"},{"type":"task","title":"Usage - mix company.setup","doc":"mix company.setup [path/to/config.yaml]\n\nIf no config file is specified, it will use the default at `config/company_setup.yaml`.","ref":"Mix.Tasks.Company.Setup.html#module-usage"},{"type":"task","title":"Example - mix company.setup","doc":"mix company.setup\n    mix company.setup path/to/my/config.yaml","ref":"Mix.Tasks.Company.Setup.html#module-example"},{"type":"task","title":"mix deps.h","doc":"Quick helper to read dependency documentation from the command line and print it to the terminal.\nYou might want to add this to your .cursorrules file\n\nExamples:\nmix deps.h Req.Request\nmix deps.h Req.Request.append_error_steps/2","ref":"Mix.Tasks.Deps.H.html"},{"type":"function","title":"Mix.Tasks.Deps.H.run/1","doc":"","ref":"Mix.Tasks.Deps.H.html#run/1"},{"type":"task","title":"mix python.test","doc":"Runs Python tests using pytest.","ref":"Mix.Tasks.Python.Test.html"},{"type":"task","title":"Examples - mix python.test","doc":"# Run all Python tests\n    mix python.test\n\n    # Run specific test file\n    mix python.test tests/test_eval.py\n\n    # Run tests with specific marker\n    mix python.test --marker=\"not slow\"\n\n    # Show test coverage\n    mix python.test --cov\n\nThe task will use Poetry to manage dependencies and run tests.\nMake sure you have Poetry installed and have run `poetry install`\nin the priv/python directory first.","ref":"Mix.Tasks.Python.Test.html#module-examples"},{"type":"task","title":"mix run.company","doc":"Runs a Lux company.","ref":"Mix.Tasks.Run.Company.html"},{"type":"task","title":"Usage - mix run.company","doc":"mix run.company MyApp.Companies.ContentTeam\n\nThis will start the company and keep it running until interrupted.","ref":"Mix.Tasks.Run.Company.html#module-usage"},{"type":"task","title":"mix setup","doc":"Sets up the project for local development.\n\nThis task:\n1. Installs Elixir dependencies\n2. Ensures Poetry is installed and configured\n3. Create virtual env\n4. Installs Python dependencies","ref":"Mix.Tasks.Setup.html"},{"type":"task","title":"Usage - mix setup","doc":"mix setup","ref":"Mix.Tasks.Setup.html#module-usage"},{"type":"extras","title":"Lux","doc":"# Lux\n\n<!-- [![Build Status](https://github.com/spectrallabs/lux/workflows/CI/badge.svg)](https://github.com/spectrallabs/lux/actions) -->\n[![Lux CI](https://github.com/Spectral-Finance/lux/actions/workflows/lux-ci.yml/badge.svg)](https://github.com/Spectral-Finance/lux/actions/workflows/lux-ci.yml)\n[![Lux App CI](https://github.com/Spectral-Finance/lux/actions/workflows/lux-app-ci.yml/badge.svg)](https://github.com/Spectral-Finance/lux/actions/workflows/lux-app-ci.yml)\n[![Hex.pm](https://img.shields.io/hexpm/v/lux.svg)](https://hex.pm/packages/lux)\n[![Docs](https://img.shields.io/badge/hex-docs-blue.svg)](https://hexdocs.pm/lux)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n\nLux is a powerful language-agnostic framework for building intelligent, adaptive, and collaborative multi-agent systems. It enables autonomous entities (Agents) to communicate, learn, and execute complex workflows while continuously improving through reflection.","ref":"readme.html"},{"type":"extras","title":"Why Lux? - Lux","doc":"- 🧠 **Self-Improving Agents**: Agents with built-in reflection capabilities (coming soon)\n- 🚀 **Language Agnostic**: Build agents in your favorite programming language\n- 🔄 **Type-Safe Communication**: Structured data flow with schema validation\n- 🤖 **AI-First**: Deep LLM integration with advanced prompting and context management\n- 🔌 **Extensible**: Easy integration with external services and APIs\n- 📊 **Observable**: Built-in monitoring, metrics, and debugging tools\n- 🧪 **Testable**: Comprehensive testing utilities for deterministic agent behavior","ref":"readme.html#why-lux"},{"type":"extras","title":"Documentation - Lux","doc":"📚 [Read the full documentation on hexdocs.pm/lux](https://hexdocs.pm/lux)","ref":"readme.html#documentation"},{"type":"extras","title":"Getting Started - Lux","doc":"- [Getting Started Guide](lux/guides/getting_started.md) (docs coming soon) - Start here if you're new to Lux\n- [Core Concepts](lux/guides/core_concepts.md) (docs coming soon) - Learn about Agents, Signals, Prisms, and Beams\n- [Language Support](lux/guides/language_support.md) (docs coming soon) - Language integration details","ref":"readme.html#getting-started"},{"type":"extras","title":"Core Concepts - Lux","doc":"- [Agents](lux/guides/agents.livemd) - Building intelligent autonomous agents\n- [Signals](lux/guides/signals.livemd) - Type-safe communication between agents\n- [Prisms](lux/guides/prisms.livemd) - Modular functional components\n- [Beams](lux/guides/beams.livemd) - Workflow orchestration\n- [Lenses](lux/guides/lenses.livemd) - External service integration","ref":"readme.html#core-concepts"},{"type":"extras","title":"Examples & Guides - Lux","doc":"- [Multi-Agent Collaboration](lux/guides/multi_agent_collaboration.livemd) - Build collaborative systems\n- [Trading System](lux/guides/trading_system.livemd) - Complete crypto trading example\n- [Running a Company](lux/guides/running_a_company.livemd) - Multi-agent content creation pipeline\n- [Role Management](lux/guides/role_management.md) - Managing agent roles\n- [Companies](lux/guides/companies.md) - Organizing agents into companies","ref":"readme.html#examples-guides"},{"type":"extras","title":"Development - Lux","doc":"- [Contributing Guide](lux/guides/contributing.md) - Help improve Lux\n- [Testing Guide](lux/guides/testing.md) - Testing your Lux applications\n- [Troubleshooting](lux/guides/troubleshooting.md) - Common issues and solutions","ref":"readme.html#development"},{"type":"extras","title":"Core Concepts - Lux","doc":"","ref":"readme.html#core-concepts"},{"type":"extras","title":"1. Agents 👻 - Lux","doc":"[Learn more about Agents](lux/guides/agents.livemd)\n\nAutonomous agents that combine intelligence and execution. Agents can:\n- Monitor and analyze data\n- Make strategic decisions\n- Delegate tasks to other agents\n- Adapt to changing conditions\n- Collaborate through structured protocols","ref":"readme.html#1-agents"},{"type":"extras","title":"2. Signals 📡 - Lux","doc":"[Learn more about Signals](lux/guides/signals.livemd)\n\nType-safe communication using predefined schemas. Signals provide:\n- Structured data validation\n- Type safety across language boundaries\n- Clear communication protocols\n- Versioning and compatibility","ref":"readme.html#2-signals"},{"type":"extras","title":"3. Prisms 🔮 - Lux","doc":"[Learn more about Prisms](lux/guides/prisms.livemd)\n\nPure functional components for specific tasks. Prisms enable:\n- Modular functionality\n- Language-specific implementations\n- Clear input/output contracts\n- Easy testing and validation","ref":"readme.html#3-prisms"},{"type":"extras","title":"4. Beams 🌟 - Lux","doc":"[Learn more about Beams](lux/guides/beams.livemd)\n\nComposable workflow orchestrators. Beams allow you to:\n- Define complex workflows\n- Coordinate multiple agents\n- Handle parallel execution\n- Manage state and dependencies","ref":"readme.html#4-beams"},{"type":"extras","title":"Language Support - Lux","doc":"Lux provides first-class support for multiple programming languages:\n\n- **Python**: Deep integration with Python's scientific and ML ecosystem\n- **JavaScript/TypeScript**: Frontend and Node.js support\n- **Other Languages**: Language-agnostic protocols for easy integration\n\n[Learn more about language support](lux/guides/language_support.md)","ref":"readme.html#language-support"},{"type":"extras","title":"Examples - Lux","doc":"Check out these examples to see Lux in action:\n\n- [Trading System](lux/guides/trading_system.livemd): A complete crypto trading system\n- [Content Creation](lux/guides/running_a_company.livemd): Multi-agent content creation pipeline\n- [Research Assistant](lux/guides/multi_agent_collaboration.livemd): Collaborative research system","ref":"readme.html#examples"},{"type":"extras","title":"Contributing - Lux","doc":"We welcome contributions! Whether you want to add support for a new language, improve documentation, or fix bugs, check out our [Contributing Guide](lux/guides/contributing.md).","ref":"readme.html#contributing"},{"type":"extras","title":"Community - Lux","doc":"- 💬 [Discord Community](https://discord.gg/luxframework)\n- 📝 [Blog](https://blog.spectrallabs.xyz)\n- 🐦 [Twitter](https://twitter.com/luxframework)","ref":"readme.html#community"},{"type":"extras","title":"License - Lux","doc":"Lux is released under the MIT License. See [LICENSE](LICENSE) for details.","ref":"readme.html#license"},{"type":"extras","title":"Testing Guide","doc":"# Testing Guide","ref":"testing.html"},{"type":"extras","title":"Overview - Testing Guide","doc":"The Lux test suite is organized into two main categories:\n- **Unit Tests**: Fast, isolated tests that don't require external services\n- **Integration Tests**: Tests that interact with external services (e.g., OpenAI, Alchemy)\n\n⚠️ **Important**: Unit and integration tests cannot run simultaneously as they may interfere with each other's configuration. Always run them separately.","ref":"testing.html#overview"},{"type":"extras","title":"Test Commands - Testing Guide","doc":"```bash\n# Run unit tests only\nmix test.unit\n\n# Run integration tests only (requires API keys)\nmix test.integration\n\n# Run python tests\nmix python.test\n```","ref":"testing.html#test-commands"},{"type":"extras","title":"Test Organization - Testing Guide","doc":"- `test/unit/` - Contains all unit tests\n- `test/integration/` - Contains all integration tests\n- `test/support/` - Shared test helpers and utilities","ref":"testing.html#test-organization"},{"type":"extras","title":"Configuration - Testing Guide","doc":"","ref":"testing.html#configuration"},{"type":"extras","title":"Unit Tests - Testing Guide","doc":"Unit tests use mock configurations and don't require real API keys. The configuration is loaded from:\n- `test.envrc` - Base test configuration\n- `test.override.envrc` - Local overrides (git-ignored)","ref":"testing.html#unit-tests"},{"type":"extras","title":"Integration Tests - Testing Guide","doc":"Integration tests require actual API keys as they interact with external services. To run integration tests:\n\n1. Create a `test.override.envrc` file (if not exists)\n2. Add your API keys:\n```bash\n# test.override.envrc\nINTEGRATION_OPENAI_API_KEY=\"your-openai-key\"\nALCHEMY_API_KEY=\"your-alchemy-key\"\n# Add other required API keys\n```\n\n⚠️ **Security Note**: Never commit real API keys to the repository. Always use the `test.override.envrc` file which is git-ignored.","ref":"testing.html#integration-tests"},{"type":"extras","title":"Writing Tests - Testing Guide","doc":"","ref":"testing.html#writing-tests"},{"type":"extras","title":"Unit Tests - Testing Guide","doc":"```elixir\ndefmodule MyModuleTest do\n  use UnitCase, async: true\n  # Your test code\nend\n```","ref":"testing.html#unit-tests"},{"type":"extras","title":"Integration Tests - Testing Guide","doc":"```elixir\ndefmodule MyIntegrationTest do\n  use IntegrationCase, async: true\n  # Your test code\nend\n```","ref":"testing.html#integration-tests"},{"type":"extras","title":"API Tests - Testing Guide","doc":"For tests that mock HTTP requests:\n```elixir\ndefmodule MyAPITest do\n  use UnitAPICase, async: true\n  # Your test code\nend\n```","ref":"testing.html#api-tests"},{"type":"extras","title":"Best Practices - Testing Guide","doc":"1. **Test Isolation**\n   - Keep unit tests independent of external services\n   - Use mocks appropriately in unit tests\n   - Integration tests should be clearly marked\n\n2. **Configuration Management**\n   - Use `test.override.envrc` for sensitive credentials\n   - Keep mock data in unit tests realistic but simplified\n   - Document any required environment variables\n\n3. **Async Testing**\n   - Most tests can run async (use `async: true`)\n   - Be cautious with shared resources in integration tests\n   - Consider using `async: false` for tests that modify global state\n\n4. **Test Organization**\n   - Follow the established directory structure\n   - Use appropriate test case modules\n   - Group related tests in describe blocks","ref":"testing.html#best-practices"},{"type":"extras","title":"Continuous Integration - Testing Guide","doc":"The CI pipeline:\n1. Runs unit tests first\n2. Runs integration tests if unit tests pass (TBD, as we didn't add key management in CI yet)\n3. Uses secure environment variables for API keys","ref":"testing.html#continuous-integration"},{"type":"extras","title":"Troubleshooting - Testing Guide","doc":"","ref":"testing.html#troubleshooting"},{"type":"extras","title":"Common Issues - Testing Guide","doc":"1. **Integration Tests Failing**\n   - Check if `test.override.envrc` exists with valid API keys\n   - Verify external service status\n   - Check rate limits\n\n2. **Configuration Conflicts**\n   - Ensure you're not running unit and integration tests simultaneously\n   - Check for conflicting environment variables\n\n3. **Mock Issues**\n   - Verify mock data matches expected format\n   - Check if API responses have changed\n   - Update mock data as needed","ref":"testing.html#common-issues"},{"type":"extras","title":"Getting Help - Testing Guide","doc":"- Check the test output for specific error messages\n- Review the relevant test helper modules\n- Consult the external service documentation\n- Reach out to the team for assistance","ref":"testing.html#getting-help"},{"type":"extras","title":"Developing Lux with Cursor","doc":"# Developing Lux with Cursor\n\nCursor is a powerful AI-enabled IDE that can significantly enhance your development experience with Lux. This guide will help you get started with using Cursor effectively for Lux development.","ref":"cursor_development.html"},{"type":"extras","title":"Getting Started with Cursor - Developing Lux with Cursor","doc":"1. **Install Cursor**: Download and install Cursor from [cursor.sh](https://cursor.sh)\n2. **Open Your Lux Project**: Open your Lux project directory in Cursor\n3. **Enable Composer**: Press `Cmd/Ctrl + L` to open the Composer panel","ref":"cursor_development.html#getting-started-with-cursor"},{"type":"extras","title":"Key Cursor Features for Lux Development - Developing Lux with Cursor","doc":"","ref":"cursor_development.html#key-cursor-features-for-lux-development"},{"type":"extras","title":"Composer Context - Developing Lux with Cursor","doc":"The Composer is Cursor's AI pair programming interface. To make it more effective for Lux development, you should provide it with relevant context:\n\n```\nYou are an expert in Elixir, Python, Javascript, Typescript, Phoenix, Distributed Systems, GenServer, PostgreSQL, LLMs, and Agentic workflows.\n\nIn this project, we are building an open source library for general LLM-based agentic workflows and collaboration between agents.\n\nPlease follow these conventions:\n- Write concise, idiomatic Elixir code\n- Follow Phoenix conventions and best practices\n- Use functional programming patterns\n- Leverage pattern matching and guards effectively\n- Follow the Elixir Style Guide\n```","ref":"cursor_development.html#composer-context"},{"type":"extras","title":"Creating Lux Components - Developing Lux with Cursor","doc":"#### Creating Prisms\n\nWhen creating new prisms, reference the existing prism examples and tests:\n- `lib/lux/prisms/eth_balance_prism.ex`\n- `test/lux/prisms/eth_balance_prism_test.exs`\n\nExample prompt:\n```\nCreate a new prism that [describe functionality]. Please follow the same structure as the eth_balance_prism.ex, including:\n- Comprehensive documentation\n- Input/output schemas\n- Error handling\n- Unit tests\n```\n\n#### Creating Beams\n\nReference the beams guide and examples when creating new beams:\n- `guides/beams.livemd`\n- Existing beam implementations\n\nExample prompt:\n```\nCreate a new beam that [describe functionality]. Please include:\n- Proper beam configuration\n- State management\n- Error handling\n- Integration with other components\n```\n\n#### Creating Lenses\n\nWhen working with lenses, refer to:\n- `guides/lenses.livemd`\n- Existing lens implementations\n\nExample prompt:\n```\nCreate a new lens that [describe functionality]. Include:\n- Input/output transformations\n- Error handling\n- Unit tests\n```","ref":"cursor_development.html#creating-lux-components"},{"type":"extras","title":"Best Practices - Developing Lux with Cursor","doc":"1. **Use Test-Driven Development**\n   - Ask Composer to write tests first\n   - Use the test file as context when implementing the component\n\n2. **Leverage Code Examples**\n   - Keep relevant example files open\n   - Reference them in your prompts to Composer\n\n3. **Iterative Development**\n   - Break down complex components into smaller tasks\n   - Use Composer for code review and improvements\n\n4. **Documentation**\n   - Ask Composer to include comprehensive documentation\n   - Follow the existing documentation style","ref":"cursor_development.html#best-practices"},{"type":"extras","title":"Common Workflows - Developing Lux with Cursor","doc":"","ref":"cursor_development.html#common-workflows"},{"type":"extras","title":"Adding a New Feature - Developing Lux with Cursor","doc":"1. Open relevant guides and example files\n2. Ask Composer to create tests first\n3. Implement the feature with Composer's help\n4. Review and refine the implementation\n5. Add documentation","ref":"cursor_development.html#adding-a-new-feature"},{"type":"extras","title":"Debugging - Developing Lux with Cursor","doc":"1. Open relevant test and implementation files\n2. Provide Composer with error messages and context\n3. Ask for specific debugging strategies\n4. Implement fixes iteratively","ref":"cursor_development.html#debugging"},{"type":"extras","title":"Code Review - Developing Lux with Cursor","doc":"1. Open the files to be reviewed\n2. Ask Composer to:\n   - Check for common issues\n   - Suggest improvements\n   - Verify test coverage\n   - Review documentation","ref":"cursor_development.html#code-review"},{"type":"extras","title":"Tips and Tricks - Developing Lux with Cursor","doc":"1. **Keep Context Fresh**\n   - Regularly update Composer's context with relevant files\n   - Include test files for better understanding\n\n2. **Use Multi-Step Development**\n   ```\n   Step 1: \"Create the test file for the new component\"\n   Step 2: \"Implement the core functionality\"\n   Step 3: \"Add error handling and edge cases\"\n   Step 4: \"Review and optimize the code\"\n   ```\n\n3. **Leverage Code Generation**\n   - Use Composer for boilerplate code\n   - Ask for complete examples with proper imports\n\n4. **Documentation Generation**\n   - Ask Composer to generate documentation\n   - Include examples and usage patterns","ref":"cursor_development.html#tips-and-tricks"},{"type":"extras","title":"Troubleshooting - Developing Lux with Cursor","doc":"","ref":"cursor_development.html#troubleshooting"},{"type":"extras","title":"Common Issues - Developing Lux with Cursor","doc":"1. **Dependency Issues**\n   - Share your `mix.exs` and `pyproject.toml` with Composer\n   - Ask for compatible version recommendations\n\n2. **Test Failures**\n   - Provide the full test output\n   - Ask for specific fixes based on error messages\n\n3. **Integration Problems**\n   - Share the relevant component interfaces\n   - Ask for proper integration patterns","ref":"cursor_development.html#common-issues"},{"type":"extras","title":"Contributing - Developing Lux with Cursor","doc":"When contributing to Lux:\n1. Follow the guidelines in `guides/contributing.md`\n2. Use Composer to help maintain consistent code style\n3. Ensure comprehensive test coverage\n4. Include proper documentation","ref":"cursor_development.html#contributing"},{"type":"extras","title":"Resources - Developing Lux with Cursor","doc":"- [Cursor Documentation](https://cursor.sh/docs)\n- [Lux Guides](./guides/)\n- [Elixir Style Guide](https://github.com/christopheradams/elixir_style_guide)\n- [Phoenix Best Practices](https://hexdocs.pm/phoenix/overview.html)","ref":"cursor_development.html#resources"},{"type":"extras","title":"Getting Started with Lux","doc":"# Getting Started with Lux\n\nLux is a powerful language-agnostic framework for building intelligent, adaptive, and collaborative multi-agent systems. This guide will help you get started with Lux development.","ref":"getting_started.html"},{"type":"extras","title":"Prerequisites - Getting Started with Lux","doc":"Before installing Lux, ensure you have:\n\n- [asdf](https://asdf-vm.com/) version manager installed\n- Git\n- A Unix-like operating system (macOS or Linux)\n- Basic knowledge of Elixir, Python, and Node.js","ref":"getting_started.html#prerequisites"},{"type":"extras","title":"Installation - Getting Started with Lux","doc":"","ref":"getting_started.html#installation"},{"type":"extras","title":"1. Clone the Repository - Getting Started with Lux","doc":"```bash\ngit clone https://github.com/Spectral-Finance/lux.git\ncd lux\n```","ref":"getting_started.html#1-clone-the-repository"},{"type":"extras","title":"2. System Dependencies - Getting Started with Lux","doc":"#### For macOS:\n\n```bash\nmake setup-mac\n```\n\nThis will install required dependencies using Homebrew:\n- autoconf\n- automake\n- libtool\n- wxmac\n- fop\n- openssl@3\n\n#### For Linux (Debian/Ubuntu):\n\n```bash\nmake setup-linux\n```\n\nThis will install required system packages including:\n- build-essential\n- autoconf\n- libncurses5-dev\n- libwxgtk3.0-gtk3-dev\n- And other necessary dependencies","ref":"getting_started.html#2-system-dependencies"},{"type":"extras","title":"3. Project Setup - Getting Started with Lux","doc":"Run the complete setup:\n\n```bash\nmake setup\n```\n\nThis will:\n1. Configure your shell for asdf\n2. Install required asdf plugins and tools\n3. Set up project dependencies including:\n   - Elixir dependencies via mix\n   - Python dependencies via Poetry\n   - Node.js dependencies via npm","ref":"getting_started.html#3-project-setup"},{"type":"extras","title":"4. Verify Installation - Getting Started with Lux","doc":"Run the test suite to verify your installation:\n\n```bash\nmake test\n```","ref":"getting_started.html#4-verify-installation"},{"type":"extras","title":"Project Structure - Getting Started with Lux","doc":"A typical Lux project consists of:\n\n```\nlux/\n├── lib/              # Elixir source code\n├── priv/\n│   ├── python/      # Python modules and dependencies\n│   └── node/        # Node.js modules and dependencies\n├── test/            # Test files\n└── guides/          # Documentation and guides\n```","ref":"getting_started.html#project-structure"},{"type":"extras","title":"Core Concepts - Getting Started with Lux","doc":"Lux is built around several key components:\n\n1. **Agents**: Autonomous components that can interact with LLMs, process signals, and execute workflows\n2. **Signals**: Type-safe communication between components\n3. **Prisms**: Modular units of functionality that can be composed into workflows\n4. **Beams**: Orchestration layer for composing components into complex workflows\n5. **Lenses**: Integration points with external systems and APIs\n\nFor detailed information about each component, refer to their respective guides:\n- [Agents Guide](agents.livemd)\n- [Signals Guide](signals.livemd)\n- [Prisms Guide](prisms.livemd)\n- [Beams Guide](beams.livemd)\n- [Lenses Guide](lenses.livemd)","ref":"getting_started.html#core-concepts"},{"type":"extras","title":"Language Support - Getting Started with Lux","doc":"Lux supports multiple programming languages:\n\n- **Elixir**: Core framework and coordination\n- **Python**: ML/AI tasks and data processing\n- **Node.js**: Web integration and text processing\n\nEach language has its own guide:\n- [Python Guide](python.md)\n- [Node.js Guide](nodejs.md)\n- Additional language support coming soon!","ref":"getting_started.html#language-support"},{"type":"extras","title":"Development Tools - Getting Started with Lux","doc":"","ref":"getting_started.html#development-tools"},{"type":"extras","title":"Using Docker (Coming Soon) - Getting Started with Lux","doc":"A Docker-based development environment is under development and will be available soon.","ref":"getting_started.html#using-docker-coming-soon"},{"type":"extras","title":"IDE Support - Getting Started with Lux","doc":"For the best development experience, we recommend using [Cursor](https://cursor.sh) with the provided development configurations. See the [Cursor Development Guide](cursor_development.md) for setup instructions.","ref":"getting_started.html#ide-support"},{"type":"extras","title":"Next Steps - Getting Started with Lux","doc":"1. Review the [Multi-Agent Collaboration Guide](multi_agent_collaboration.livemd) for examples of building agent systems\n2. Check out the [Trading System Example](trading_system.livemd) for a complete application\n3. Learn about organizing agents in [Companies Guide](companies.md)\n4. Explore [Running a Company](running_a_company.livemd) for complex workflows","ref":"getting_started.html#next-steps"},{"type":"extras","title":"Testing and Troubleshooting - Getting Started with Lux","doc":"- Read our [Testing Guide](testing.md) for best practices\n- Check the [Troubleshooting Guide](troubleshooting.md) for common issues and solutions","ref":"getting_started.html#testing-and-troubleshooting"},{"type":"extras","title":"Contributing - Getting Started with Lux","doc":"We welcome contributions! Check out our [Contributing Guide](contributing.md) to get started.","ref":"getting_started.html#contributing"},{"type":"extras","title":"License - Getting Started with Lux","doc":"Lux is released under the MIT License. See [LICENSE](../LICENSE) for details.","ref":"getting_started.html#license"},{"type":"extras","title":"Core Concepts","doc":"# Core Concepts\n\nLux is built on several core concepts that work together to create powerful multi-agent systems. This guide provides an overview of these concepts and how they interact.","ref":"core_concepts.html"},{"type":"extras","title":"Overview - Core Concepts","doc":"The key components of Lux are:\n\n1. Agents\n2. Signals\n3. Prisms\n4. Beams\n5. Lenses\n6. Companies\n\nLet's explore each of these in detail.","ref":"core_concepts.html#overview"},{"type":"extras","title":"Agents - Core Concepts","doc":"[Detailed Guide](agents.livemd)\n\nAgents are autonomous components that combine intelligence with execution capabilities. They can:\n\n- Interact with Language Models (LLMs)\n- Process and respond to signals\n- Execute workflows\n- Maintain state and memory\n- Collaborate with other agents\n\nKey characteristics of agents:\n- Unique identifier\n- Name and description\n- Defined goal or purpose\n- LLM configuration\n- Optional memory configuration\n- Component integration (Prisms, Beams, Lenses)\n- Signal handling capabilities","ref":"core_concepts.html#agents"},{"type":"extras","title":"Signals - Core Concepts","doc":"[Detailed Guide](signals.livemd)\n\nSignals are the communication protocol in Lux. They provide type-safe, schema-validated message passing between components. A signal consists of:\n\n- Unique identifier\n- Schema identifier\n- Validated content\n- Processing metadata\n\nSignals ensure:\n- Type safety\n- Schema validation\n- Versioning\n- Compatibility checking\n- Structured communication","ref":"core_concepts.html#signals"},{"type":"extras","title":"Prisms - Core Concepts","doc":"[Detailed Guide](prisms.livemd)\n\nPrisms are modular units of functionality that can be composed into workflows. They encapsulate:\n\n- Business logic\n- Data transformations\n- External integrations\n- Validation rules\n\nKey features:\n- Input/output schemas\n- Handler functions\n- Error handling\n- Composability\n- Testing utilities","ref":"core_concepts.html#prisms"},{"type":"extras","title":"Beams - Core Concepts","doc":"[Detailed Guide](beams.livemd)\n\nBeams are the orchestration layer of Lux. They compose other components into complex workflows, supporting:\n\n- Sequential execution\n- Parallel processing\n- Conditional branching\n- Error handling\n- State management\n- Logging and monitoring\n\nA beam consists of:\n- Step sequences\n- Input/output schemas\n- Execution configuration\n- Error handling rules\n- Parameter passing","ref":"core_concepts.html#beams"},{"type":"extras","title":"Lenses - Core Concepts","doc":"[Detailed Guide](lenses.livemd)\n\nLenses provide structured interaction with external systems and APIs. They handle:\n\n- Authentication\n- Data transformation\n- Error handling\n- Response processing\n- Schema validation\n\nComponents:\n- URL endpoint\n- HTTP method configuration\n- Authentication setup\n- Schema validation\n- Response transformation","ref":"core_concepts.html#lenses"},{"type":"extras","title":"Companies - Core Concepts","doc":"[Detailed Guide](companies.md)\n\nCompanies organize agents into collaborative teams. They provide:\n\n- Role management\n- Capability registration\n- Objective tracking\n- Workflow coordination\n- Resource allocation\n\nKey concepts:\n- CEO and member roles\n- Capability definitions\n- Objective specifications\n- Success criteria\n- Execution tracking","ref":"core_concepts.html#companies"},{"type":"extras","title":"Component Interaction - Core Concepts","doc":"These components interact in the following ways:\n\n1. **Agent Communication**\n   - Agents exchange information via Signals\n   - Signals ensure type-safe communication\n   - Companies coordinate agent interactions\n\n2. **Workflow Execution**\n   - Beams orchestrate complex workflows\n   - Prisms provide modular functionality\n   - Lenses connect to external systems\n\n3. **State Management**\n   - Agents maintain internal state\n   - Signals carry state changes\n   - Companies track global state\n\n4. **Error Handling**\n   - Each component handles errors appropriately\n   - Errors propagate through the system\n   - Recovery mechanisms exist at multiple levels","ref":"core_concepts.html#component-interaction"},{"type":"extras","title":"Best Practices - Core Concepts","doc":"1. **Component Design**\n   - Keep components focused and modular\n   - Use clear naming conventions\n   - Document interfaces and behaviors\n   - Follow language-specific guidelines\n\n2. **Error Handling**\n   - Handle errors at appropriate levels\n   - Provide meaningful error messages\n   - Implement recovery strategies\n   - Log errors with context\n\n3. **Testing**\n   - Test components in isolation\n   - Test component interactions\n   - Use appropriate test types\n   - Maintain test coverage\n\n4. **Performance**\n   - Optimize cross-component communication\n   - Use appropriate data structures\n   - Consider resource usage\n   - Monitor system performance","ref":"core_concepts.html#best-practices"},{"type":"extras","title":"Language Support - Core Concepts","doc":"Lux supports multiple programming languages:\n\n- **Elixir**: Core framework and coordination\n- **Python**: ML/AI tasks and data processing\n- **Node.js**: Web integration and text processing\n\nEach language has specific guidelines and best practices detailed in:\n- [Python Guide](python.md)\n- [Node.js Guide](nodejs.md)\n- Additional language support coming soon!","ref":"core_concepts.html#language-support"},{"type":"extras","title":"Next Steps - Core Concepts","doc":"1. Follow the [Getting Started Guide](getting_started.md)\n2. Try the [Trading System Example](trading_system.livemd)\n3. Explore [Multi-Agent Collaboration](multi_agent_collaboration.livemd)\n4. Learn about [Running a Company](running_a_company.livemd)\n5. Read our [Testing Guide](testing.md) and [Troubleshooting Guide](troubleshooting.md)","ref":"core_concepts.html#next-steps"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [0.4.0] - 2025-02-20","ref":"changelog.html"},{"type":"extras","title":"Added - Changelog","doc":"- Company management system with execution engine and objectives\n- Role-based agent management for companies\n- New DSL for company and objective definitions\n- Artifact store for company execution outputs\n- Task tracking and objective process management\n- Local company hub implementation\n- Enhanced agent base functionality\n- New guides for company management and role management\n- Objective and task signal schemas\n- Company-specific signal handlers for agents","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Updated agent hub implementation for company support\n- Enhanced signal router for company-related signals\n- Improved configuration system\n- Updated OpenAI LLM integration\n- Enhanced documentation across all guides\n- Refactored agent base implementation","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Various documentation improvements and corrections\n\n## [0.2.0] - 2025-02-05","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Support for multiple named AgentHub instances\n- Improved agent lifecycle management with proper process monitoring\n- Enhanced test coverage for agent collaboration scenarios\n- Support for running integration tests asynchronously","ref":"changelog.html#added"},{"type":"extras","title":"Changed - Changelog","doc":"- Renamed `Lux.Agent.Registry` to `Lux.AgentHub` for better clarity\n- Updated agent registration to support multiple hub instances\n- Improved agent status tracking and offline detection\n- Enhanced test reliability with proper process cleanup","ref":"changelog.html#changed"},{"type":"extras","title":"Fixed - Changelog","doc":"- Agent status not updating correctly when processes terminate\n- Race conditions in agent status management tests\n- Process monitoring in multi-hub scenarios\n\n## [0.1.0] - 2025-01-16","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release of Lux framework\n- Basic agent infrastructure with configurable components\n- Agent supervision and lifecycle management\n- Communication foundation with signal system\n- Basic collaboration protocols\n- Agent discovery and capability advertisement\n- Status tracking for agents\n- Integration with OpenAI's GPT models","ref":"changelog.html#added"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2025 Boltzmann Ltd\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Agents Guide","doc":"# Agents Guide\n\n```elixir\nMix.install(\n  [\n    {:lux, \"~> 0.4.0\"},\n    {:kino, \"~> 0.14.2\"}\n  ],\n  config: [\n    lux: [\n      open_ai_models: [\n        default: \"gpt-4o-mini\"\n      ],\n      api_keys: [\n        openai: System.fetch_env!(\"LB_OPENAI_API_KEY\")\n      ]\n    ]\n  ],\n  start_applications: false\n)\n\nMix.Task.run(\"setup\", install_deps: false)\n\nApplication.put_env(:venomous, :snake_manager, %{\n  python_opts: [\n    module_paths: [\n      Lux.Python.module_path(),\n      Lux.Python.module_path(:deps)\n    ],\n    python_executable: \"python3\"\n  ]\n})\n\nApplication.ensure_all_started([:lux, :ex_unit, :kino])\n```","ref":"agents.html"},{"type":"extras","title":"Section - Agents Guide","doc":"Agents are autonomous components in Lux that can interact with LLMs, process signals, and execute workflows. They combine intelligence with execution capabilities, making them perfect for building conversational and agentic applications.","ref":"agents.html#section"},{"type":"extras","title":"Overview - Agents Guide","doc":"An Agent consists of:\n\n* A unique identifier\n* Name and description\n* Goal or purpose\n* LLM configuration\n* Memory configuration (optional)\n* Optional components (Prisms, Beams, Lenses)\n* Signal handling capabilities","ref":"agents.html#overview"},{"type":"extras","title":"Creating an Agent - Agents Guide","doc":"Here's a basic example of an Agent:\n\n```elixir\ndefmodule MyApp.Agents.Assistant do\n  use Lux.Agent,\n    name: \"Simple Assistant\",\n    description: \"A helpful assistant that can engage in conversations\",\n    goal: \"Help users by providing clear and accurate responses\",\n    llm_config: %{\n      messages: [\n        %{\n          role: \"system\",\n          content: \"\"\"\n          You are Simple Assistant, a helpful assistant that can engage in conversations.\n          Your goal is: Help users by providing clear and accurate responses\n          \"\"\"\n        }\n      ]\n    }\nend\n\n{:ok, pid} = Kino.start_child({MyApp.Agents.Assistant, []})\nMyApp.Agents.Assistant.send_message(pid, \"Hello!\")\n```","ref":"agents.html#creating-an-agent"},{"type":"extras","title":"Agent Configuration - Agents Guide","doc":"","ref":"agents.html#agent-configuration"},{"type":"extras","title":"Memory Configuration - Agents Guide","doc":"Agents can be configured with memory to maintain state and recall previous interactions. Memory is particularly useful for maintaining conversation context and recalling previous decisions:\n\n```elixir\ndefmodule MyApp.Agents.MemoryAgent do\n  use Lux.Agent,\n    name: \"Memory-Enabled Assistant\",\n    description: \"An assistant that remembers past interactions\",\n    goal: \"Help users while maintaining context of conversations\",\n    memory_config: %{\n      backend: Lux.Memory.SimpleMemory,\n      name: :memory_agent_store\n    }\nend\n\nKino.nothing()\n```\n\nMemory is automatically used in chat interactions when enabled:\n\n```elixir\nframe = Kino.Frame.new() |> Kino.render()\n\n# Start an agent with memory\n{:ok, pid} = Kino.start_child({MyApp.Agents.MemoryAgent, []})\n\n# Chat with memory enabled (remembers context)\n{:ok, response1} = MyApp.Agents.MemoryAgent.send_message(pid, \"My name is John\", use_memory: true)\nKino.Frame.append(frame, response1)\n{:ok, response2} = MyApp.Agents.MemoryAgent.send_message(pid, \"What's my name?\", use_memory: true)\nKino.Frame.append(frame, response2)\n\n# Chat without memory (no context)\n{:ok, response3} = MyApp.Agents.MemoryAgent.send_message(pid, \"What's my name?\", use_memory: false)\nKino.Frame.append(frame, response3)\n\nKino.nothing()\n```\n\nYou can control memory context size in chat:\n\n```elixir\n# Limit memory context to last 3 interactions\n{:ok, response} = MyApp.Agents.MemoryAgent.send_message(\n  pid,\n  \"Summarize our conversation\",\n  use_memory: true,\n  max_memory_context: 3\n)\n```\n\nThe memory system stores each interaction with metadata:\n\n* User messages are stored with `role: :user`\n* Agent responses are stored with `role: :assistant`\n* All interactions are timestamped and retrievable\n* Memory is automatically cleaned up when the agent terminates","ref":"agents.html#memory-configuration"},{"type":"extras","title":"Scheduled Actions - Agents Guide","doc":"Agents can perform scheduled, recurring tasks using prisms or beams. Each scheduled action runs at specified intervals and is supervised by the Lux runtime:\n\n```elixir\ndefmodule MyApp.Agents.MonitorAgent do\n  use Lux.Agent,\n    name: \"System Monitor\",\n    description: \"Monitors system health and performance\",\n    goal: \"Maintain system health through regular checks\",\n    prisms: [MyApp.Prisms.HealthCheck, MyApp.Prisms.MetricsCollector],\n    # beams: [MyApp.Beams.SystemDiagnostics],\n    scheduled_actions: [\n      # Run health check every minute\n      {MyApp.Prisms.HealthCheck, 60_000, %{scope: :full}, %{\n        name: \"health_check\",  # Optional name, defaults to module name\n        timeout: 30_000        # Optional timeout, defaults to 60 seconds\n      }},\n      # Run system diagnostics every 5 minutes\n      {MyApp.Beams.SystemDiagnostics, 300_000, %{deep_scan: true}, %{}}\n    ]\nend\n\nKino.nothing()\n```\n\nScheduled actions are defined as tuples of `{module, interval_ms, input, opts}` where:\n\n* `module`: The prism or beam to execute\n* `interval_ms`: Time in milliseconds between executions\n* `input`: Map of input parameters for the action\n* `opts`: Configuration options\n  * `name`: Optional name for the action (defaults to module name)\n  * `timeout`: Maximum execution time in milliseconds (defaults to 60 seconds)\n\nEach scheduled action:\n\n* Runs in a supervised Task\n* Automatically reschedules itself after completion\n* Has error handling and logging\n* Receives the full agent context in its execution\n\nExample prism for scheduled actions:\n\n```elixir\ndefmodule MyApp.Prisms.HealthCheck do\n  use Lux.Prism,\n    description: \"System health monitoring\"\n\n  require Logger\n\n  def handler(params, agent) do\n    # Access agent configuration using Access protocol\n    agent_name = agent[:name]\n\n    # Perform health check\n    with {:ok, metrics} <- check_system_health(params) do\n      Logger.info(\"Health check completed for #{agent_name}\")\n      {:ok, metrics}\n    end\n  end\n\n  defp check_system_health(_params), do: {:ok, %{result: \"health check result\"}}\nend\n\ndefmodule MyApp.Prisms.MetricsCollector do\n  use Lux.Prism,\n    description: \"System metrics collector\"\n\n  require Logger\n\n  def handler(params, agent) do\n    # Access agent configuration using Access protocol\n    agent_name = agent[:name]\n\n    # Perform collection\n    with {:ok, metrics} <- collect_metrics(params) do\n      Logger.info(\"Metrics collected by #{agent_name}\")\n      {:ok, metrics}\n    end\n  end\n\n  defp collect_metrics(_params), do: {:ok, %{result: \"collected metrics\"}}\nend\n\nalias MyApp.Agents.MonitorAgent\n\n{:ok, monitor_agent_pid} = Kino.start_child({MonitorAgent, []})\nagent = MonitorAgent.get_state(monitor_agent_pid)\n\nMonitorAgent.chat(agent, \"Can you check current status of system?\")\n```\n\nThe agent runtime ensures that:\n\n* Failed actions don't crash the agent\n* Timeouts are properly handled\n* Actions are rescheduled even after errors\n* All executions are logged","ref":"agents.html#scheduled-actions"},{"type":"extras","title":"LLM Configuration - Agents Guide","doc":"Control how your agent interacts with language models:\n\n```elixir\nllm_config = %{\n  # API configuration\n  api_key: \" \",\n  model: Application.get_env(:lux, :open_ai_models)[:default],\n  \n  # Response characteristics\n  temperature: 0.7,        # 0.0-1.0: lower = more focused, higher = more creative\n  \n  # System messages for personality\n  messages: [\n    %{\n      role: \"system\",\n      content: \"You are a helpful assistant...\"\n    }\n  ]\n}\n```","ref":"agents.html#llm-configuration"},{"type":"extras","title":"Structured Responses - Agents Guide","doc":"Define schemas to get structured responses from your agent:\n\n```elixir\ndefmodule MyApp.Schemas.ResponseSchema do\n  use Lux.SignalSchema,\n    schema: %{\n      type: :object,\n      properties: %{\n        message: %{type: :string, description: \"The content of the response\"}\n      },\n      required: [:message]\n    }\nend\n\ndefmodule MyApp.Agents.StructuredAssistant do\n  use Lux.Agent,\n    name: \"Structured Assistant\",\n    description: \"An assistant that provides structured responses\",\n    goal: \"Provide clear, structured responses to user queries\",\n    response_schema: MyApp.Schemas.ResponseSchema,\n    llm_config: %{\n      api_key: Lux.Config.openai_api_key(),\n      messages: [\n        %{\n          role: \"system\",\n          content: \"\"\"\n          You are Structured Assistant, an assistant that provides structured responses.\n          Your goal is: Provide clear, structured responses to user queries\n          \"\"\"\n        }\n      ]\n    }\nend\n\n{:ok, pid} = Kino.start_child({MyApp.Agents.StructuredAssistant, []})\nMyApp.Agents.StructuredAssistant.send_message(pid, \"What is your goal?\")\n```","ref":"agents.html#structured-responses"},{"type":"extras","title":"Agent Types - Agents Guide","doc":"","ref":"agents.html#agent-types"},{"type":"extras","title":"Chat Agent - Agents Guide","doc":"A simple conversational agent:\n\n```elixir\ndefmodule MyApp.Agents.ChatAgent do\n  use Lux.Agent,\n    name: \"Chat Assistant\",\n    description: \"A conversational assistant\",\n    goal: \"Engage in helpful dialogue\",\n    llm_config: %{\n      messages: [\n        %{\n          role: \"system\",\n          content: \"\"\"\n          You are Chat Assistant, a conversational assistant.\n          Your goal is: Engage in helpful dialogue\n\n          Respond to users in a clear and concise manner.\n          \"\"\"\n        }\n      ]\n    }\nend\n\n{:ok, chat_agent_pid} = Kino.start_child({MyApp.Agents.ChatAgent, []})\nMyApp.Agents.ChatAgent.send_message(chat_agent_pid, \"What can you do?\")\n```","ref":"agents.html#chat-agent"},{"type":"extras","title":"Personality-Driven Agent - Agents Guide","doc":"An agent with a distinct personality:\n\n```elixir\ndefmodule MyApp.Agents.FunAgent do\n  use Lux.Agent,\n    name: \"Fun Assistant\",\n    description: \"A playful and witty AI assistant who loves jokes\",\n    goal: \"Make conversations fun and engaging while being helpful\",\n    llm_config: %{\n      temperature: 0.8,  # Higher temperature for more creative responses\n      messages: [\n        %{\n          role: \"system\",\n          content: \"\"\"\n          You are Fun Assistant, a playful and witty AI assistant who loves jokes.\n          Your goal is: Make conversations fun and engaging while being helpful\n          \n          Keep your responses light-hearted but still helpful.\n          When explaining technical concepts, use fun analogies and examples.\n          \"\"\"\n        }\n      ]\n    }\nend\n\n{:ok, fun_agent_pid} = Kino.start_child({MyApp.Agents.FunAgent, []})\nMyApp.Agents.FunAgent.send_message(fun_agent_pid, \"Hey, how are you?\")\n```","ref":"agents.html#personality-driven-agent"},{"type":"extras","title":"Defining Agents via JSON - Agents Guide","doc":"Agents can be defined and loaded dynamically using JSON configuration. This is particularly useful when:\n- You need to create agents dynamically at runtime\n- You want to store agent configurations in a database or files\n- You're building a system that allows users to define their own agents","ref":"agents.html#defining-agents-via-json"},{"type":"extras","title":"Basic JSON Structure - Agents Guide","doc":"Here's a basic agent configuration in JSON:\n\n```json\n{\n  \"id\": \"research-agent-1\",\n  \"name\": \"Research Assistant\",\n  \"description\": \"A specialized agent for conducting research\",\n  \"goal\": \"Provide thorough and accurate research results\",\n  \"module\": \"ResearchAgent\",\n  \"template\": \"company_agent\",\n  \"template_opts\": {\n    \"llm_config\": {\n      \"temperature\": 0.3\n    }\n  },\n  \"llm_config\": {\n    \"model\": \"gpt-4\",\n    \"temperature\": 0.7,\n    \"messages\": [\n      {\n        \"role\": \"system\",\n        \"content\": \"You are a research assistant focused on providing accurate information.\"\n      }\n    ]\n  }\n}\n```","ref":"agents.html#basic-json-structure"},{"type":"extras","title":"Loading JSON Agents - Agents Guide","doc":"You can load agents from various JSON sources:\n\n```elixir\n# From a JSON string\njson = ~s({\n  \"id\": \"researcher-1\",\n  \"name\": \"Research Assistant\",\n  \"description\": \"Conducts thorough research\",\n  \"goal\": \"Provide accurate research results\",\n  \"module\": \"ResearchAgent\"\n})\n\n{:ok, [agent_module]} = Lux.Agent.from_json(json)\n{:ok, pid} = agent_module.start_link()\n\n# From a JSON file\n{:ok, [agent_module]} = Lux.Agent.from_json(\"agents/researcher.json\")\n\n# From a directory of JSON files\n{:ok, agent_modules} = Lux.Agent.from_json(\"agents/\")\n\n# From multiple specific files\n{:ok, agent_modules} = Lux.Agent.from_json([\n  \"agents/researcher.json\",\n  \"agents/writer.json\"\n])\n```","ref":"agents.html#loading-json-agents"},{"type":"extras","title":"Configuration Options - Agents Guide","doc":"The JSON configuration supports all standard agent options:\n\n```json\n{\n  \"id\": \"advanced-agent-1\",\n  \"name\": \"Advanced Agent\",\n  \"description\": \"An agent with advanced configuration\",\n  \"goal\": \"Demonstrate advanced agent capabilities\",\n  \"module\": \"AdvancedAgent\",\n  \n  // Optional template configuration\n  \"template\": \"company_agent\",\n  \"template_opts\": {\n    \"llm_config\": {\n      \"temperature\": 0.5\n    }\n  },\n  \n  // LLM configuration\n  \"llm_config\": {\n    \"model\": \"gpt-4\",\n    \"temperature\": 0.7,\n    \"messages\": [\n      {\n        \"role\": \"system\",\n        \"content\": \"You are an advanced agent...\"\n      }\n    ]\n  },\n  \n  // Memory configuration\n  \"memory_config\": {\n    \"backend\": \"Lux.Memory.SimpleMemory\",\n    \"name\": \"advanced_agent_memory\"\n  },\n  \n  // Component lists\n  \"prisms\": [\n    \"MyApp.Prisms.DataAnalysis\",\n    \"MyApp.Prisms.TextProcessor\"\n  ],\n  \"beams\": [\n    \"MyApp.Beams.WorkflowEngine\",\n    \"MyApp.Beams.DataPipeline\"\n  ],\n  \"lenses\": [\n    \"MyApp.Lenses.DataVisualizer\"\n  ],\n  \n  // Signal handlers\n  \"signal_handlers\": [\n    {\n      \"schema\": \"MyApp.Schemas.TaskSignal\",\n      \"handler\": \"MyApp.Handlers.TaskHandler\"\n    }\n  ],\n  \n  // Scheduled actions\n  \"scheduled_actions\": [\n    {\n      \"module\": \"MyApp.Prisms.HealthCheck\",\n      \"interval_ms\": 60000,\n      \"input\": {\n        \"scope\": \"full\"\n      },\n      \"opts\": {\n        \"name\": \"health_check\",\n        \"timeout\": 30000\n      }\n    }\n  ]\n}\n```","ref":"agents.html#configuration-options"},{"type":"extras","title":"Best Practices - Agents Guide","doc":"1. **Unique Identifiers**\n   - Always provide unique `id` and `module` names\n   - Use descriptive module names that reflect the agent's purpose\n\n2. **Module Names**\n   - Module names can be provided with or without the \"Elixir.\" prefix\n   - Example: `\"module\": \"MyApp.Agents.Researcher\"` or `\"module\": \"Researcher\"`\n\n3. **Component References**\n   - All component references (prisms, beams, lenses) must be valid module names\n   - Components must be compiled and available in the application\n\n4. **Template Options**\n   - When using templates like `:company_agent`, provide appropriate `template_opts`\n   - Template-specific options are preserved as string keys in the configuration\n\n5. **Error Handling**\n   - The loader will skip invalid configurations when loading multiple agents\n   - Always check the return value for success/failure","ref":"agents.html#best-practices"},{"type":"extras","title":"Example: Company Agent - Agents Guide","doc":"Here's a complete example of a company agent configuration:\n\n```json\n{\n  \"id\": \"content-writer-1\",\n  \"name\": \"Content Writer\",\n  \"description\": \"Specialized in creating high-quality content\",\n  \"goal\": \"Create engaging and informative content\",\n  \"module\": \"ContentWriter\",\n  \"template\": \"company_agent\",\n  \"template_opts\": {\n    \"llm_config\": {\n      \"temperature\": 0.7\n    }\n  },\n  \"llm_config\": {\n    \"model\": \"gpt-4\",\n    \"messages\": [\n      {\n        \"role\": \"system\",\n        \"content\": \"You are a professional content writer...\"\n      }\n    ]\n  },\n  \"signal_handlers\": [\n    {\n      \"schema\": \"Lux.Schemas.Companies.TaskSignal\",\n      \"handler\": \"MyApp.Handlers.ContentTaskHandler\"\n    },\n    {\n      \"schema\": \"Lux.Schemas.Companies.ObjectiveSignal\",\n      \"handler\": \"MyApp.Handlers.ContentObjectiveHandler\"\n    }\n  ]\n}\n```\n\nLet's create and use this agent:\n\n```elixir\n# Write the configuration to a file\njson = ~s({\n  \"id\": \"writer-1\",\n  \"name\": \"Content Writer\",\n  \"description\": \"Creates high-quality content\",\n  \"goal\": \"Create engaging content\",\n  \"module\": \"ContentWriter\",\n  \"template\": \"company_agent\",\n  \"template_opts\": {\n    \"llm_config\": {\n      \"temperature\": 0.7\n    }\n  }\n})\n\n# Create a temporary file\npath = Path.join(System.tmp_dir!(), \"content_writer.json\")\nFile.write!(path, json)\n\n# Load and start the agent\n{:ok, [ContentWriter]} = Lux.Agent.from_json(path)\n{:ok, pid} = ContentWriter.start_link()\n\n# Chat with the agent\nContentWriter.send_message(pid, \"What kind of content can you create?\")\n```","ref":"agents.html#example-company-agent"},{"type":"extras","title":"Validation and Error Handling - Agents Guide","doc":"The JSON loader performs several validations:\n\n1. **Required Fields**\n   - id\n   - name\n   - description\n   - goal\n   - module\n\n2. **Type Checking**\n   - Ensures all fields have correct types\n   - Validates module names and references\n\n3. **Template Validation**\n   - Verifies template existence\n   - Validates template-specific options\n\nExample error handling:\n\n```elixir\n# Handle potential errors\ncase Lux.Agent.from_json(\"agents/\") do\n  {:ok, modules} ->\n    Enum.map(modules, fn module ->\n      case module.start_link() do\n        {:ok, pid} -> {:ok, {module, pid}}\n        error -> {:error, {module, error}}\n      end\n    end)\n    \n  {:error, reason} ->\n    Logger.error(\"Failed to load agents: #{inspect(reason)}\")\n    {:error, reason}\nend\n```","ref":"agents.html#validation-and-error-handling"},{"type":"extras","title":"Using Agents - Agents Guide","doc":"","ref":"agents.html#using-agents"},{"type":"extras","title":"Starting an Agent - Agents Guide","doc":"Agents can be started as GenServers:\n\n```elixir\n{:ok, pid} = Kino.start_child({MyApp.Agents.MemoryAgent, [name: :another_agent]})\n```","ref":"agents.html#starting-an-agent"},{"type":"extras","title":"Sending Messages - Agents Guide","doc":"Chat with your agent:\n\n```elixir\nframe = Kino.Frame.new() |> Kino.render()\n\n# Basic chat (default timeout is 120 seconds)\n{:ok, response} = MyApp.Agents.ChatAgent.send_message(pid, \"Hello!\")\nKino.Frame.append(frame, response)\n\n# With custom timeout\n{:ok, response} = MyApp.Agents.ChatAgent.send_message(pid, \"Tell me a joke!\", timeout: 30_000)\nKino.Frame.append(frame, response)\n\nKino.nothing()\n```","ref":"agents.html#sending-messages"},{"type":"extras","title":"Working with Memory - Agents Guide","doc":"Access an agent's memory:\n\n```elixir\nagent = MyApp.Agents.ChatAgent.get_state(pid)\n\nframe = Kino.Frame.new() |> Kino.render()\n\n# Get recent interactions\n{:ok, recent} = Lux.Memory.SimpleMemory.recent(agent.memory_pid, 5)\nKino.Frame.append(frame, recent)\n\n# Search for specific content\n{:ok, matches} = Lux.Memory.SimpleMemory.search(agent.memory_pid, \"specific topic\")\nKino.Frame.append(frame, matches)\n\n# # Get interactions within a time window\nstart_time = DateTime.utc_now() |> DateTime.add(-3600) # 1 hour ago\nend_time = DateTime.utc_now()\n{:ok, window} = Lux.Memory.SimpleMemory.window(agent.memory_pid, start_time, end_time)\nKino.Frame.append(frame, window)\n\nKino.nothing()\n```","ref":"agents.html#working-with-memory"},{"type":"extras","title":"Best Practices - Agents Guide","doc":"1. **Agent Design**\n\n   * Give agents clear, focused purposes\n   * Use descriptive names and goals\n   * Keep system messages concise but informative\n\n2. **Configuration**\n\n   * Use `Lux.Config` for API keys\n   * Use application config for model selection\n   * Choose appropriate temperature settings\n   * Set reasonable timeouts for long-running operations\n\n3. **Error Handling**\n\n   * Handle API errors gracefully\n   * Provide meaningful error messages\n   * Consider retry strategies for transient failures\n\n4. **Testing**\n\n   * Test agent behavior with different inputs\n   * Mock LLM responses in tests\n   * Verify structured response handling\n\n```elixir\ndefmodule MyApp.Agents.ChatAgentTest do\n  use UnitCase, async: true\n\n  alias MyApp.Agents.ChatAgent\n\n  setup do\n    {:ok, pid} = ChatAgent.start_link(%{name: :test_agent})\n    {:ok, agent: pid}\n  end\n\n  test \"can chat with the agent\", %{agent: pid} do\n    {:ok, response} = ChatAgent.send_message(pid, \"Hello!\")\n    assert is_binary(response)\n    assert String.length(response) > 0\n  end\nend\n\nExUnit.run()\n```","ref":"agents.html#best-practices"},{"type":"extras","title":"Advanced Features - Agents Guide","doc":"","ref":"agents.html#advanced-features"},{"type":"extras","title":"Signal Handling - Agents Guide","doc":"Agents can process signals from other components:\n\n```elixir\ndefmodule MyApp.Agents.SignalAwareAgent do\n  use Lux.Agent,\n    signal_handlers: [\n      {MyApp.Schemas.TaskSignal, MyApp.Prisms.TaskProcessor}\n    ]\nend\n\ndefmodule MyApp.Prisms.TaskProcessor do\n  use Lux.Prism\n\n  def handler(_signal, _agent) do\n    {:ok, \"Signal processed\"}\n  end\nend\n\n{:ok, pid} = Kino.start_child({MyApp.Agents.SignalAwareAgent, %{}})\n\n# send singal to agent\nMyApp.Agents.SignalAwareAgent.send_message(\n  pid,\n  {:signal,\n   %{\n     schema_id: MyApp.Schemas.TaskSignal,\n     payload: %{data: \"this signal data\"}\n   }}\n)\n```","ref":"agents.html#signal-handling"},{"type":"extras","title":"Component Integration - Agents Guide","doc":"Combine agents with other Lux components:\n\n```elixir\ndefmodule MyApp.Agents.SmartAgent do\n  use Lux.Agent,\n    name: \"Smart Assistant\",\n    prisms: [MyApp.Prisms.DataAnalysis],\n    beams: [MyApp.Beams.TaskProcessor],\n    lenses: [MyApp.Lenses.DataViewer]\n    # ... rest of config ...\nend\n\nKino.nothing()\n```\n\n<!-- livebook:{\"offset\":13357,\"stamp\":{\"token\":\"XCP.5uDaDN_ax0taOD_UDP8WfS0Uqs8jhY9Vuvzs_U1nf8QawsDmFPRylwoenPaXdFgU5DomWyZL5CDo6P7xq2Bl8gHxdbBAdV-tIAxr8ldurMXQvw1Gcf06X3z3aFeZJmrI0W_pp8uoLoBAzhpTYXgeuksT_UXdf8UQdbHlutFi3uRV38cjZ8Gv2Gs3yWm8-I1YF7DJqBQTOGgp0eNdpHEddDfiBRNX\",\"version\":2}} -->","ref":"agents.html#component-integration"},{"type":"extras","title":"Beams Guide","doc":"<!-- livebook:{\"persist_outputs\":true} -->\n\n# Beams Guide\n\n```elixir\nMix.install(\n  [\n    {:lux, \"~> 0.4.0\"}\n    {:kino, \"~> 0.14.2\"}\n  ],\n  start_applications: false\n)\nMix.Task.run(\"setup\", install_deps: false)\n\nApplication.put_env(:venomous, :snake_manager, %{\n  python_opts: [\n    module_paths: [\n      Lux.Python.module_path(),\n      Lux.Python.module_path(:deps)\n    ],\n    python_executable: \"python3\"\n  ]\n})\n\nApplication.ensure_all_started([:lux, :kino, :ex_unit])\n```","ref":"beams.html"},{"type":"extras","title":"Overview - Beams Guide","doc":"Beams are the orchestration layer of Lux, allowing you to compose Prisms, Lenses, and other components into complex workflows. They support sequential, parallel, and conditional execution with rich error handling and logging.\n\nA Beam consists of:\n\n* A sequence of steps\n* Input and output schemas\n* Execution configuration\n* Error handling and logging\n* Parameter passing between steps","ref":"beams.html#overview"},{"type":"extras","title":"Creating a Beam - Beams Guide","doc":"Here's a basic example of a Beam:\n\n```elixir\ndefmodule MyApp.Beams.ContentProcessor do\n  use Lux.Beam,\n    name: \"Content Processor\",\n    description: \"Processes and enriches content\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        text: %{type: :string},\n        language: %{type: :string},\n        enrich: %{type: :boolean, default: true}\n      },\n      required: [\"text\"]\n    },\n    output_schema: %{\n      type: :object,\n      properties: %{\n        sentiment: %{type: :string},\n        entities: %{type: :array, items: %{type: :string}},\n        summary: %{type: :string}\n      }\n    },\n    generate_execution_log: true\n\n  sequence do\n    step(:sentiment, Lux.Prisms.SentimentAnalysisPrism, [:input])\n\n    branch {__MODULE__, :should_enrich?} do\n      true ->\n        parallel do\n          step(:entities, MyApp.Prisms.EntityExtraction, [:input], retries: 2)\n\n          step(:summary, MyApp.Prisms.TextSummarization, [:input],\n            timeout: :timer.seconds(30)\n          )\n        end\n\n      false ->\n        step(:skip, MyApp.Prisms.NoOp, %{})\n    end\n  end\n\n  def should_enrich?(ctx) do\n    Map.get(ctx.input, :enrich, true)\n  end\nend\n\nKino.nothing()\n```\n\nBefore run defined Beam, we need to define some Prisms that it will use.\n\n```elixir\ndefmodule MyApp.Prisms.EntityExtraction do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: [\"\"]}}\n  end\nend\n\ndefmodule MyApp.Prisms.TextSummarization do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: \"A short summary\"}}\n  end\nend\n\ndefmodule MyApp.Prisms.NoOp do\n  use Lux.Prism\n\n  def handler(input, _ctx) do\n    {:ok, input}\n  end\nend\n\nKino.nothing()\n```\n\nYou can run defined Beam with `run/2` function. You can inspect entire steps and their outputs in `log`.\n\n```elixir\nframe = Kino.Frame.new() |> Kino.render()\n\n{:ok, result, log} = MyApp.Beams.ContentProcessor.run(%{\n  enrich: true,\n  text: \"hello world\",\n  language: \"en\"\n})\n\nKino.Frame.append(frame, result)\nKino.Frame.append(frame, log)\nKino.nothing()\n```","ref":"beams.html#creating-a-beam"},{"type":"extras","title":"Step Types - Beams Guide","doc":"","ref":"beams.html#step-types"},{"type":"extras","title":"Sequential Steps - Beams Guide","doc":"Execute steps one after another:\n\n```elixir\nimport Lux.Beam\n\nsequence do\n  step(:first, FirstPrism, %{param: :value})\n  step(:second, SecondPrism, [:steps, :first, :result])\n  step(:third, ThirdPrism, [:steps, :third, :result])\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:sequence,\n [\n   %{\n     id: :first,\n     module: FirstPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: %{param: :value}\n   },\n   %{\n     id: :second,\n     module: SecondPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: [:steps, :first, :result]\n   },\n   %{\n     id: :third,\n     module: ThirdPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: [:steps, :third, :result]\n   }\n ]}\n```","ref":"beams.html#sequential-steps"},{"type":"extras","title":"Parallel Steps - Beams Guide","doc":"Execute steps concurrently:\n\n```elixir\nparallel do\n  step(:analysis, AnalysisPrism, %{data: :input})\n  step(:validation, ValidationPrism, %{data: :input})\n  step(:enrichment, EnrichmentPrism, %{data: :input})\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:parallel,\n [\n   %{\n     id: :analysis,\n     module: AnalysisPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: %{data: :input}\n   },\n   %{\n     id: :validation,\n     module: ValidationPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: %{data: :input}\n   },\n   %{\n     id: :enrichment,\n     module: EnrichmentPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: %{data: :input}\n   }\n ]}\n```","ref":"beams.html#parallel-steps"},{"type":"extras","title":"Conditional Steps - Beams Guide","doc":"Branch based on conditions:\n\n```elixir\nbranch {__MODULE__, :check_condition} do\n  :path_a ->\n    sequence do\n      step(:a1, PathAPrism, %{})\n      step(:a2, PathAPrism2, %{})\n    end\n\n  :path_b ->\n    sequence do\n      step(:b1, PathBPrism, %{})\n      step(:b2, PathBPrism2, %{})\n    end\n\n  _ ->\n    step(:default, DefaultPrism, %{})\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:branch, {nil, :check_condition},\n [\n   path_a: {:sequence,\n    [\n      %{\n        id: :a1,\n        module: PathAPrism,\n        opts: %{\n          timeout: 300000,\n          dependencies: [],\n          fallback: nil,\n          retries: 0,\n          retry_backoff: 1000,\n          track: false,\n          store_io: false\n        },\n        params: %{}\n      },\n      %{\n        id: :a2,\n        module: PathAPrism2,\n        opts: %{\n          timeout: 300000,\n          dependencies: [],\n          fallback: nil,\n          retries: 0,\n          retry_backoff: 1000,\n          track: false,\n          store_io: false\n        },\n        params: %{}\n      }\n    ]},\n   path_b: {:sequence,\n    [\n      %{\n        id: :b1,\n        module: PathBPrism,\n        opts: %{\n          timeout: 300000,\n          dependencies: [],\n          fallback: nil,\n          retries: 0,\n          retry_backoff: 1000,\n          track: false,\n          store_io: false\n        },\n        params: %{}\n      },\n      %{\n        id: :b2,\n        module: PathBPrism2,\n        opts: %{\n          timeout: 300000,\n          dependencies: [],\n          fallback: nil,\n          retries: 0,\n          retry_backoff: 1000,\n          track: false,\n          store_io: false\n        },\n        params: %{}\n      }\n    ]},\n   _: %{\n     id: :default,\n     module: DefaultPrism,\n     opts: %{\n       timeout: 300000,\n       dependencies: [],\n       fallback: nil,\n       retries: 0,\n       retry_backoff: 1000,\n       track: false,\n       store_io: false\n     },\n     params: %{}\n   }\n ]}\n```","ref":"beams.html#conditional-steps"},{"type":"extras","title":"Parameter References - Beams Guide","doc":"","ref":"beams.html#parameter-references"},{"type":"extras","title":"Basic References - Beams Guide","doc":"Reference previous step outputs:\n\n```elixir\nstep(:data, DataPrism, %{value: :input_value})\nstep(:process, ProcessPrism, %{data: [:steps, :data, :result]})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :process,\n  module: ProcessPrism,\n  opts: %{\n    timeout: 300000,\n    dependencies: [],\n    fallback: nil,\n    retries: 0,\n    retry_backoff: 1000,\n    track: false,\n    store_io: false\n  },\n  params: %{data: [:steps, :data, :result]}\n}\n```","ref":"beams.html#basic-references"},{"type":"extras","title":"Nested References - Beams Guide","doc":"Access nested values:\n\n```elixir\nstep(:complex, ComplexPrism, %{\n  value: [:steps, :data, :result, :nested, :value],\n  config: [:steps, :settings, :result]\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :complex,\n  module: ComplexPrism,\n  opts: %{\n    timeout: 300000,\n    dependencies: [],\n    fallback: nil,\n    retries: 0,\n    retry_backoff: 1000,\n    track: false,\n    store_io: false\n  },\n  params: %{value: [:steps, :data, :result, :nested, :value], config: [:steps, :settings, :result]}\n}\n```","ref":"beams.html#nested-references"},{"type":"extras","title":"Multiple References - Beams Guide","doc":"Combine multiple references:\n\n```elixir\nstep(:combine, CombinePrism, %{\n  first: [:steps, :step1, :result],\n  second: [:steps, :step2, :result],\n  third: [:steps, :step3, :result]\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :combine,\n  module: CombinePrism,\n  opts: %{\n    timeout: 300000,\n    dependencies: [],\n    fallback: nil,\n    retries: 0,\n    retry_backoff: 1000,\n    track: false,\n    store_io: false\n  },\n  params: %{\n    first: [:steps, :step1, :result],\n    second: [:steps, :step2, :result],\n    third: [:steps, :step3, :result]\n  }\n}\n```","ref":"beams.html#multiple-references"},{"type":"extras","title":"Step Configuration - Beams Guide","doc":"","ref":"beams.html#step-configuration"},{"type":"extras","title":"Timeouts - Beams Guide","doc":"```elixir\nstep(:long_running, LongPrism, %{}, timeout: :timer.minutes(10))\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :long_running,\n  module: LongPrism,\n  opts: %{\n    timeout: 600000,\n    dependencies: [],\n    fallback: nil,\n    retries: 0,\n    retry_backoff: 1000,\n    track: false,\n    store_io: false\n  },\n  params: %{}\n}\n```","ref":"beams.html#timeouts"},{"type":"extras","title":"Retries - Beams Guide","doc":"```elixir\nstep(:flaky, FlakyPrism, %{},\n  retries: 3,\n  retry_backoff: 1000\n)\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :flaky,\n  module: FlakyPrism,\n  opts: %{\n    timeout: 300000,\n    dependencies: [],\n    fallback: nil,\n    retries: 3,\n    retry_backoff: 1000,\n    track: false,\n    store_io: false\n  },\n  params: %{}\n}\n```","ref":"beams.html#retries"},{"type":"extras","title":"Dependencies - Beams Guide","doc":"```elixir\nstep(:dependent, DependentPrism, %{}, dependencies: [\"step1\", \"step2\"])\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :dependent,\n  module: DependentPrism,\n  opts: %{\n    timeout: 300000,\n    dependencies: [\"step1\", \"step2\"],\n    fallback: nil,\n    retries: 0,\n    retry_backoff: 1000,\n    track: false,\n    store_io: false\n  },\n  params: %{}\n}\n```","ref":"beams.html#dependencies"},{"type":"extras","title":"Execution Logging - Beams Guide","doc":"```elixir\nstep(:important, ImportantPrism, %{}, store_io: true)\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{\n  id: :important,\n  module: ImportantPrism,\n  opts: %{\n    timeout: 300000,\n    dependencies: [],\n    fallback: nil,\n    retries: 0,\n    retry_backoff: 1000,\n    track: false,\n    store_io: true\n  },\n  params: %{}\n}\n```","ref":"beams.html#execution-logging"},{"type":"extras","title":"Error Handling - Beams Guide","doc":"","ref":"beams.html#error-handling"},{"type":"extras","title":"Basic Error Handling - Beams Guide","doc":"```elixir\ndefmodule MyApp.Beams.RobustBeam do\n  use Lux.Beam\n\n  sequence do\n    step(:risky, MyApp.Prisms.RiskyPrism, %{},\n      retries: 3,\n      retry_backoff: 1000,\n      fallback: MyApp.Fallbacks.RiskyFallback\n    )\n  end\nend\n\ndefmodule MyApp.Prisms.RiskyPrism do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:error, :too_risky}\n  end\nend\n\ndefmodule MyApp.Fallbacks.RiskyFallback do\n  def handle_error(%{error: error, context: ctx}) do\n    case error do\n      %{recoverable: true} ->\n        {:continue, %{status: :degraded, result: compute_fallback(ctx)}}\n\n      _ ->\n        {:stop, \"Unrecoverable error: #{inspect(error)}\"}\n    end\n  end\n\n  defp compute_fallback(_ctx) do\n    # Compute fallback result\n    %{value: 0}\n  end\nend\n\nMyApp.Beams.RobustBeam.run(%{})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:error, \"Unrecoverable error: :too_risky\", nil}\n```","ref":"beams.html#basic-error-handling"},{"type":"extras","title":"Inline Fallbacks - Beams Guide","doc":"You can also define fallbacks inline using anonymous functions:\n\n```elixir\ndefmodule MyApp.Beams.InlineFallbackBeam do\n  use Lux.Beam\n\n  sequence do\n    step(:operation, MyApp.Prisms.OperationPrism, %{},\n      fallback: fn %{error: error, context: _ctx} ->\n        if recoverable?(error) do\n          {:continue, %{status: :degraded}}\n        else\n          {:stop, \"Cannot proceed: #{inspect(error)}\"}\n        end\n      end)\n  end\n\n  defp recoverable?(%{type: :temporary}), do: true\n  defp recoverable?(_), do: false\nend\n\ndefmodule MyApp.Prisms.OperationPrism do\n  use Lux.Prism\n  \n  def handler(:ok, _ctx) do\n    {:ok, %{type: :temporary}}\n  end\n\n  def handler(_input, _ctx) do\n    {:error, %{type: :temporary}}\n  end\nend\n\nMyApp.Beams.InlineFallbackBeam.run(%{})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{status: :degraded}, nil}\n```","ref":"beams.html#inline-fallbacks"},{"type":"extras","title":"Fallback Behavior - Beams Guide","doc":"Fallbacks can:\n\n* Access the error and context\n* Return `{:continue, result}` to continue execution\n* Return `{:stop, reason}` to halt the beam\n* Transform errors into valid results\n* Implement recovery strategies","ref":"beams.html#fallback-behavior"},{"type":"extras","title":"Custom Error Handling - Beams Guide","doc":"```elixir\ndefmodule MyApp.Beams.ErrorHandlingBeam do\n  use Lux.Beam\n\n  sequence do\n    step(:operation, MyApp.Prisms.OperationPrism, [:input])\n    \n    branch {__MODULE__, :handle_error} do\n      :retry ->\n        step(:retry, MyApp.Prisms.RetryPrism, %{\n          original_input: [:steps, :operatoin, :input],\n          error: [:steps, :operatoin, :error]\n        })\n\n      :fallback ->\n        step(:fallback, MyApp.Prisms.FallbackPrism, %{\n          error: [:steps, :operatoin, :error]\n        })\n\n      :fail ->\n        step(:error, MyApp.Prisms.ErrorPrism, %{\n          error: [:steps, :operatoin, :error],\n          context: :context\n        })\n    end\n  end\n\n  def handle_error(ctx) do\n    case ctx.steps.operation.result do\n      %{type: :temporary} -> :retry\n      %{type: :permanent} -> :fallback\n      _ -> :fail\n    end\n  end\nend\n\ndefmodule MyApp.Prisms.RetryPrism do\n  use Lux.Prism\n  \n  def handler(_input, _ctx) do\n    {:ok, %{type: :retried}}\n  end\nend\n\nMyApp.Beams.ErrorHandlingBeam.run(:ok)\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{type: :retried}, nil}\n```","ref":"beams.html#custom-error-handling"},{"type":"extras","title":"Best Practices - Beams Guide","doc":"1. **Step Organization**\n\n   * Group related steps together\n   * Use meaningful step IDs\n   * Keep step configurations clear\n   * Document complex workflows\n\n2. **Error Handling**\n\n   * Use appropriate retry strategies\n   * Implement fallback paths\n   * Log errors with context\n   * Handle all error cases\n\n3. **Performance**\n\n   * Use parallel execution when possible\n   * Set appropriate timeouts\n   * Monitor execution times\n\n4. **Testing**\n\n   * Test happy paths\n   * Test error scenarios\n   * Test parallel execution\n   * Test timeouts and retries\n\nExample test:\n\n```elixir\ndefmodule MyApp.Beams.ContentProcessorTest do\n  use UnitCase, async: true\n\n  describe \"run/2\" do\n    test \"processes content successfully\" do\n      {:ok, _result, log} = MyApp.Beams.ContentProcessor.run(%{\n        text: \"Great product!\",\n        language: \"en\",\n        enrich: true\n      })\n\n      steps_by_id = Map.new(log.steps, &{&1.id, &1})\n\n      assert steps_by_id[:sentiment].output[\"sentiment\"] == \"positive\"\n      assert length(steps_by_id[:entities].output.result) > 0\n      assert is_binary(steps_by_id[:summary].output.result)\n    end\n\n    test \"respects enrich flag\" do\n      {:ok, _result, log} = MyApp.Beams.ContentProcessor.run(%{\n        text: \"Simple text\",\n        enrich: false\n      })\n      \n      steps_by_id = Map.new(log.steps, &{&1.id, &1})\n\n      assert steps_by_id[:sentiment]\n      refute steps_by_id[:entities]\n      refute steps_by_id[:summary]\n    end\n  end\nend\n\nExUnit.run()\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\nRunning ExUnit with seed: 780470, max_cases: 40\n\n..\nFinished in 0.00 seconds (0.00s async, 0.00s sync)\n2 tests, 0 failures\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{total: 2, failures: 0, excluded: 0, skipped: 0}\n```","ref":"beams.html#best-practices"},{"type":"extras","title":"Advanced Topics - Beams Guide","doc":"","ref":"beams.html#advanced-topics"},{"type":"extras","title":"Complex Workflows - Beams Guide","doc":"```elixir\ndefmodule MyApp.Beams.ComplexWorkflow do\n  use Lux.Beam,\n    generate_execution_log: true\n\n  sequence do\n    parallel do\n      step(:data1, DataSource1, %{})\n      step(:data2, DataSource2, %{})\n      step(:data3, DataSource3, %{})\n    end\n\n    step(:validate, DataValidator, %{\n      data1: [:steps, :data1, :result],\n      data2: [:steps, :data2, :result],\n      data3: [:steps, :data3, :result]\n    })\n\n    branch {__MODULE__, :process_path} do\n      :fast ->\n        step(:quick, QuickProcessor, %{\n          data: [:steps, :validate, :result]\n        })\n\n      :thorough ->\n        parallel do\n          step(:analysis, DeepAnalysis, %{\n            data: [:steps, :validate, :result]\n          })\n\n          step(:enrichment, DataEnrichment, %{\n            data: [:steps, :validate, :result]\n          })\n\n          step(:verification, DataVerification, %{\n            data: [:steps, :validate, :result]\n          })\n        end\n    end\n\n    step(:finalize, Finalizer, %{\n      result: [:steps, :process_path, :result]\n    })\n  end\n\n  def process_path(ctx) do\n    cond do\n      ctx.steps.validate.result.size > 1000 -> :thorough\n      true -> :fast\n    end\n  end\nend\n\nKino.nothing()\n```\n\n```elixir\ndefmodule DataSource1 do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, :source1}\n  end\nend\n\ndefmodule DataSource2 do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, :source2}\n  end\nend\n\ndefmodule DataSource3 do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, :source3}\n  end\nend\n\ndefmodule DataValidator do\n  use Lux.Prism\n\n  def handler(input, _ctx) do\n    {:ok, Map.merge(input, %{size: 2000})}\n  end\nend\n\ndefmodule QuickProcessor do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: \"quick result\"}}\n  end\nend\n\ndefmodule DeepAnalysis do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: \"analized result\"}}\n  end\nend\n\ndefmodule DataEnrichment do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: \"enriched result\"}}\n  end\nend\n\ndefmodule DataVerification do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: \"verified result\"}}\n  end\nend\n\ndefmodule Finalizer do\n  use Lux.Prism\n\n  def handler(_input, _ctx) do\n    {:ok, %{result: \"finalized result\"}}\n  end\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:module, Finalizer, <<70, 79, 82, 49, 0, 0, 10, ...>>, {:handler, 2}}\n```\n\n```elixir\nMyApp.Beams.ComplexWorkflow.run(%{})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{result: \"finalized result\"},\n %{\n   input: %{},\n   output: %{result: \"finalized result\"},\n   status: :completed,\n   started_at: ~U[2025-02-12 06:30:32.034005Z],\n   steps: [\n     %{\n       error: nil,\n       id: :data1,\n       input: %{},\n       output: :source1,\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034005Z],\n       step_index: 0,\n       completed_at: ~U[2025-02-12 06:30:32.034027Z]\n     },\n     %{\n       error: nil,\n       id: :data2,\n       input: %{},\n       output: :source2,\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034137Z],\n       step_index: 1,\n       completed_at: ~U[2025-02-12 06:30:32.034142Z]\n     },\n     %{\n       error: nil,\n       id: :data3,\n       input: %{},\n       output: :source3,\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034240Z],\n       step_index: 2,\n       completed_at: ~U[2025-02-12 06:30:32.034247Z]\n     },\n     %{\n       error: nil,\n       id: :validate,\n       input: %{data1: :source1, data2: :source2, data3: :source3},\n       output: %{size: 2000, data1: :source1, data2: :source2, data3: :source3},\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034338Z],\n       step_index: 3,\n       completed_at: ~U[2025-02-12 06:30:32.034343Z]\n     },\n     %{\n       error: nil,\n       id: :analysis,\n       input: %{data: %{size: 2000, data1: :source1, data2: :source2, data3: :source3}},\n       output: %{result: \"analized result\"},\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034426Z],\n       step_index: 4,\n       completed_at: ~U[2025-02-12 06:30:32.034446Z]\n     },\n     %{\n       error: nil,\n       id: :enrichment,\n       input: %{data: %{size: 2000, data1: :source1, data2: :source2, data3: :source3}},\n       output: %{result: \"enriched result\"},\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034522Z],\n       step_index: 5,\n       completed_at: ~U[2025-02-12 06:30:32.034535Z]\n     },\n     %{\n       error: nil,\n       id: :verification,\n       input: %{data: %{size: 2000, data1: :source1, data2: :source2, data3: :source3}},\n       output: %{result: \"verified result\"},\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034549Z],\n       step_index: 6,\n       completed_at: ~U[2025-02-12 06:30:32.034557Z]\n     },\n     %{\n       error: nil,\n       id: :finalize,\n       input: %{result: nil},\n       output: %{result: \"finalized result\"},\n       status: :completed,\n       started_at: ~U[2025-02-12 06:30:32.034601Z],\n       step_index: 7,\n       completed_at: ~U[2025-02-12 06:30:32.034607Z]\n     }\n   ],\n   completed_at: ~U[2025-02-12 06:30:32.034607Z],\n   beam_id: \"b54a67b8-7da6-4e53-a90c-4363c721a2c3\",\n   started_by: \"system\"\n }}\n```","ref":"beams.html#complex-workflows"},{"type":"extras","title":"Execution Monitoring - Beams Guide","doc":"```elixir\ndefmodule MyApp.Beams.MonitoredBeam do\n  use Lux.Beam,\n    generate_execution_log: true,\n    monitoring: %{\n      metrics: [:duration, :memory, :errors],\n      alerts: [\n        %{\n          condition: &__MODULE__.alert?/1,\n          action: &__MODULE__.notify/1\n        }\n      ]\n    }\n\n  sequence do\n    step(:operation, MonitoredPrism, %{},\n      track: true)\n  end\n\n  def alert?(metrics) do\n    metrics.duration > :timer.seconds(30) ||\n    metrics.memory > 1_000_000_000\n  end\n\n  def notify(_metrics) do\n    # Send alert\n  end\nend\n\nKino.nothing()\n```","ref":"beams.html#execution-monitoring"},{"type":"extras","title":"Prisms Guide","doc":"<!-- livebook:{\"persist_outputs\":true} -->\n\n# Prisms Guide\n\n```elixir\nMix.install(\n  [\n    {:lux, \"~> 0.4.0\"},\n    {:xml_builder, \"~> 2.3\"},\n    {:csv, \"~> 3.2\"},\n    {:swoosh, \"~> 1.17\"}\n  ],\n  start_applications: false\n)\n\nMix.Task.run(\"setup\", install_deps: false)\n\nApplication.put_env(:venomous, :snake_manager, %{\n  python_opts: [\n    module_paths: [\n      Lux.Python.module_path(),\n      Lux.Python.module_path(:deps)\n    ],\n    python_executable: \"python3\"\n  ]\n})\n\nApplication.ensure_all_started([:lux, :ex_unit])\n```","ref":"prisms.html"},{"type":"extras","title":"Overview - Prisms Guide","doc":"Prisms are modular units of functionality that can be composed into workflows. They provide a way to encapsulate business logic, transformations, and integrations into reusable components.\n\nA Prism consists of:\n\n* A unique identifier\n* Input and output schemas\n* A handler function\n* Optional configuration and metadata","ref":"prisms.html#overview"},{"type":"extras","title":"Creating a Prism - Prisms Guide","doc":"Here's a basic example of a Prism:\n\n```elixir\ndefmodule MyApp.Prisms.TextAnalysis do\n  use Lux.Prism,\n    name: \"Text Analysis\",\n    description: \"Analyzes text for sentiment and key phrases\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        text: %{type: :string, description: \"Text to analyze\"},\n        language: %{type: :string, description: \"ISO language code\"}\n      },\n      required: [\"text\"]\n    },\n    output_schema: %{\n      type: :object,\n      properties: %{\n        sentiment: %{\n          type: :string,\n          enum: [\"positive\", \"negative\", \"neutral\"]\n        },\n        confidence: %{type: :number},\n        key_phrases: %{\n          type: :array,\n          items: %{type: :string}\n        }\n      },\n      required: [\"sentiment\", \"confidence\"]\n    }\n  \n  def handler(%{text: \"\"}, _ctx), do: {:error, :empty_text}\n\n  def handler(_input, _ctx) do\n    # Implementation\n    {:ok, %{\n      sentiment: \"positive\",\n      confidence: 0.95,\n      key_phrases: [\"great\", \"awesome\"]\n    }}\n  end\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:module, MyApp.Prisms.TextAnalysis, <<70, 79, 82, 49, 0, 0, 12, ...>>, {:handler, 2}}\n```","ref":"prisms.html#creating-a-prism"},{"type":"extras","title":"Using Prisms - Prisms Guide","doc":"Prisms can be used directly or composed into Beams:\n\n```elixir\n# Direct usage\n{:ok, result} = MyApp.Prisms.TextAnalysis.run(%{\n  text: \"Great product, highly recommended!\",\n  language: \"en\"\n})\n\nresult\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{sentiment: \"positive\", confidence: 0.95, key_phrases: [\"great\", \"awesome\"]}\n```","ref":"prisms.html#using-prisms"},{"type":"extras","title":"Prism Types - Prisms Guide","doc":"","ref":"prisms.html#prism-types"},{"type":"extras","title":"Transformation Prisms - Prisms Guide","doc":"Transform data from one format to another:\n\n```elixir\ndefmodule MyApp.Prisms.DataTransformation do\n  use Lux.Prism,\n    name: \"Data Transformer\",\n    description: \"Transforms data between formats\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        data: %{type: :object},\n        format: %{type: :string, enum: [\"json\", \"xml\", \"csv\"]}\n      }\n    }\n\n  def handler(%{data: data, format: format}, _ctx) do\n    case format do\n      \"json\" -> {:ok, Jason.encode!(data)}\n      \"xml\" -> {:ok, XmlBuilder.generate(data)}\n      \"csv\" -> {:ok, CSV.encode(data)}\n    end\n  end\nend\n\nMyApp.Prisms.DataTransformation.run(%{\n  data: %{a: 1, b: 2},\n  format: \"json\"\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, \"{\\\"a\\\":1,\\\"b\\\":2}\"}\n```","ref":"prisms.html#transformation-prisms"},{"type":"extras","title":"Integration Prisms - Prisms Guide","doc":"Connect to external services:\n\n```elixir\ndefmodule MyApp.Prisms.EmailSender do\n  use Lux.Prism,\n    name: \"Email Sender\",\n    description: \"Sends emails via SMTP\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        to: %{type: :string},\n        subject: %{type: :string},\n        body: %{type: :string}\n      },\n      required: [\"to\", \"subject\", \"body\"]\n    }\n\n  def handler(params, _ctx) do\n    case Swoosh.Mailer.deliver(build_email(params), []) do\n      {:ok, _} -> {:ok, %{sent: true}}\n      {:error, reason} -> {:error, reason}\n    end\n  end\n\n  defp build_email(%{to: to, subject: subject, body: body}) do\n    Swoosh.Email.new()\n    |> Swoosh.Email.to(to)\n    |> Swoosh.Email.subject(subject)\n    |> Swoosh.Email.text_body(body)\n  end\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:module, MyApp.Prisms.EmailSender, <<70, 79, 82, 49, 0, 0, 12, ...>>, {:build_email, 1}}\n```","ref":"prisms.html#integration-prisms"},{"type":"extras","title":"Business Logic Prisms - Prisms Guide","doc":"Implement business rules and workflows:\n\n```elixir\ndefmodule MyApp.Prisms.OrderProcessor do\n  use Lux.Prism,\n    name: \"Order Processor\",\n    description: \"Processes orders with business rules\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        order: %{\n          type: :object,\n          properties: %{\n            items: %{type: :array},\n            total: %{type: :number},\n            customer: %{type: :object}\n          }\n        }\n      }\n    }\n\n  def handler(%{order: order}, _ctx) do\n    with :ok <- validate_inventory(order.items),\n         :ok <- validate_payment(order.total),\n         {:ok, processed} <- apply_discounts(order) do\n      {:ok,\n       %{\n         order_id: generate_order_id(),\n         processed_at: DateTime.utc_now(),\n         final_total: processed.total\n       }}\n    end\n  end\n\n  defp validate_inventory(_), do: :ok\n\n  defp validate_payment(_), do: :ok\n\n  defp apply_discounts(order), do: {:ok, order}\n\n  defp generate_order_id(), do: 1\nend\n\nMyApp.Prisms.OrderProcessor.run(%{\n  order: %{\n    items: [1, 2],\n    total: 2,\n    customer: %{}\n  }\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{order_id: 1, processed_at: ~U[2025-02-08 18:22:11.925749Z], final_total: 2}}\n```","ref":"prisms.html#business-logic-prisms"},{"type":"extras","title":"Best Practices - Prisms Guide","doc":"1. **Input/Output Schemas**\n\n   * Define clear, specific schemas\n   * Document all properties\n   * Use appropriate types and constraints\n   * Include examples where helpful\n\n2. **Error Handling**\n\n   * Return `{:ok, result}` or `{:error, reason}`\n   * Provide meaningful error messages\n   * Handle all error cases\n   * Use pattern matching for validation\n\n3. **Context Usage**\n\n   * Use context for cross-cutting concerns\n   * Don't rely on global state\n   * Pass necessary data through context\n   * Keep context usage minimal\n\n4. **Testing**\n\n   * Test happy and error paths\n   * Mock external dependencies\n   * Test with various inputs\n   * Test error conditions\n\nExample test:\n\n```elixir\ndefmodule MyApp.Prisms.TextAnalysisTest do\n  use UnitCase, async: true\n\n  alias MyApp.Prisms.TextAnalysis\n\n  describe \"run/2\" do\n    test \"analyzes positive text\" do\n      {:ok, result} = TextAnalysis.run(%{\n        text: \"Great product!\",\n        language: \"en\"\n      })\n\n      assert result.sentiment == \"positive\"\n      assert result.confidence > 0.8\n      assert \"great\" in result.key_phrases\n    end\n\n    test \"handles empty text\" do\n      assert {:error, _} = TextAnalysis.run(%{\n        text: \"\",\n        language: \"en\"\n      })\n    end\n  end\nend\n\nExUnit.run()\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\nRunning ExUnit with seed: 616293, max_cases: 40\n\n..\nFinished in 0.00 seconds (0.00s async, 0.00s sync)\n2 tests, 0 failures\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{total: 2, failures: 0, excluded: 0, skipped: 0}\n```","ref":"prisms.html#best-practices"},{"type":"extras","title":"Advanced Topics - Prisms Guide","doc":"","ref":"prisms.html#advanced-topics"},{"type":"extras","title":"Composable Prisms - Prisms Guide","doc":"Prisms can be composed together:\n\n```elixir\ndefmodule MyApp.Prisms.Validator do\n  use Lux.Prism,\n    name: \"Validator\",\n    description: \"Validate input\"\n  \n  def handler(input, _ctx), do: {:ok, input}\nend\n\ndefmodule MyApp.Prisms.Enricher do\n  use Lux.Prism,\n    name: \"Enricher\",\n    description: \"Enrich input\"\n  \n  def handler(input, _ctx), do: {:ok, input}\nend\n\ndefmodule MyApp.Prisms.Processor do\n  use Lux.Prism,\n    name: \"Processor\",\n    description: \"Process input\"\n  \n  def handler(input, _ctx), do: {:ok, input}\nend\n\ndefmodule MyApp.Prisms.Pipeline do\n  use Lux.Prism,\n    name: \"Processing Pipeline\",\n    description: \"Chains multiple prisms\"\n\n  def handler(input, _ctx) do\n    with {:ok, validated} <- MyApp.Prisms.Validator.run(input),\n         {:ok, enriched} <- MyApp.Prisms.Enricher.run(validated),\n         {:ok, processed} <- MyApp.Prisms.Processor.run(enriched) do\n      {:ok, processed}\n    end\n  end\nend\n\nMyApp.Prisms.Pipeline.run(%{})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{}}\n```","ref":"prisms.html#composable-prisms"},{"type":"extras","title":"Async Prisms - Prisms Guide","doc":"Handle long-running operations:\n\n```elixir\ndefmodule MyApp.Prisms.AsyncProcessor do\n  use Lux.Prism,\n    name: \"Async Processor\",\n    description: \"Handles async operations\"\n\n  def handler(_input, _ctx) do\n    task = Task.async(fn ->\n      # Long running operation\n      Process.sleep(5000)\n      {:ok, %{result: \"done\"}}\n    end)\n\n    case Task.yield(task, :timer.seconds(10)) do\n      {:ok, result} -> result\n      nil ->\n        Task.shutdown(task)\n        {:error, :timeout}\n    end\n  end\nend\n\nMyApp.Prisms.AsyncProcessor.run(%{})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{result: \"done\"}}\n```","ref":"prisms.html#async-prisms"},{"type":"extras","title":"Python Integration - Prisms Guide","doc":"Prisms can leverage Python code directly in their handlers using `Lux.Python`. This is particularly useful for machine learning, data processing, or when you need to use Python libraries:\n\n```elixir\ndefmodule MyApp.Prisms.SentimentAnalyzer do\n  use Lux.Prism,\n    name: \"Sentiment Analyzer\",\n    description: \"Analyzes text sentiment using Python's NLTK\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        text: %{type: :string, description: \"Text to analyze\"},\n        language: %{type: :string, description: \"ISO language code\"}\n      },\n      required: [\"text\"]\n    },\n    output_schema: %{\n      type: :object,\n      properties: %{\n        sentiment: %{type: :string, enum: [\"positive\", \"negative\", \"neutral\"]},\n        confidence: %{type: :number, minimum: 0, maximum: 1}\n      },\n      required: [\"sentiment\", \"confidence\"]\n    }\n\n  require Lux.Python\n  import Lux.Python\n\n  def handler(%{text: text, language: lang}, _ctx) do\n    # Import required Python packages\n    {:ok, %{\"success\" => true}} = Lux.Python.import_package(\"nltk\")\n    \n    # Execute Python code with variable bindings\n    result = python variables: %{text: text, lang: lang} do\n      ~PY\"\"\"\n      import nltk\n      from nltk.sentiment import SentimentIntensityAnalyzer\n\n      # Download required NLTK data if not already present\n      try:\n          nltk.data.find('vader_lexicon')\n      except LookupError:\n          nltk.download('vader_lexicon')\n\n      # Analyze sentiment\n      sia = SentimentIntensityAnalyzer()\n      scores = sia.polarity_scores(text)\n\n      # Convert scores to our format\n      compound = scores['compound']\n      if compound >= 0.05:\n          sentiment = \"positive\"\n      elif compound <= -0.05:\n          sentiment = \"negative\"\n      else:\n          sentiment = \"neutral\"\n\n      # Return result\n      {\n          \"sentiment\": sentiment,\n          \"confidence\": abs(compound)\n      }\n      \"\"\"\n    end\n\n    {:ok, result}\n  end\nend\n\nMyApp.Prisms.SentimentAnalyzer.run(%{\n  text: \"hello\",\n  language: \"en\"\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{\"confidence\" => 0.0, \"sentiment\" => \"neutral\"}}\n```\n\n```elixir\ndefmodule MyApp.Prisms.CryptoAddressValidator do\n  use Lux.Prism,\n    name: \"Crypto Address Validator\",\n    description: \"Validates cryptocurrency addresses\",\n    input_schema: %{\n      type: :object,\n      properties: %{\n        address: %{type: :string, description: \"The cryptocurrency address\"},\n        chain: %{type: :string, enum: [\"ethereum\", \"bitcoin\"], description: \"Chain type\"}\n      },\n      required: [\"address\", \"chain\"]\n    }\n\n  require Lux.Python\n  import Lux.Python\n\n  def handler(%{address: address, chain: \"ethereum\"}, _ctx) do\n    # Import required packages\n    {:ok, %{\"success\" => true}} = Lux.Python.import_package(\"web3\")\n    {:ok, %{\"success\" => true}} = Lux.Python.import_package(\"eth_utils\")\n\n    result = python variables: %{address: address} do\n      ~PY\"\"\"\n      from eth_utils import is_address, to_checksum_address\n      \n      checksum_address = to_checksum_address(address)\n      is_valid = is_address(checksum_address)\n      {\"is_valid\": is_valid, \"normalized_address\": checksum_address}\n      \"\"\"\n    end\n\n    {:ok, result}\n  end\nend\n\nMyApp.Prisms.CryptoAddressValidator.run(%{\n  address: \"0xd3CdA913deB6f67967B99D67aCDFa1712C293601\",\n  chain: \"ethereum\"\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok, %{\"is_valid\" => true, \"normalized_address\" => \"0xd3CdA913deB6f67967B99D67aCDFa1712C293601\"}}\n```\n\nThe Python integration supports:\n\n* Direct Python code execution with `~PY` sigils\n* Variable binding between Elixir and Python\n* Package management with `import_package/1`\n* Error handling and timeouts\n* Multi-line Python code with proper indentation\n* Access to the full Python ecosystem\n\nBest practices for Python integration:\n\n1. Always handle package imports explicitly\n2. Use proper error handling for Python code execution\n3. Keep Python code focused and modular\n4. Leverage Python's scientific and ML libraries when appropriate\n5. Use type hints and docstrings in Python code\n6. Follow both Elixir and Python style guides","ref":"prisms.html#python-integration"},{"type":"extras","title":"Signals Guide","doc":"<!-- livebook:{\"persist_outputs\":true} -->\n\n# Signals Guide\n\n```elixir\nMix.install(\n  [\n    {:lux, \"~> 0.4.0\"}\n    {:kino, \"~> 0.14.2\"}\n  ]\n)\n\nApplication.ensure_all_started([:ex_unit])\n```","ref":"signals.html"},{"type":"extras","title":"Overview - Signals Guide","doc":"Signals are the fundamental units of communication in Lux. They provide a type-safe, schema-validated way for components to exchange information.\n\nA Signal consists of:\n\n* A unique identifier\n* A schema identifier that defines its structure\n* Content that conforms to the schema\n* Metadata about the signal's context and processing","ref":"signals.html#overview"},{"type":"extras","title":"Creating a Signal Schema - Signals Guide","doc":"Signal schemas define the structure and validation rules for signals:\n\n```elixir\ndefmodule MyApp.Schemas.TaskSchema do\n  use Lux.SignalSchema,\n    name: \"task\",\n    version: \"1.0.0\",\n    description: \"Represents a task assignment\",\n    schema: %{\n      type: :object,\n      properties: %{\n        title: %{type: :string},\n        description: %{type: :string},\n        priority: %{type: :string, enum: [\"low\", \"medium\", \"high\"]},\n        due_date: %{type: :string, format: \"date-time\"},\n        assignee: %{type: :string},\n        tags: %{type: :array, items: %{type: :string}}\n      },\n      required: [\"title\", \"priority\", \"assignee\"]\n    },\n    tags: [\"task\", \"workflow\"],\n    compatibility: :full,\n    format: :json\nend\n\nKino.nothing()\n```","ref":"signals.html#creating-a-signal-schema"},{"type":"extras","title":"Creating a Signal - Signals Guide","doc":"Signals are created by modules that use the `Lux.Signal` behaviour:\n\n```elixir\ndefmodule MyApp.Signals.Task do\n  use Lux.Signal,\n    schema_id: MyApp.Schemas.TaskSchema\nend\n\nKino.nothing()\n```\n\nWhen you create a signal with new/1 function, signal module perform validation with schema.\n\n```elixir\nMyApp.Signals.Task.new(%{\n  payload: %{\n    title: \"new signal\",\n    priority: \"low\",\n    assignee: \"agent\"\n  }\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"8597236a-ee9e-4f24-a05e-a0f86816e2cb\",\n   payload: %{priority: \"low\", title: \"new signal\", assignee: \"agent\"},\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.873770Z],\n   metadata: %{},\n   schema_id: MyApp.Schemas.TaskSchema\n }}\n```\n\n```elixir\nMyApp.Signals.Task.new(%{\n  payload: %{message: \"invalid\"}\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:error, [{\"Required properties title, priority, assignee were not present.\", \"#\"}]}\n```","ref":"signals.html#creating-a-signal"},{"type":"extras","title":"Signal Validation - Signals Guide","doc":"Lux uses JSON Schema (Draft 4) for validating signal payloads. This provides a robust, standardized way to ensure your signals conform to their expected structure.","ref":"signals.html#signal-validation"},{"type":"extras","title":"Basic Types - Signals Guide","doc":"The following basic types are supported:\n\n<!-- livebook:{\"break_markdown\":true} -->\n\n#### Null Validation\n\n```elixir\ndefmodule NullSchema do\n  use Lux.SignalSchema,\n    schema: %{type: :null}\nend\n\ndefmodule NullSignal do\n  use Lux.Signal, schema_id: NullSchema\nend\n\nNullSignal.new(%{payload: nil})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"bb30cfe4-ab2c-4716-9e4e-9ef7419ad021\",\n   payload: nil,\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.899178Z],\n   metadata: %{},\n   schema_id: NullSchema\n }}\n```\n\n#### Boolean Validation\n\n```elixir\ndefmodule BooleanSchema do\n  use Lux.SignalSchema,\n    schema: %{type: :boolean}\nend\n\ndefmodule BooleanSignal do\n  use Lux.Signal, schema_id: BooleanSchema\nend\n\nBooleanSignal.new(%{payload: true})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"3d26ee2f-f2bc-42bb-89e8-3942079dc1dc\",\n   payload: true,\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.918708Z],\n   metadata: %{},\n   schema_id: BooleanSchema\n }}\n```\n\n#### Integer Vlidation\n\n```elixir\ndefmodule IntegerSchema do\n  use Lux.SignalSchema,\n    schema: %{type: :integer}\nend\n\ndefmodule IntegerSignal do\n  use Lux.Signal, schema_id: IntegerSchema\nend\n\nIntegerSignal.new(%{payload: 1})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"7adaf40b-e022-4b72-9dd8-9457078e0fde\",\n   payload: 1,\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.938289Z],\n   metadata: %{},\n   schema_id: IntegerSchema\n }}\n```\n\n#### String Validation\n\n```elixir\ndefmodule StringSchema do\n  use Lux.SignalSchema,\n    schema: %{type: :string}\nend\n\ndefmodule StringSignal do\n  use Lux.Signal, schema_id: StringSchema\nend\n\nStringSignal.new(%{payload: \"payload\"})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"a6f4b7fa-88fc-47d8-8242-a3d588807d78\",\n   payload: \"payload\",\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.958540Z],\n   metadata: %{},\n   schema_id: StringSchema\n }}\n```\n\n#### Array Validation\n\n```elixir\n# Array validation\ndefmodule ArraySchema do\n  use Lux.SignalSchema,\n    schema: %{\n      type: :array,\n      items: %{type: :string}  # Validates each array item\n    }\nend\n\ndefmodule ArraySignal do\n  use Lux.Signal, schema_id: ArraySchema\nend\n\nArraySignal.new(%{payload: [\"data\"]})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"37d23fea-bf81-43a2-8930-ba0aefbd7ff7\",\n   payload: [\"data\"],\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.978059Z],\n   metadata: %{},\n   schema_id: ArraySchema\n }}\n```","ref":"signals.html#basic-types"},{"type":"extras","title":"Object Validation - Signals Guide","doc":"Objects can have nested properties and required fields:\n\n```elixir\ndefmodule ComplexObjectSchema do\n  use Lux.SignalSchema,\n    schema: %{\n      type: :object,\n      properties: %{\n        name: %{type: :string},\n        age: %{type: :integer},\n        tags: %{\n          type: :array,\n          items: %{type: :string}\n        },\n        metadata: %{\n          type: :object,\n          properties: %{\n            created_at: %{type: :string, format: \"date-time\"},\n            priority: %{type: :string, enum: [\"low\", \"medium\", \"high\"]}\n          },\n          required: [\"created_at\"]\n        }\n      },\n      required: [\"name\", \"age\"]  # Top-level required fields\n    }\nend\n\ndefmodule ComplexObjectSignal do\n  use Lux.Signal, schema_id: ComplexObjectSchema\nend\n\nComplexObjectSignal.new(%{payload: %{\n  name: \"John Doe\",\n  age: 10,\n  tags: [\"user\"],\n  metadata: %{\n    created_at: \"2024-03-21T17:32:28Z\",\n  }\n}})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"134ec6d0-e05f-4142-bc7b-561c70335b3f\",\n   payload: %{\n     name: \"John Doe\",\n     metadata: %{created_at: \"2024-03-21T17:32:28Z\"},\n     tags: [\"user\"],\n     age: 10\n   },\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:51.998781Z],\n   metadata: %{},\n   schema_id: ComplexObjectSchema\n }}\n```","ref":"signals.html#object-validation"},{"type":"extras","title":"Format Validation - Signals Guide","doc":"Lux supports the following formats out of the box:\n\n* `date-time`: ISO 8601 dates (e.g., \"2024-03-21T17:32:28Z\")\n* `email`: Email addresses\n* `hostname`: Valid hostnames\n* `ipv4`: IPv4 addresses\n* `ipv6`: IPv6 addresses\n\nExample:\n\n```elixir\ndefmodule UserSchema do\n  use Lux.SignalSchema,\n    schema: %{\n      type: :object,\n      properties: %{\n        email: %{type: :string, format: \"email\"},\n        last_login: %{type: :string, format: \"date-time\"},\n        server: %{type: :string, format: \"hostname\"}\n      }\n    }\nend\n\ndefmodule UserSignal do\n  use Lux.Signal, schema_id: UserSchema\nend\n\nUserSignal.new(%{payload: %{\n  email: \"hello@lux.io\",\n  last_login: \"2024-03-21T17:32:28Z\",\n  server: \"lux.io\"\n}})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:ok,\n %Lux.Signal{\n   id: \"6bb89ac0-cba3-45fd-a06d-3c3bf0c6bda1\",\n   payload: %{server: \"lux.io\", email: \"hello@lux.io\", last_login: \"2024-03-21T17:32:28Z\"},\n   sender: nil,\n   recipient: nil,\n   timestamp: ~U[2025-02-12 12:56:52.026939Z],\n   metadata: %{},\n   schema_id: UserSchema\n }}\n```","ref":"signals.html#format-validation"},{"type":"extras","title":"Custom Format Validation - Signals Guide","doc":"You can add custom format validators in your configuration:\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\n# In config/config.exs\nconfig :ex_json_schema,\n  :custom_format_validator,\n  fn\n    # Validate a custom UUID format\n    \"uuid\", value ->\n      case UUID.info(value) do\n        {:ok, _} -> true\n        {:error, _} -> false\n      end\n    \n    # Return true for unknown formats (as per JSON Schema spec)\n    _, _ -> true\n  end\n```\n\n<!-- livebook:{\"break_markdown\":true} -->\n\n<!-- TODO: Add support for runtime custom formatters via resolve callbacks at schema definition. ref: https://github.com/jonasschmidt/ex_json_schema?tab=readme-ov-file#custom-formats -->","ref":"signals.html#custom-format-validation"},{"type":"extras","title":"Validation Errors - Signals Guide","doc":"When validation fails, you get detailed error messages:\n\n<!-- livebook:{\"force_markdown\":true} -->\n\n```elixir\n# Missing required field\n{:error, [{\"Required property name was not present.\", \"#\"}]}\n\n# Type mismatch\n{:error, [{\"Type mismatch. Expected Integer but got String.\", \"#/age\"}]}\n\n# Invalid format\n{:error, [{\"Format validation failed.\", \"#/email\"}]}\n\n# Invalid enum value\n{:error, [{\"Value not allowed.\", \"#/metadata/priority\"}]}\n```\n\n<!-- livebook:{\"break_markdown\":true} -->","ref":"signals.html#validation-errors"},{"type":"extras","title":"Best Practices for Schema Validation - Signals Guide","doc":"1. **Type Safety**\n\n   * Always specify types for properties\n   * Use appropriate types (e.g., `:integer` vs `:number`)\n   * Consider using enums for constrained string values\n\n2. **Required Fields**\n\n   * Mark essential fields as required\n   * Consider the impact on backward compatibility\n   * Document why fields are required\n\n3. **Nested Validation**\n\n   * Break down complex objects into logical groups\n   * Use nested required fields for sub-objects\n   * Keep nesting depth reasonable\n\n4. **Format Validation**\n\n   * Use built-in formats when possible\n   * Create custom formats for domain-specific values\n   * Document format requirements\n\n5. **Error Handling**\n\n   * Handle validation errors gracefully\n   * Provide clear error messages\n   * Consider aggregating multiple validation errors\n\n6. **Testing**\n\n   * Test both valid and invalid cases\n   * Test edge cases and boundary values\n   * Test format validation thoroughly\n\n```elixir\ndefmodule MyApp.Schemas.TaskSchemaTest do\n  use UnitCase, async: true\n\n  alias MyApp.Schemas.TaskSchema\n\n  test \"validates required fields\" do\n    assert {:error, _} = TaskSchema.validate(%Lux.Signal{payload: %{}})\n    assert {:error, _} = TaskSchema.validate(%Lux.Signal{payload: %{title: \"Test\"}})\n    assert {:ok, _} = TaskSchema.validate(\n      %Lux.Signal{payload: %{title: \"Test\", priority: \"high\", assignee: \"alice\"}}\n    )\n  end\n\n  test \"validates field types\" do\n    assert {:error, _} = TaskSchema.validate(\n      %Lux.Signal{payload: %{title: 123, priority: \"high\", assignee: \"alice\"}}\n    )\n  end\n\n  test \"validates enums\" do\n    assert {:error, _} = TaskSchema.validate(\n      %Lux.Signal{payload: %{title: \"Test\", priority: \"invalid\", assignee: \"alice\"}}\n    )\n  end\nend\n\nExUnit.run()\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\nRunning ExUnit with seed: 49621, max_cases: 40\n\n...\nFinished in 0.00 seconds (0.00s async, 0.00s sync)\n3 tests, 0 failures\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{total: 3, failures: 0, excluded: 0, skipped: 0}\n```","ref":"signals.html#best-practices-for-schema-validation"},{"type":"extras","title":"Using Signals - Signals Guide","doc":"Signals can be created and used in various ways:\n\n```elixir\n# Create a new task signal\n{:ok, signal} =\n  MyApp.Signals.Task.new(%{\n    payload: %{\n      title: \"Review PR\",\n      priority: \"high\",\n      assignee: \"alice\",\n      tags: [\"github\", \"code-review\"]\n    }\n  })\n\nsignal\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%Lux.Signal{\n  id: \"9c69dae9-fa78-416d-afb2-e94d0cb8cf3a\",\n  payload: %{\n    priority: \"high\",\n    title: \"Review PR\",\n    tags: [\"github\", \"code-review\"],\n    assignee: \"alice\"\n  },\n  sender: nil,\n  recipient: nil,\n  timestamp: ~U[2025-02-12 12:58:06.802667Z],\n  metadata: %{},\n  schema_id: MyApp.Schemas.TaskSchema\n}\n```","ref":"signals.html#using-signals"},{"type":"extras","title":"Schema Evolution - Signals Guide","doc":"Lux supports schema evolution through versioning and compatibility levels:\n\n* `:full` - New schema must be fully compatible with old schema\n* `:backward` - New schema can read old data\n* `:forward` - Old schema can read new data\n* `:none` - No compatibility guarantees\n\nExample of schema evolution:\n\n```elixir\ndefmodule MyApp.Schemas.TaskSchemaV2 do\n  use Lux.SignalSchema,\n    name: \"task\",\n    version: \"2.0.0\",\n    description: \"Task assignment with status tracking\",\n    schema: %{\n      type: :object,\n      properties: %{\n        title: %{type: :string},\n        description: %{type: :string},\n        priority: %{type: :string, enum: [\"low\", \"medium\", \"high\"]},\n        due_date: %{type: :string, format: \"date-time\"},\n        assignee: %{type: :string},\n        tags: %{type: :array, items: %{type: :string}},\n        status: %{type: :string, enum: [\"pending\", \"in_progress\", \"completed\"]},\n        progress: %{type: :integer, minimum: 0, maximum: 100}\n      },\n      required: [\"title\", \"priority\", \"assignee\", \"status\"]\n    },\n    compatibility: :backward,\n    reference: \"v1: MyApp.Schemas.TaskSchema\"\nend\n\nKino.nothing()\n```","ref":"signals.html#schema-evolution"},{"type":"extras","title":"Best Practices - Signals Guide","doc":"1. **Schema Design**\n\n   * Use semantic versioning for schemas\n   * Document schema changes\n   * Consider backward compatibility\n   * Use appropriate compatibility levels\n\n2. **Validation**\n\n   * Validate business rules in `validate/1`\n   * Keep validations focused and specific\n   * Return clear error messages\n\n3. **Testing**\n\n   * Test schema validation\n   * Test business rule validation\n   * Test compatibility between versions\n\nExample test:\n\n```elixir\ndefmodule MyApp.Signals.TaskTest do\n  use UnitCase, async: true\n\n  describe \"new/1\" do\n    test \"creates valid task signal\" do\n      {:ok, signal} =\n        MyApp.Signals.Task.new(%{\n          payload: %{\n            title: \"Test Task\",\n            priority: \"high\",\n            assignee: \"bob\"\n          }\n        })\n\n      assert signal.payload.title == \"Test Task\"\n      assert signal.payload.priority == \"high\"\n      assert signal.payload.assignee == \"bob\"\n    end\n\n    test \"validates title presence\" do\n      assert {:error,\n              [\n                {\"Required property title was not present.\", \"#\"}\n              ]} =\n               MyApp.Signals.Task.new(%{\n                 payload: %{\n                   priority: \"high\",\n                   assignee: \"bob\"\n                 }\n               })\n    end\n  end\nend\n\nExUnit.run()\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\nRunning ExUnit with seed: 49621, max_cases: 40\n\n..\nFinished in 0.00 seconds (0.00s async, 0.00s sync)\n2 tests, 0 failures\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{total: 2, failures: 0, excluded: 0, skipped: 0}\n```","ref":"signals.html#best-practices"},{"type":"extras","title":"Advanced Topics - Signals Guide","doc":"","ref":"signals.html#advanced-topics"},{"type":"extras","title":"Schema Documentation - Signals Guide","doc":"Schemas can include rich documentation:\n\n```elixir\ndefmodule MyApp.Schemas.DocumentedTaskSchema do\n  use Lux.SignalSchema,\n    name: \"documented_task\",\n    version: \"1.0.0\",\n    description: \"\"\"\n    Represents a task assignment in the system.\n    Tasks are the basic unit of work assignment and tracking.\n    \"\"\",\n    schema: %{\n      type: :object,\n      properties: %{\n        title: %{\n          type: :string,\n          description: \"Short title describing the task\",\n          examples: [\"Review PR #123\", \"Deploy to production\"]\n        },\n        priority: %{\n          type: :string,\n          enum: [\"low\", \"medium\", \"high\"],\n          description: \"Task priority level\",\n          default: \"medium\"\n        }\n      }\n    },\n    tags: [\"task\", \"workflow\"],\n    reference: \"https://example.com/docs/task-schema\"\nend\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:module, MyApp.Schemas.DocumentedTaskSchema, <<70, 79, 82, 49, 0, 0, 14, ...>>, :ok}\n```","ref":"signals.html#schema-documentation"},{"type":"extras","title":"Custom Validation Rules - Signals Guide","doc":"You can implement complex validation rules:\n\n```elixir\ndefmodule MyApp.Schemas.CustomSchema do\n  use Lux.SignalSchema,\n    name: \"task\",\n    version: \"1.0.0\",\n    description: \"Represents a task assignment\",\n    schema: %{\n      type: :object,\n      properties: %{\n        due_date: %{type: :string, format: \"date-time\"},\n      }\n    },\n    tags: [\"task\", \"workflow\"],\n    compatibility: :full,\n    format: :json\n\n  def validate(%{payload: %{due_date: due_date}} = content) do\n    with {:ok, parsed_date, _offset} <- DateTime.from_iso8601(due_date),\n         :ok <- validate_future_date(parsed_date),\n         :ok <- validate_working_hours(parsed_date) do\n      {:ok, content}\n    end\n  end\n\n  defp validate_future_date(date) do\n    if DateTime.compare(date, DateTime.utc_now()) == :gt do\n      :ok\n    else\n      {:error, \"Due date must be in the future\"}\n    end\n  end\n\n  defp validate_working_hours(date) do\n    if date.hour >= 9 and date.hour <= 17 do\n      :ok\n    else\n      {:error, \"Due date must be during working hours (9-17)\"}\n    end\n  end\nend\n\ndefmodule MyApp.Signals.CustomSignal do\n  use Lux.Signal,\n    schema_id: MyApp.Schemas.CustomSchema\nend\n\nMyApp.Signals.CustomSignal.new(%{\n  payload: %{\n    due_date: \"2024-03-21T17:32:28Z\"\n  }\n})\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n{:error, \"Due date must be in the future\"}\n```","ref":"signals.html#custom-validation-rules"},{"type":"extras","title":"Signal Metadata - Signals Guide","doc":"Metadata provides context about the signal's creation and processing:\n\n```elixir\ndefmodule MyApp.Signals.MetadataTask do\n  use Lux.Signal,\n    schema_id: MyApp.Schemas.TaskSchema\nend\n\n{:ok, signal} = MyApp.Signals.MetadataTask.new(%{\n  payload: %{\n    title: \"Test Task\",\n    priority: \"high\",\n    assignee: \"bob\"\n  }\n})\n\nsignal.metadata\n```\n\n<!-- livebook:{\"output\":true} -->\n\n```\n%{}\n```","ref":"signals.html#signal-metadata"},{"type":"extras","title":"Lenses Guide","doc":"# Lenses Guide\n\n```elixir\nMix.install([\n  {:lux, \"~> 0.4.0\"}\n  {:kino, \"~> 0.14.2\"}\n])\n\nApplication.ensure_all_started([:ex_unit])\n```","ref":"lenses.html"},{"type":"extras","title":"Overview - Lenses Guide","doc":"Lenses provide a way to interact with external systems and APIs in a structured, composable way. They handle authentication, data transformation, and error handling for external integrations.\n\nA Lens consists of:\n\n* A URL endpoint\n* HTTP method and parameters\n* Authentication configuration\n* Schema validation\n* Response transformation","ref":"lenses.html#overview"},{"type":"extras","title":"Creating a Lens - Lenses Guide","doc":"Here's a basic example of a Lens:\n\n```elixir\ndefmodule MyApp.Lenses.WeatherAPI do\n  use Lux.Lens,\n    name: \"OpenWeather API\",\n    description: \"Fetches weather data from OpenWeather\",\n    url: \"https://api.openweathermap.org/data/2.5/weather\",\n    method: :get,\n    schema: %{\n      type: :object,\n      properties: %{\n        q: %{\n          type: :string,\n          description: \"City name\"\n        },\n        units: %{\n          type: :string,\n          description: \"Temperature units. For temperature in Fahrenheit use units=imperial and for temperature in Celsius use units=metric\",\n          enum: [\"metric\", \"imperial\"]\n        },\n        appid: %{type: :string, description: \"API key\"}\n      },\n      required: [\"q\", \"appid\"]\n    }\n\n  def after_focus(%{\"main\" => %{\"temp\" => temp}} = response) do\n    {:ok, %{\n      temperature: temp,\n      raw_data: response\n    }}\n  end\n\n  def after_focus(%{\"error\" => error}) do\n    {:error, error}\n  end\nend\n```","ref":"lenses.html#creating-a-lens"},{"type":"extras","title":"Using Lenses - Lenses Guide","doc":"Lenses can be used directly or within Beams:\n\n```elixir\n{:ok, weather} = MyApp.Lenses.WeatherAPI.focus(%{\n  q: \"London\",\n  units: \"metric\",\n  appid: System.fetch_env!(\"LB_OPEN_WEATHER_API_KEY\")\n})\n\nframe = Kino.Frame.new() |> Kino.render()\n\nKino.Frame.append(frame, weather.temperature)\nKino.Frame.append(frame, weather.raw_data)\n\nKino.nothing()\n```","ref":"lenses.html#using-lenses"},{"type":"extras","title":"Authentication Types - Lenses Guide","doc":"Lenses support several authentication methods that are automatically applied when making requests:","ref":"lenses.html#authentication-types"},{"type":"extras","title":"API Key Authentication - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.APIKeyAuth do\n  use Lux.Lens,\n    name: \"API Key Example\",\n    url: \"https://api.example.com/data\",\n    auth: %{\n      type: :api_key,\n      key: System.get_env(\"API_KEY\")\n    }\nend\n```\n\nWhen using API key authentication, the key is automatically added as a Bearer token in the Authorization header.","ref":"lenses.html#api-key-authentication"},{"type":"extras","title":"Basic Authentication - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.BasicAuth do\n  use Lux.Lens,\n    name: \"Basic Auth Example\",\n    url: \"https://api.example.com/secure\",\n    auth: %{\n      type: :basic,\n      username: System.get_env(\"API_USER\"),\n      password: System.get_env(\"API_PASS\")\n    }\nend\n```\n\nBasic authentication automatically encodes the username and password in Base64 format and adds them to the Authorization header.","ref":"lenses.html#basic-authentication"},{"type":"extras","title":"OAuth Authentication - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.OAuthExample do\n  use Lux.Lens,\n    name: \"OAuth Example\",\n    url: \"https://api.example.com/oauth\",\n    auth: %{\n      type: :oauth,\n      token: System.get_env(\"OAUTH_TOKEN\")\n    }\nend\n```\n\nOAuth authentication adds the token as a Bearer token in the Authorization header.","ref":"lenses.html#oauth-authentication"},{"type":"extras","title":"Custom Authentication - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.CustomAuth do\n  use Lux.Lens,\n    name: \"Custom Auth Example\",\n    url: \"https://api.example.com/custom\",\n    auth: %{\n      type: :custom,\n      auth_function: &__MODULE__.authenticate/1\n    }\n\n  def authenticate(lens) do\n    # Add custom headers or modify request\n    headers = [{\"X-Custom-Auth\", \"value\"}]\n    %{lens | headers: headers}\n  end\nend\n```\n\nCustom authentication allows you to implement your own authentication logic by providing a function that modifies the lens before the request is made.","ref":"lenses.html#custom-authentication"},{"type":"extras","title":"Response Transformation - Lenses Guide","doc":"","ref":"lenses.html#response-transformation"},{"type":"extras","title":"Basic Transformation - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.UserAPI do\n  use Lux.Lens,\n    name: \"User API\",\n    url: \"https://api.example.com/users\"\n\n  def after_focus(%{\"data\" => users}) do\n    transformed =\n      Enum.map(users, fn user ->\n        %{\n          id: user[\"id\"],\n          name: user[\"name\"],\n          email: user[\"email\"]\n        }\n      end)\n\n    {:ok, %{users: transformed}}\n  end\nend\n```","ref":"lenses.html#basic-transformation"},{"type":"extras","title":"Error Handling - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.RobustAPI do\n  use Lux.Lens,\n    name: \"Robust API\",\n    url: \"https://api.example.com/data\"\n\n  def after_focus(%{\"error\" => error}) do\n    {:error, \"API Error: #{error}\"}\n  end\n\n  def after_focus(%{\"data\" => nil}) do\n    {:error, \"No data available\"}\n  end\n\n  def after_focus(%{\"data\" => data}) do\n    {:ok, data}\n  end\n\n  def after_focus(response) do\n    {:error, \"Unexpected response format: #{inspect(response)}\"}\n  end\nend\n```","ref":"lenses.html#error-handling"},{"type":"extras","title":"Best Practices - Lenses Guide","doc":"1. **Authentication**\n\n   * Use environment variables for credentials\n   * Keep sensitive data out of version control\n   * Use appropriate auth type for the API\n   * Handle authentication errors gracefully\n\n2. **Error Handling**\n\n   * Handle common HTTP errors\n   * Transform API-specific errors\n   * Provide meaningful error messages\n   * Include request context in errors\n\n3. **Response Transformation**\n\n   * Clean and normalize data\n   * Remove unnecessary fields\n   * Convert types appropriately\n   * Handle missing or null values\n\n4. **Testing**\n\n   * Mock HTTP requests\n   * Test authentication\n   * Test error cases\n   * Test transformations\n\nExample test:\n\n```elixir\ndefmodule MyApp.Lenses.WeatherAPITest do\n  use UnitCase, async: true\n\n  setup do\n    Req.Test.verify_on_exit!()\n    :ok\n  end\n\n  describe \"focus/1\" do\n    test \"fetches weather data successfully\" do\n      Req.Test.stub(Lux.Lens, fn conn ->\n        assert conn.params == %{\"q\" => \"London\", \"units\" => \"metric\", \"appid\" => \"test_key\"}\n\n        Req.Test.json(conn, %{\n          \"main\" => %{\"temp\" => 20.5},\n          \"weather\" => [%{\"description\" => \"clear sky\"}]\n        })\n      end)\n\n      {:ok, result} = MyApp.Lenses.WeatherAPI.focus(%{\n        q: \"London\",\n        units: \"metric\",\n        appid: System.fetch_env!(\"LB_OPEN_WEATHER_API_KEY\")\n      })\n\n      assert is_float(result.temperature)\n    end\n\n    test \"handles API errors\" do\n      Req.Test.stub(Lux.Lens, fn conn ->\n        Req.Test.json(conn, %{\"error\" => \"City not found\"})\n      end)\n\n      assert {:error, _} = MyApp.Lenses.WeatherAPI.focus(%{\n        q: \"NonexistentCity\",\n        units: \"metric\",\n        appid: System.fetch_env!(\"LB_OPEN_WEATHER_API_KEY\")\n      })\n    end\n  end\nend\n\nExUnit.run()\n```","ref":"lenses.html#best-practices"},{"type":"extras","title":"Advanced Topics - Lenses Guide","doc":"","ref":"lenses.html#advanced-topics"},{"type":"extras","title":"Retry Logic - Lenses Guide","doc":"```elixir\ndefmodule MyApp.Lenses.RetryingAPI do\n  use Lux.Lens,\n    name: \"Retrying API\",\n    url: \"https://api.example.com/data\",\n    retry: %{\n      max_attempts: 3,\n      base_delay: 1000,\n      max_delay: 5000,\n      exponential: true\n    }\n\n  def should_retry?({:error, %{status: status}}) do\n    status in [500, 502, 503, 504]\n  end\n  def should_retry?(_), do: false\n\n  def after_focus(response) do\n    {:ok, response}\n  end\nend\n```","ref":"lenses.html#retry-logic"},{"type":"extras","title":"Multi-Agent Collaboration Guide","doc":"# Multi-Agent Collaboration Guide\n\n```elixir\nMix.install(\n  [\n    {:lux, \"~> 0.4.0\"}\n    {:kino, \"~> 0.14.2\"}\n  ],\n  config: [\n    lux: [\n      open_ai_models: [\n        default: \"gpt-4o-mini\"\n      ],\n      api_keys: [\n        openai: System.fetch_env!(\"LB_OPENAI_API_KEY\")\n      ]\n    ]\n  ]\n)\n```","ref":"multi_agent_collaboration.html"},{"type":"extras","title":"Introduction - Multi-Agent Collaboration Guide","doc":"This guide demonstrates how to create and coordinate multiple agents working together in Lux.","ref":"multi_agent_collaboration.html#introduction"},{"type":"extras","title":"Basic Concepts - Multi-Agent Collaboration Guide","doc":"Multi-agent collaboration in Lux is built on several key components:\n\n1. **Agent Hub**: Central system for discovering and tracking agents\n2. **Capabilities**: Tags that describe what an agent can do\n3. **Status Tracking**: Monitoring agent availability and workload\n4. **Message Passing**: Communication between agents","ref":"multi_agent_collaboration.html#basic-concepts"},{"type":"extras","title":"Creating Collaborative Agents - Multi-Agent Collaboration Guide","doc":"Here's an example of creating two agents that work together:\n\n```elixir\ndefmodule MyApp.Agents.Researcher do\n  use Lux.Agent,\n    name: \"Research Assistant\",\n    description: \"Specialized in research and analysis\",\n    goal: \"Find and analyze information accurately\",\n    capabilities: [:research, :analysis],\n    llm_config: %{\n      model: \"gpt-4o-mini\",\n      max_tokens: 500,\n      messages: [\n        %{\n          role: \"system\",\n          content: \"\"\"\n          You are a Research Assistant specialized in finding and analyzing information.\n          Work with other agents to provide comprehensive research results.\n          \"\"\"\n        }\n      ]\n    }\nend\n\ndefmodule MyApp.Agents.Writer do\n  use Lux.Agent,\n    name: \"Content Writer\",\n    description: \"Specialized in content creation\",\n    goal: \"Create engaging content from research\",\n    capabilities: [:writing, :editing],\n    llm_config: %{\n      model: \"gpt-4o-mini\",\n      max_tokens: 500,\n      messages: [\n        %{\n          role: \"system\",\n          content: \"\"\"\n          You are a Content Writer specialized in creating engaging content.\n          Work with researchers to transform their findings into compelling articles.\n          \"\"\"\n        }\n      ]\n    }\nend\n```","ref":"multi_agent_collaboration.html#creating-collaborative-agents"},{"type":"extras","title":"Starting and Registering Agents - Multi-Agent Collaboration Guide","doc":"Let's start the agents.\n\n```elixir\nalias MyApp.Agents.Researcher\nalias MyApp.Agents.Writer\n\n{:ok, researcher_pid} = Kino.start_child({Researcher, []})\n{:ok, writer_pid} = Kino.start_child({Writer, []})\n```\n\nYou can check agent's state with `get_state/1` function.\n\n```elixir\nresearcher = Researcher.get_state(researcher_pid)\n```\n\n```elixir\nwriter = Writer.get_state(writer_pid)\n```\n\nStart your own agent hub.\n\n> If you want to use default agent hub, you can get it with `Lux.AgentHub.get_default/0` function.\n\n```elixir\n{:ok, hub} = Kino.start_child({Lux.AgentHub, [name: :my_hub]})\n```\n\nRegister agents with their capabilities\n\n```elixir\n:ok =\n  Lux.AgentHub.register(\n    hub,\n    researcher,\n    researcher_pid,\n    [:research, :analysis]\n  )\n\n:ok =\n  Lux.AgentHub.register(\n    hub,\n    writer,\n    writer_pid,\n    [:writing, :editing]\n  )\n```","ref":"multi_agent_collaboration.html#starting-and-registering-agents"},{"type":"extras","title":"Finding and Using Agents - Multi-Agent Collaboration Guide","doc":"You can find agents by their capabilities.\n\n```elixir\nresearch_agents = Lux.AgentHub.find_by_capability(hub, :research)\n```\n\n```elixir\nwriting_agents = Lux.AgentHub.find_by_capability(hub, :writing)\n```\n\nOr you can get specific agent info with `id`\n\n```elixir\n{:ok, researcher_info} = Lux.AgentHub.get_agent_info(hub, researcher.id)\n```","ref":"multi_agent_collaboration.html#finding-and-using-agents"},{"type":"extras","title":"Coordinating Work Between Agents - Multi-Agent Collaboration Guide","doc":"Here's an example of how to coordinate work between a researcher and writer:\n\n```elixir\nframe = Kino.Frame.new() |> Kino.render()\n\n# 1. Update researcher status to busy\n:ok = Lux.AgentHub.update_status(hub, researcher.id, :busy)\n\n# 2. Start with a research task\n{:ok, research_response} = \n  Researcher.send_message(\n    researcher_pid,\n    \"Research the impact of AI on healthcare\"\n  )\n\n# 3. Mark researcher as available again\n:ok = Lux.AgentHub.update_status(hub, researcher.id, :available)\n\nKino.Frame.append(frame, research_response)\n\n# 4. Update writer status to busy\n:ok = Lux.AgentHub.update_status(hub, writer.id, :busy)\n\n# 5. Send research to writer for content creation\n{:ok, article} = \n  Writer.send_message(\n    writer_pid,\n    \"\"\"\n    Create an engaging blog post based on this research:\n    #{research_response}\n    \"\"\"\n  )\n\n# 6. Mark writer as avaiable again\n:ok = Lux.AgentHub.update_status(hub, writer.id, :available)\n\nKino.Frame.append(frame, article)\n\nKino.nothing()\n```","ref":"multi_agent_collaboration.html#coordinating-work-between-agents"},{"type":"extras","title":"Best Practices - Multi-Agent Collaboration Guide","doc":"1. **Status Management**\n\n   * Always update agent status when starting/finishing work\n   * Check agent availability before sending tasks\n   * Handle offline agents gracefully\n\n2. **Capability Design**\n\n   * Use specific, descriptive capability names\n   * Avoid overlapping capabilities\n   * Document expected inputs/outputs for each capability\n\n3. **Error Handling**\n\n   * Handle agent unavailability\n   * Implement retry mechanisms for failed communications\n   * Monitor agent health\n\n```elixir\nLux.AgentHub.find_by_capability(hub, :research)\n```","ref":"multi_agent_collaboration.html#best-practices"},{"type":"extras","title":"Example: Research and Writing Pipeline - Multi-Agent Collaboration Guide","doc":"Here's a complete example of a research and writing pipeline:\n\n```elixir\ndefmodule MyApp.Workflows.ContentCreation do\n  alias Lux.AgentHub\n  \n  def create_article(topic) do\n    # Get Agent Hub's pid\n    hub = Process.whereis(:my_hub)\n\n    # Find available researcher\n    case AgentHub.find_by_capability(hub, :research) do\n      [%{agent: researcher, pid: researcher_pid, status: :available} | _] ->\n        # Update researcher status\n        :ok = AgentHub.update_status(hub, researcher.id, :busy)\n        \n        # Get research\n        {:ok, research} = Researcher.send_message(\n          researcher_pid,\n          \"Research #{topic} comprehensively\"\n        )\n        \n        # Mark researcher as available\n        :ok = AgentHub.update_status(hub, researcher.id, :available)\n        \n        # Find available writer\n        case AgentHub.find_by_capability(hub, :writing) do\n          [%{pid: writer_pid} | _] ->\n            # Create content\n            {:ok, article} = Writer.send_message(\n              writer_pid,\n              \"\"\"\n              Create an engaging article based on this research:\n              #{research}\n              \"\"\"\n            )\n            \n            {:ok, article}\n            \n          [] ->\n            {:error, :no_writers_available}\n        end\n        \n      [] ->\n        {:error, :no_researchers_available}\n    end\n  end\nend\n```\n\n```elixir\nMyApp.Workflows.ContentCreation.create_article(\"\"\"\nAI & Blockchain\n\"\"\")\n```","ref":"multi_agent_collaboration.html#example-research-and-writing-pipeline"},{"type":"extras","title":"Advanced Topics - Multi-Agent Collaboration Guide","doc":"","ref":"multi_agent_collaboration.html#advanced-topics"},{"type":"extras","title":"Scaling Agent Teams - Multi-Agent Collaboration Guide","doc":"As your system grows, consider:\n\n* Implementing load balancing between similar agents\n* Adding specialized agents for specific tasks\n* Using agent pools for high-demand capabilities","ref":"multi_agent_collaboration.html#scaling-agent-teams"},{"type":"extras","title":"Monitoring and Debugging - Multi-Agent Collaboration Guide","doc":"Track agent collaboration using:\n\n* Agent status history\n* Task completion metrics\n* Communication logs","ref":"multi_agent_collaboration.html#monitoring-and-debugging"},{"type":"extras","title":"Security Considerations - Multi-Agent Collaboration Guide","doc":"* Implement authentication between agents\n* Validate message contents\n* Rate limit agent interactions\n* Monitor resource usage","ref":"multi_agent_collaboration.html#security-considerations"},{"type":"extras","title":"Next Steps - Multi-Agent Collaboration Guide","doc":"1. Implement more sophisticated collaboration patterns\n2. Add error recovery mechanisms\n3. Create specialized agent teams\n4. Implement performance monitoring","ref":"multi_agent_collaboration.html#next-steps"},{"type":"extras","title":"Trading System Example","doc":"# Trading System Example\n\n```elixir\nMix.install(\n  [\n    {:lux, \"~> 0.4.0\"}\n    {:kino, \"~> 0.14.2\"}\n  ],\n  start_applications: false,\n  config: [\n    lux: [\n      api_keys: [\n        openai: System.fetch_env!(\"LB_OPENAI_API_KEY\")\n      ],\n      open_ai_models: [\n        default: \"gpt-4o-mini\"\n      ],\n      accounts: [\n        hyperliquid_private_key: System.fetch_env!(\"LB_HYPERLIQUID_PRIVATE_KEY\"),\n        hyperliquid_address: System.fetch_env!(\"LB_HYPERLIQUID_ADDRESS\"),\n        hyperliquid_api_url: System.fetch_env!(\"LB_HYPERLIQUID_API_URL\")\n      ]\n    ]\n  ]\n)\n\nMix.Task.run(\"setup\", install_deps: false)\n\nApplication.put_env(:venomous, :snake_manager, %{\n  python_opts: [\n    module_paths: [\n      Lux.Python.module_path(),\n      Lux.Python.module_path(:deps)\n    ],\n    python_executable: \"python3\"\n  ]\n})\n\nApplication.ensure_all_started([:lux, :kino])\n```","ref":"trading_system.html"},{"type":"extras","title":"Environment Setup - Trading System Example","doc":"Before running this notebook, you'll need to set up the following secrets in your Livebook settings:\n\n```\nLB_OPENAI_API_KEY=\"\"          # Your OpenAI API key\nLB_HYPERLIQUID_PRIVATE_KEY=\"\" # Your Hyperliquid private key\nLB_HYPERLIQUID_ADDRESS=\"\"     # Your Hyperliquid wallet address\nLB_HYPERLIQUID_API_URL=\"https://api.hyperliquid.xyz\"\n```\n\nWhen you run this notebook for the first time, you can get an error and see `Add secret` button. After you add the secret and evaludate the setup cell again, you'll get another button to add other secrets.\n\n![](https://github.com/user-attachments/assets/907d68cb-2d73-46b3-93ab-c55149a4f992)","ref":"trading_system.html#environment-setup"},{"type":"extras","title":"Overview - Trading System Example","doc":"This example demonstrates a simple trading system built with Lux agents. The system consists of:\n\n* A Market Researcher agent that analyzes market conditions and proposes trades\n* A Risk Manager agent that evaluates trade proposals\n* An Agent Hub that coordinates communication between agents\n* A Local Signal Router for message passing","ref":"trading_system.html#overview"},{"type":"extras","title":"Running the Trading System - Trading System Example","doc":"Here's the complete trading system implementation:\n\n```elixir\ndefmodule ExampleApp.TradingSystem do\n  @moduledoc \"\"\"\n  Simple interface for running the trading system.\n  \"\"\"\n\n  alias Lux.Agents.MarketResearcher\n  alias Lux.AgentHub\n  alias Lux.Signal.Router.Local\n  alias Lux.Signals.TradeProposal\n\n  require Logger\n\n  @doc \"\"\"\n  Runs one iteration of market analysis and trading.\n  \"\"\"\n  def run(researcher_id, risk_manager_id) do\n    hub = AgentHub.get_default()\n    router = Process.whereis(:trading_router)\n\n    {:ok, %{agent: researcher, pid: researcher_pid}} = AgentHub.get_agent_info(hub, researcher_id)\n    {:ok, %{agent: risk_manager}} = AgentHub.get_agent_info(hub, risk_manager_id)\n\n    # Example market conditions (replace with real data)\n    market_conditions = %{\n      \"ETH\" => %{\n        \"price\" => 2800.0,\n        \"24h_volume\" => 1_000_000,\n        \"volatility\" => 0.15\n      }\n    }\n\n    # Get trade proposal from researcher and send to risk manager\n    with {:ok, signal} <- MarketResearcher.propose_trade(researcher_pid, market_conditions) do\n      # Create a signal to send to the risk manager\n      {:ok, trade_signal} = TradeProposal.new(%{\n        payload: signal,\n        sender: researcher.id,\n        recipient: risk_manager.id\n      })\n\n      signal_id = trade_signal.id\n\n      # Subscribe to signal delivery events\n      :ok = Local.subscribe(signal_id, name: router)\n\n      # Update researcher status to busy while processing\n      :ok = AgentHub.update_status(hub, researcher.id, :busy)\n\n      # Route the signal through the local router\n      :ok = Local.route(trade_signal, name: router, hub: hub)\n\n      # Wait for signal delivery confirmation\n      receive do\n        {:signal_delivered, ^signal_id} ->\n          Logger.info(\"Trade signal delivered successfully\")\n          :ok = AgentHub.update_status(hub, researcher.id, :available)\n\n        {:signal_failed, ^signal_id, reason} ->\n          Logger.error(\"Failed to deliver trade signal: #{inspect(reason)}\")\n          :ok = AgentHub.update_status(hub, researcher.id, :available)\n      after\n        5000 ->\n          Logger.error(\"Timeout waiting for signal delivery\")\n          :ok = AgentHub.update_status(hub, researcher.id, :available)\n          {:error, :timeout}\n      end\n    end\n  end\nend\n```\n\nBefore start the system, let's start some agents and register them to `Lux.AgentHub`.\n\n```elixir\nalias Lux.Agents.MarketResearcher\nalias Lux.Agents.RiskManager\nalias Lux.AgentHub\nalias Lux.Signal.Router.Local\n\n# Get default agent hub \nhub = AgentHub.get_default()\n\n# Start the signal router\n{:ok, router} = Kino.start_child({Local, [name: :trading_router]})\n\n# Start both agents\n{:ok, researcher_pid} = Kino.start_child({MarketResearcher, []})\n{:ok, risk_manager_pid} = Kino.start_child({RiskManager, []})\n\n# Get agent states\nresearcher = :sys.get_state(researcher_pid)\nrisk_manager = :sys.get_state(risk_manager_pid)\n\n# Register agents with their capabilities\n:ok = AgentHub.register(hub, researcher, researcher_pid, [:market_research, :analysis])\n:ok = AgentHub.register(hub, risk_manager, risk_manager_pid, [:risk_management])\n```\n\nLet's try running the trading system:\n\n```elixir\nExampleApp.TradingSystem.run(\n  researcher.id,\n  risk_manager.id\n)\n```","ref":"trading_system.html#running-the-trading-system"},{"type":"extras","title":"How It Works - Trading System Example","doc":"1. **System Setup**\n\n   * The system starts by initializing an AgentHub and Local Router\n   * Two agents are created: MarketResearcher and RiskManager\n   * Agents are registered with their capabilities in the hub\n\n2. **Market Analysis**\n\n   * The MarketResearcher analyzes market conditions\n   * If a trading opportunity is found, it creates a trade proposal\n\n3. **Signal Routing**\n\n   * Trade proposals are wrapped in a TradeProposal signal\n   * The Local Router handles delivery between agents\n   * The system monitors signal delivery status\n\n4. **Risk Management**\n\n   * The RiskManager receives and evaluates trade proposals\n   * It applies risk management rules before approving trades\n\nThis example demonstrates core Lux concepts including:\n\n* Agent-based architecture\n* Signal-based communication\n* Capability registration\n* Status management\n* Error handling","ref":"trading_system.html#how-it-works"},{"type":"extras","title":"Next Steps - Trading System Example","doc":"To extend this example, you could:\n\n* Add more sophisticated market analysis\n* Implement additional risk management rules\n* Add trade execution functionality\n* Include position tracking\n* Add portfolio management\n* Implement backtesting capabilities","ref":"trading_system.html#next-steps"},{"type":"extras","title":"Language Support in Lux","doc":"# Language Support in Lux\n\nLux is designed to be language-agnostic, allowing you to build agents in your preferred programming language. This guide provides an overview of language support in Lux and how to use different programming languages in your agents.","ref":"language_support.html"},{"type":"extras","title":"Currently Supported Languages - Language Support in Lux","doc":"","ref":"language_support.html#currently-supported-languages"},{"type":"extras","title":"Python Integration - Language Support in Lux","doc":"[Learn more about Python integration](language_support/python.livemd)\n\nPython is a first-class citizen in Lux, with deep integration into the framework. You can:\n- Write Python code directly in your Elixir files using `~PY` sigils\n- Add custom Python modules under `priv/python` and import them\n- Use any Python package through pip/poetry\n- Leverage Python's rich ML and data science ecosystem\n\n> 🔥 **Coming Soon**: Define Prisms, Beams, and other Lux components entirely in Python! This will allow you to write your agents' logic completely in Python while still leveraging Lux's powerful orchestration capabilities.","ref":"language_support.html#python-integration"},{"type":"extras","title":"Node.js/JavaScript Integration - Language Support in Lux","doc":"[Learn more about Node.js integration](language_support/nodejs.livemd)\n\nNode.js integration allows you to leverage the vast JavaScript ecosystem:\n- Write JavaScript/TypeScript code using `~JS` sigils\n- Use NPM packages in your agents\n- Support for modern ES modules and async/await\n- Full access to Node.js APIs","ref":"language_support.html#node-js-javascript-integration"},{"type":"extras","title":"Future Language Support - Language Support in Lux","doc":"","ref":"language_support.html#future-language-support"},{"type":"extras","title":"Rust Integration (Coming Soon) - Language Support in Lux","doc":"Native Rust integration is under development, which will provide:\n- High-performance components for compute-intensive tasks\n- Direct FFI integration for optimal performance\n- Access to Rust's rich ecosystem\n- Memory-safe interop with Elixir","ref":"language_support.html#rust-integration-coming-soon"},{"type":"extras","title":"Custom Language Integration - Language Support in Lux","doc":"Want to add support for your favorite language? Lux provides a Language Integration Protocol that allows you to:\n- Add new language runtimes\n- Define type conversion rules\n- Handle package management\n- Implement error handling\n\nCheck out our [Contributing Guide](contributing.md) for details on adding language support.","ref":"language_support.html#custom-language-integration"},{"type":"extras","title":"Best Practices - Language Support in Lux","doc":"1. **Choose the Right Language**\n   - Use Python for ML/AI tasks and data processing\n   - Use Node.js for web integration and text processing\n   - Use Elixir for coordination and state management\n   - Consider Rust (coming soon) for performance-critical components\n\n2. **Package Management**\n   - Add custom Python modules under `priv/python/`\n   - Use `poetry` for Python dependency management\n   - Use `npm`/`yarn` for Node.js dependencies\n   - Follow the language's best practices for versioning\n\n3. **Performance Considerations**\n   - Minimize cross-language calls\n   - Batch operations when possible\n   - Use appropriate data serialization\n   - Consider memory usage patterns\n\n4. **Security**\n   - Validate all inputs\n   - Control package versions\n   - Follow security best practices for each language\n   - Implement proper sandboxing","ref":"language_support.html#best-practices"},{"type":"extras","title":"Examples - Language Support in Lux","doc":"Check out these examples of language integration:\n\n- [Trading System](trading_system.livemd): Uses Python for data analysis\n- [Content Creation](running_a_company.livemd): Uses JavaScript for text processing\n- [Research Assistant](multi_agent_collaboration.livemd): Combines multiple languages","ref":"language_support.html#examples"},{"type":"extras","title":"Contributing - Language Support in Lux","doc":"Want to add support for a new language? Check our [Contributing Guide](contributing.md) and:\n\n1. Review the Language Integration Protocol\n2. Create a proof of concept\n3. Add comprehensive tests\n4. Document the integration\n5. Submit a pull request\n\nFor detailed examples and up-to-date documentation, visit [hexdocs.pm/lux](https://hexdocs.pm/lux).","ref":"language_support.html#contributing"},{"type":"extras","title":"Python Integration in Lux","doc":"# Python Integration in Lux\n\n```elixir\nMix.install([\n  {:lux, \"~> 0.4.0\"},\n  {:kino, \"~> 0.14.2\"}\n])\n\nApplication.ensure_all_started([:lux])\n```","ref":"python.html"},{"type":"extras","title":"Overview - Python Integration in Lux","doc":"Lux provides first-class support for Python, allowing you to leverage Python's rich ecosystem of libraries and tools in your agents. This guide explains how to use Python effectively with Lux.","ref":"python.html#overview"},{"type":"extras","title":"Writing Python Code - Python Integration in Lux","doc":"","ref":"python.html#writing-python-code"},{"type":"extras","title":"Using the ~PY Sigil - Python Integration in Lux","doc":"The `~PY` sigil allows you to write Python code directly in your Elixir files:\n\n```elixir\ndefmodule MyApp.Prisms.DataAnalysisPrism do\n  use Lux.Prism,\n    name: \"Data Analysis\"\n\n  require Lux.Python\n  import Lux.Python\n\n  def handler(input, _ctx) do\n    result = python variables: %{data: input} do\n      ~PY\"\"\"\n      import numpy as np\n      \n      # Process input data\n      array = np.array(data)\n      mean = np.mean(array)\n      std = np.std(array)\n      \n      {\n          \"mean\": float(mean),\n          \"std\": float(std),\n          \"shape\": array.shape\n      }\n      \"\"\"\n    end\n\n    {:ok, result}\n  end\nend\n```\n\nLet's try it out with some real data:\n\n```elixir\nrequire Lux.Python\nimport Lux.Python\n\ndata = [1, 2, 3, 4, 5]\n\npython variables: %{data: data} do\n  ~PY\"\"\"\n  import numpy as np\n  \n  array = np.array(data)\n  mean = np.mean(array)\n  std = np.std(array)\n  \n  {\n      \"mean\": float(mean),\n      \"std\": float(std),\n      \"shape\": array.shape\n  }\n  \"\"\"\nend\n```\n\nKey features:\n- Multi-line Python code with proper indentation\n- Variable binding between Elixir and Python\n- Automatic type conversion\n- Error handling and timeouts","ref":"python.html#using-the-py-sigil"},{"type":"extras","title":"Custom Python Modules - Python Integration in Lux","doc":"You can add your own Python modules under the `priv/python` directory:\n\n```\npriv/python/\n├── my_module/\n│   ├── __init__.py\n│   ├── analysis.py\n│   └── utils.py\n├── another_module.py\n└── pyproject.toml\n```\n\nThese modules can be imported and used in your Lux code:\n\n```elixir\npython do\n  ~PY\"\"\"\n  from my_module.analysis import process_data\n  from my_module.utils import format_output\n  \n  result = process_data(input_data)\n  formatted = format_output(result)\n  \"\"\"\nend\n```","ref":"python.html#custom-python-modules"},{"type":"extras","title":"Package Management - Python Integration in Lux","doc":"","ref":"python.html#package-management"},{"type":"extras","title":"Using Poetry - Python Integration in Lux","doc":"Lux uses Poetry for Python package management. The `pyproject.toml` file in `priv/python` defines your dependencies:\n\n```toml\n[tool.poetry]\nname = \"lux-python\"\nversion = \"0.1.0\"\ndescription = \"Python support for Lux framework\"\n\n[tool.poetry.dependencies]\npython = \"^3.9\"\nnumpy = \"^1.24.0\"\npandas = \"^2.0.0\"\nscikit-learn = \"^1.2.0\"\n\n[tool.poetry.dev-dependencies]\npytest = \"^7.0.0\"\nblack = \"^23.0.0\"\n```\n\nTo install dependencies:\n\n```bash\ncd priv/python\npoetry install\n```","ref":"python.html#using-poetry"},{"type":"extras","title":"Importing Packages - Python Integration in Lux","doc":"Use `Lux.Python.import_package/1` to dynamically import Python packages:\n\n```elixir\n# Import numpy for numerical operations\n{:ok, %{\"success\" => true}} = Lux.Python.import_package(\"numpy\")\n\n# Let's use it in a calculation\npython do\n  ~PY\"\"\"\n  import numpy as np\n  \n  # Create an array and perform operations\n  array = np.array([1, 2, 3, 4, 5])\n  mean = np.mean(array)\n  std = np.std(array)\n  \n  {\"mean\": float(mean), \"std\": float(std)}\n  \"\"\"\nend\n```","ref":"python.html#importing-packages"},{"type":"extras","title":"Type Conversion - Python Integration in Lux","doc":"Lux automatically handles type conversion between Elixir and Python:\n\n| Elixir Type | Python Type |\n|-------------|-------------|\n| `nil` | `None` |\n| `true`/`false` | `True`/`False` |\n| Integer | `int` |\n| Float | `float` |\n| String | `str` |\n| List | `list` |\n| Map | `dict` |\n| Struct | `dict` |\n\nLet's see type conversion in action:\n\n```elixir\npython variables: %{\n  number: 42,\n  text: \"hello\",\n  list: [1, 2, 3],\n  map: %{key: \"value\"}\n} do\n  ~PY\"\"\"\n  # Check types of converted variables\n  result = {\n    \"number_type\": str(type(number)),\n    \"text_type\": str(type(text)),\n    \"list_type\": str(type(list)),\n    \"map_type\": str(type(map))\n  }\n  \n  # Show some conversions\n  result[\"conversions\"] = {\n    \"none_to_nil\": None,\n    \"bool_to_atom\": True,\n    \"int_to_integer\": 42,\n    \"list_to_list\": [1, \"two\", 3.0]\n  }\n  \n  result\n  \"\"\"\nend\n```","ref":"python.html#type-conversion"},{"type":"extras","title":"Error Handling - Python Integration in Lux","doc":"Python errors are converted to Elixir exceptions. You have several options for handling them:","ref":"python.html#error-handling"},{"type":"extras","title":"1. Handle Errors in Python - Python Integration in Lux","doc":"```elixir\n# Handle errors directly in Python code\npython do\n  ~PY\"\"\"\n  try:\n    # This will raise a NameError\n    result = undefined_variable\n  except NameError as e:\n    result = {\"error\": str(e)}\n  except Exception as e:\n    result = {\"error\": f\"Unexpected error: {str(e)}\"}\n    \n  result\n  \"\"\"\nend\n```","ref":"python.html#1-handle-errors-in-python"},{"type":"extras","title":"2. Handle Exceptions in Elixir - Python Integration in Lux","doc":"```elixir\n# Use try/rescue in Elixir\ntry do\n  python! do\n    ~PY\"\"\"\n    # This will raise a NameError\n    undefined_variable\n    \"\"\"\n  end\nrescue\n  RuntimeError -> \"Caught Python error\"\nend\n```","ref":"python.html#2-handle-exceptions-in-elixir"},{"type":"extras","title":"3. Pattern Match on Results - Python Integration in Lux","doc":"```elixir\n# Use pattern matching with python/2\ncase python do\n  ~PY\"\"\"\n  import math\n  \n  try:\n    result = math.sqrt(-1)  # This will raise a ValueError\n    {\"success\": True, \"result\": result}\n  except ValueError as e:\n    {\"success\": False, \"error\": str(e)}\n  \"\"\"\nend do\n  {:ok, %{\"success\" => true, \"result\" => result}} -> \n    \"Got result: #{result}\"\n  {:ok, %{\"success\" => false, \"error\" => error}} -> \n    \"Got error: #{error}\"\n  {:error, error} -> \n    \"Python execution failed: #{error}\"\nend\n```","ref":"python.html#3-pattern-match-on-results"},{"type":"extras","title":"Testing - Python Integration in Lux","doc":"","ref":"python.html#testing"},{"type":"extras","title":"Elixir Tests - Python Integration in Lux","doc":"Test your Python code using the standard Elixir testing tools:\n\n```elixir\ndefmodule MyApp.Prisms.DataAnalysisPrismTest do\n  use UnitCase, async: true\n  \n  import Lux.Python\n  \n  test \"processes data correctly\" do\n    result = python variables: %{data: [1, 2, 3, 4, 5]} do\n      ~PY\"\"\"\n      import numpy as np\n      np.mean(data)\n      \"\"\"\n    end\n    \n    assert {:ok, 3.0} = result\n  end\n  \n  test \"handles errors gracefully\" do\n    result = python do\n      ~PY\"\"\"\n      try:\n        undefined_variable\n      except NameError:\n        {\"status\": \"error\", \"message\": \"Variable not defined\"}\n      \"\"\"\n    end\n    \n    assert {:ok, %{\"status\" => \"error\"}} = result\n  end\nend\n```","ref":"python.html#elixir-tests"},{"type":"extras","title":"Python Tests - Python Integration in Lux","doc":"You can write native Python tests under `priv/python/tests/`. These tests use pytest and can be run directly from your project root using the `mix python.test` command.\n\nHere's an example test structure:\n\n```\npriv/python/\n├── tests/\n│   ├── __init__.py\n│   ├── test_eval.py      # Tests for eval module\n│   ├── test_analysis.py  # Tests for your custom modules\n│   └── test_utils.py     # Tests for utility functions\n├── my_module/\n│   ├── __init__.py\n│   ├── analysis.py\n│   └── utils.py\n└── pyproject.toml\n```\n\nExample test file (`test_analysis.py`):\n\n```python\n\"\"\"Tests for the analysis module.\"\"\"\nimport pytest\nfrom my_module.analysis import process_data\n\ndef test_process_data():\n    \"\"\"Test basic data processing functionality.\"\"\"\n    input_data = [1, 2, 3, 4, 5]\n    result = process_data(input_data)\n    assert \"mean\" in result\n    assert \"std\" in result\n    assert result[\"mean\"] == 3.0\n\ndef test_process_data_empty():\n    \"\"\"Test handling of empty input.\"\"\"\n    with pytest.raises(ValueError, match=\"Input data cannot be empty\"):\n        process_data([])\n\ndef test_process_data_types():\n    \"\"\"Test type conversion and validation.\"\"\"\n    result = process_data([1, 2.5, \"3\"])  # Mixed types\n    assert isinstance(result[\"mean\"], float)\n    assert isinstance(result[\"std\"], float)\n```\n\nTo run the Python tests:\n\n```bash\n# Run all Python tests\nmix python.test\n\n# Run specific test file\nmix python.test tests/test_analysis.py\n\n# Run tests with specific marker\nmix python.test --marker=integration\n\n# Run tests with pytest options\nmix python.test --verbose --capture=no\n```\n\nThe test runner will:\n1. Ensure the test directory exists and create it if needed\n2. Install pytest and pytest-cov if not already installed\n3. Run the tests with coverage reporting\n4. Display test results and coverage information","ref":"python.html#python-tests"},{"type":"extras","title":"Test Best Practices - Python Integration in Lux","doc":"1. **Test Organization**\n   - Keep Python tests in `priv/python/tests/`\n   - Use descriptive test names with docstrings\n   - Group related tests in classes or modules\n   - Follow pytest best practices for fixtures and markers\n\n2. **Test Coverage**\n   - Test both success and error paths\n   - Test type conversions thoroughly\n   - Test edge cases and boundary conditions\n   - Use pytest's parametrize for multiple test cases\n\n3. **Test Performance**\n   - Use pytest fixtures for setup/teardown\n   - Mock external services and heavy operations\n   - Use appropriate scopes for fixtures\n   - Consider test isolation needs\n\n4. **Test Maintenance**\n   - Keep tests focused and readable\n   - Document test requirements in docstrings\n   - Update tests when behavior changes\n   - Use CI/CD to run tests automatically","ref":"python.html#test-best-practices"},{"type":"extras","title":"Best Practices - Python Integration in Lux","doc":"1. **Module Organization**\n   - Keep related Python code in modules under `priv/python`\n   - Use clear module and function names\n   - Follow Python style guidelines (PEP 8)\n\n2. **Performance**\n   - Batch operations to minimize cross-language calls\n   - Use NumPy for numerical operations\n   - Consider memory usage with large datasets\n\n3. **Error Handling**\n   - Handle expected errors in Python with try/except\n   - Use pattern matching in Elixir for high-level flow control\n   - Provide meaningful error messages\n   - Clean up resources in error cases\n\n4. **Testing**\n   - Test both success and error cases\n   - Verify type conversions\n   - Test with realistic data","ref":"python.html#best-practices"},{"type":"extras","title":"Coming Soon - Python Integration in Lux","doc":"Lux will soon support defining components entirely in Python:\n\n```python\nfrom lux import Prism, Beam, Agent\n\nclass MyPrism(Prism):\n    name = \"Python Prism\"\n    description = \"A prism implemented in Python\"\n    \n    def handler(self, input, context):\n        try:\n            # Process input\n            result = self.process_data(input)\n            return {\"success\": True, \"data\": result}\n        except Exception as e:\n            return {\"success\": False, \"error\": str(e)}\n```\n\nThis will allow you to:\n- Write agents entirely in Python\n- Define prisms and beams in Python\n- Use Python's class system\n- Leverage Python's async capabilities\n\nStay tuned for updates!","ref":"python.html#coming-soon"},{"type":"extras","title":"Node.js Integration in Lux","doc":"# Node.js Integration in Lux\n\n```elixir\nMix.install([\n  {:lux, \"~> 0.4.0\"},\n  {:kino, \"~> 0.14.2\"}\n])\n\nApplication.ensure_all_started([:lux])\n```","ref":"nodejs.html"},{"type":"extras","title":"Overview - Node.js Integration in Lux","doc":"Lux provides robust support for Node.js, allowing you to leverage the vast JavaScript ecosystem in your agents. This guide explains how to use Node.js effectively with Lux.","ref":"nodejs.html#overview"},{"type":"extras","title":"Writing JavaScript Code - Node.js Integration in Lux","doc":"","ref":"nodejs.html#writing-javascript-code"},{"type":"extras","title":"Using the ~JS Sigil - Node.js Integration in Lux","doc":"The `~JS` sigil allows you to write JavaScript code directly in your Elixir files. Note that all JavaScript code must export a `main` function that will be called by Lux:\n\n```elixir\ndefmodule MyApp.Prisms.TextProcessingPrism do\n  use Lux.Prism,\n    name: \"Text Processing\"\n\n  require Lux.NodeJS\n  import Lux.NodeJS\n\n  def handler(input, _ctx) do\n    result = nodejs variables: %{text: input} do\n      ~JS\"\"\"\n      import { tokenize } from 'natural';\n      import { sentiment } from 'sentiment';\n      \n      export const main = ({text}) => {\n        // Process input text\n        const tokens = tokenize(text);\n        const analysis = sentiment(text);\n        \n        return {\n          tokens,\n          sentiment: analysis.score,\n          comparative: analysis.comparative\n        };\n      };\n      \"\"\"\n    end\n\n    {:ok, result}\n  end\nend\n```\n\nLet's try it with some simple text processing:\n\n```elixir\nrequire Lux.NodeJS\nimport Lux.NodeJS\n\n# First, import the natural language processing package\n{:ok, %{\"success\" => true}} = Lux.NodeJS.import_package(\"natural\")\n\n# Now process some text\nnodejs variables: %{text: \"Hello, this is a test sentence!\"} do\n  ~JS\"\"\"\n  import { tokenize, PorterStemmer } from 'natural';\n  \n  export const main = ({text}) => {\n    const tokens = tokenize(text);\n    const stems = tokens.map(token => PorterStemmer.stem(token));\n    \n    return {\n      original: text,\n      tokens,\n      stems\n    };\n  };\n  \"\"\"\nend\n```\n\nKey features:\n- Modern JavaScript (ES modules) support\n- Variable binding between Elixir and JavaScript\n- Automatic type conversion\n- Error handling and timeouts\n- Full async/await support","ref":"nodejs.html#using-the-js-sigil"},{"type":"extras","title":"Custom JavaScript Modules - Node.js Integration in Lux","doc":"You can add your own JavaScript modules under the `priv/node` directory:\n\n```\npriv/node/\n├── src/\n│   ├── analysis.mjs\n│   └── utils.mjs\n├── package.json\n└── package-lock.json\n```\n\nThese modules can be imported and used in your Lux code:\n\n```elixir\nnodejs do\n  ~JS\"\"\"\n  import { analyzeText } from './src/analysis.mjs';\n  import { formatOutput } from './src/utils.mjs';\n  \n  export const main = async () => {\n    const result = await analyzeText(input);\n    return formatOutput(result);\n  };\n  \"\"\"\nend\n```","ref":"nodejs.html#custom-javascript-modules"},{"type":"extras","title":"Package Management - Node.js Integration in Lux","doc":"","ref":"nodejs.html#package-management"},{"type":"extras","title":"Using NPM - Node.js Integration in Lux","doc":"Lux uses NPM for JavaScript package management. The `package.json` file in `priv/node` defines your dependencies:\n\n```json\n{\n  \"name\": \"lux-nodejs\",\n  \"version\": \"0.1.0\",\n  \"description\": \"Node.js support for Lux framework\",\n  \"type\": \"module\",\n  \"dependencies\": {\n    \"natural\": \"^6.0.0\",\n    \"sentiment\": \"^5.0.0\",\n    \"lodash\": \"^4.17.21\"\n  },\n  \"devDependencies\": {\n    \"jest\": \"^29.0.0\",\n    \"eslint\": \"^8.0.0\"\n  }\n}\n```\n\nTo install dependencies:\n\n```bash\ncd priv/node\nnpm install\n```","ref":"nodejs.html#using-npm"},{"type":"extras","title":"Importing Packages - Node.js Integration in Lux","doc":"Use `Lux.NodeJS.import_package/1` to dynamically import Node.js packages:\n\n```elixir\n# Import lodash for data manipulation\n{:ok, %{\"success\" => true}} = Lux.NodeJS.import_package(\"lodash\")\n\n# Let's use it to process some data\nnodejs variables: %{data: [1, 2, 3, 4, 5]} do\n  ~JS\"\"\"\n  import _ from 'lodash';\n  \n  export const main = ({data}) => {\n    return {\n      sum: _.sum(data),\n      mean: _.mean(data),\n      chunks: _.chunk(data, 2)\n    };\n  };\n  \"\"\"\nend\n```","ref":"nodejs.html#importing-packages"},{"type":"extras","title":"Type Conversion - Node.js Integration in Lux","doc":"Lux automatically handles type conversion between Elixir and JavaScript:\n\n| Elixir Type | JavaScript Type |\n|-------------|----------------|\n| `nil` | `null` |\n| `true`/`false` | `true`/`false` |\n| Integer | `number` |\n| Float | `number` |\n| String | `string` |\n| List | `Array` |\n| Map | `Object` |\n| Struct | JavaScript class |\n\nLet's see type conversion in action:\n\n```elixir\nnodejs variables: %{\n  number: 42,\n  text: \"hello\",\n  list: [1, 2, 3],\n  map: %{key: \"value\"}\n} do\n  ~JS\"\"\"\n  export const main = (vars) => ({\n    numberType: typeof vars.number,\n    textType: typeof vars.text,\n    listType: Array.isArray(vars.list),\n    mapType: typeof vars.map,\n    \n    // Show some conversions\n    conversions: {\n      nullToNil: null,\n      boolToAtom: true,\n      intToNumber: 42,\n      arrayToList: [1, \"two\", 3.0]\n    }\n  });\n  \"\"\"\nend\n```","ref":"nodejs.html#type-conversion"},{"type":"extras","title":"Async/Await Support - Node.js Integration in Lux","doc":"Lux fully supports JavaScript's async/await. The `main` function can be async:\n\n```elixir\n# Import axios for HTTP requests\n{:ok, %{\"success\" => true}} = Lux.NodeJS.import_package(\"axios\")\n\nnodejs do\n  ~JS\"\"\"\n  import axios from 'axios';\n  \n  export const main = async () => {\n    try {\n      const response = await axios.get('https://api.github.com/users/octocat');\n      return {\n        success: true,\n        data: {\n          login: response.data.login,\n          name: response.data.name,\n          repos: response.data.public_repos\n        }\n      };\n    } catch (error) {\n      return {\n        success: false,\n        error: error.message\n      };\n    }\n  };\n  \"\"\"\nend\n```","ref":"nodejs.html#async-await-support"},{"type":"extras","title":"Error Handling - Node.js Integration in Lux","doc":"JavaScript errors are converted to Elixir exceptions. You have several options for handling them:","ref":"nodejs.html#error-handling"},{"type":"extras","title":"1. Handle Errors in JavaScript - Node.js Integration in Lux","doc":"```elixir\n# Handle errors in the JavaScript code\nnodejs do\n  ~JS\"\"\"\n  export const main = () => {\n    try {\n      // This will throw a ReferenceError\n      const result = undefinedVariable;\n      return { success: true, result };\n    } catch (error) {\n      return { \n        success: false, \n        error: error.message,\n        type: error.constructor.name\n      };\n    }\n  };\n  \"\"\"\nend\n```","ref":"nodejs.html#1-handle-errors-in-javascript"},{"type":"extras","title":"2. Handle Exceptions in Elixir - Node.js Integration in Lux","doc":"```elixir\n# Use try/rescue in Elixir\ntry do\n  nodejs! do\n    ~JS\"\"\"\n    export const main = () => {\n      // This will throw an Error\n      throw new Error(\"Something went wrong\");\n    };\n    \"\"\"\n  end\nrescue\n  NodeJS.Error -> \"Caught JavaScript error\"\nend\n```","ref":"nodejs.html#2-handle-exceptions-in-elixir"},{"type":"extras","title":"3. Pattern Match on Results - Node.js Integration in Lux","doc":"```elixir\n# Use pattern matching with nodejs/2\ncase nodejs do\n  ~JS\"\"\"\n  export const main = () => {\n    try {\n      const result = JSON.parse('invalid json');\n      return { success: true, data: result };\n    } catch (error) {\n      return { success: false, error: error.message };\n    }\n  };\n  \"\"\"\nend do\n  {:ok, %{\"success\" => true, \"data\" => data}} -> \n    \"Got data: #{inspect(data)}\"\n  {:ok, %{\"success\" => false, \"error\" => error}} -> \n    \"Got error: #{error}\"\n  {:error, error} -> \n    \"JavaScript execution failed: #{error}\"\nend\n```","ref":"nodejs.html#3-pattern-match-on-results"},{"type":"extras","title":"Testing - Node.js Integration in Lux","doc":"Test your JavaScript code using the standard Elixir testing tools:\n\n```elixir\ndefmodule MyApp.Prisms.TextProcessingPrismTest do\n  use UnitCase, async: true\n  \n  import Lux.NodeJS\n  \n  test \"processes text correctly\" do\n    {:ok, %{\"success\" => true}} = Lux.NodeJS.import_package(\"natural\")\n    \n    result = nodejs variables: %{text: \"Hello, world!\"} do\n      ~JS\"\"\"\n      import { tokenize } from 'natural';\n      \n      export const main = ({text}) => {\n        return tokenize(text);\n      };\n      \"\"\"\n    end\n    \n    assert {:ok, [\"Hello\", \"world\"]} = result\n  end\n  \n  test \"handles errors gracefully\" do\n    result = nodejs do\n      ~JS\"\"\"\n      export const main = () => {\n        try {\n          undefinedVariable;\n        } catch (error) {\n          return {\n            status: \"error\",\n            message: \"Variable not defined\"\n          };\n        }\n      };\n      \"\"\"\n    end\n    \n    assert {:ok, %{\"status\" => \"error\"}} = result\n  end\nend\n```","ref":"nodejs.html#testing"},{"type":"extras","title":"Best Practices - Node.js Integration in Lux","doc":"1. **Module Organization**\n   - Keep related JavaScript code in modules under `priv/node/src`\n   - Use ES modules for better code organization\n   - Follow JavaScript style guidelines\n\n2. **Performance**\n   - Use async/await for I/O operations\n   - Batch operations to minimize cross-language calls\n   - Consider memory usage with large datasets\n\n3. **Error Handling**\n   - Handle expected errors in JavaScript with try/catch\n   - Use pattern matching in Elixir for high-level flow control\n   - Provide meaningful error messages\n   - Clean up resources in error cases\n\n4. **Testing**\n   - Test both success and error cases\n   - Verify type conversions\n   - Test with realistic data","ref":"nodejs.html#best-practices"},{"type":"extras","title":"Coming Soon - Node.js Integration in Lux","doc":"Lux will soon support defining components entirely in JavaScript:\n\n```javascript\nimport { Prism, Beam, Agent } from 'lux';\n\nclass MyPrism extends Prism {\n  name = \"JavaScript Prism\";\n  description = \"A prism implemented in JavaScript\";\n  \n  async handler(input, context) {\n    try {\n      // Process input\n      const result = await this.processData(input);\n      return { success: true, data: result };\n    } catch (error) {\n      return { success: false, error: error.message };\n    }\n  }\n}\n```\n\nThis will allow you to:\n- Write agents entirely in JavaScript\n- Define prisms and beams in JavaScript\n- Use JavaScript's class system\n- Leverage Node.js's async capabilities\n\nStay tuned for updates!","ref":"nodejs.html#coming-soon"},{"type":"extras","title":"Contributing to Lux","doc":"# Contributing to Lux\n\nThank you for your interest in contributing to Lux! This guide will help you understand how to add new components and contribute to the project.","ref":"contributing.html"},{"type":"extras","title":"Project Structure - Contributing to Lux","doc":"Lux follows a modular architecture where components are organized by their type:\n\n```\nlib/lux/\n├── prisms/         # Prisms for specific functionality\n├── lenses/         # Lenses for external integrations\n├── beams/          # Beams for workflow orchestration\n├── signals/        # Signal definitions\n└── schemas/        # Schema definitions\n```","ref":"contributing.html#project-structure"},{"type":"extras","title":"Adding New Components - Contributing to Lux","doc":"","ref":"contributing.html#adding-new-components"},{"type":"extras","title":"Adding a Prism - Contributing to Lux","doc":"Prisms should be added under `lib/lux/prisms/` and follow these conventions:\n1. One prism per file\n2. File name should match the prism's purpose (e.g., `sentiment_analysis_prism.ex`)\n3. Module name should be in PascalCase and end with \"Prism\" (e.g., `Lux.Prisms.SentimentAnalysisPrism`)\n4. Include comprehensive documentation and examples\n5. Add corresponding tests under `test/lux/prisms/`\n\nExample structure:\n```elixir\n# lib/lux/prisms/my_feature_prism.ex\ndefmodule Lux.Prisms.MyFeaturePrism do\n  use Lux.Prism,\n    name: \"My Feature\",\n    description: \"Implements specific functionality\",\n    input_schema: %{...},\n    output_schema: %{...}\n\n  def handler(input, ctx) do\n    # Implementation\n  end\nend\n\n# test/lux/prisms/my_feature_prism_test.exs\ndefmodule Lux.Prisms.MyFeaturePrismTest do\n  use UnitCase, async: true\n  alias Lux.Prisms.MyFeaturePrism\n  \n  test \"processes input correctly\" do\n    # Test implementation\n  end\nend\n```","ref":"contributing.html#adding-a-prism"},{"type":"extras","title":"Adding a Lens - Contributing to Lux","doc":"Lenses should be added under `lib/lux/lenses/` following these guidelines:\n1. One lens per file\n2. File name should reflect the external service (e.g., `openai_lens.ex`)\n3. Module name should end with \"Lens\" (e.g., `Lux.Lenses.OpenAILens`)\n4. Include proper error handling and rate limiting\n5. Add tests under `test/lux/lenses/`\n\nExample structure:\n```elixir\n# lib/lux/lenses/my_service_lens.ex\ndefmodule Lux.Lenses.MyServiceLens do\n  use Lux.Lens,\n    name: \"My Service\",\n    description: \"Integrates with external service\",\n    schema: %{...}\n\n  def focus(input, opts) do\n    # Implementation\n  end\nend\n\n# test/lux/lenses/my_service_lens_test.exs\ndefmodule Lux.Lenses.MyServiceLensTest do\n  use UnitCase, async: true\n  alias Lux.Lenses.MyServiceLens\n  \n  test \"integrates with service correctly\" do\n    # Test implementation\n  end\nend\n```","ref":"contributing.html#adding-a-lens"},{"type":"extras","title":"Adding a Beam - Contributing to Lux","doc":"Beams should be added under `lib/lux/beams/` following these conventions:\n1. One beam per file\n2. File name should describe the workflow (e.g., `user_onboarding_beam.ex`)\n3. Module name should end with \"Beam\" (e.g., `Lux.Beams.UserOnboardingBeam`)\n4. Include clear step definitions and error handling\n5. Add tests under `test/lux/beams/`\n\nExample structure:\n```elixir\n# lib/lux/beams/my_workflow_beam.ex\ndefmodule Lux.Beams.MyWorkflowBeam do\n  use Lux.Beam,\n    name: \"My Workflow\",\n    description: \"Orchestrates a specific workflow\"\n\n  sequence do\n    step(:validate, MyValidatorPrism, %{...})\n    step(:process, MyProcessorPrism, %{...})\n    step(:notify, MyNotifierPrism, %{...})\n  end\nend\n\n# test/lux/beams/my_workflow_beam_test.exs\ndefmodule Lux.Beams.MyWorkflowBeamTest do\n  use UnitCase, async: true\n  alias Lux.Beams.MyWorkflowBeam\n  \n  test \"executes workflow correctly\" do\n    # Test implementation\n  end\nend\n```","ref":"contributing.html#adding-a-beam"},{"type":"extras","title":"Development Guidelines - Contributing to Lux","doc":"1. **Documentation**\n   - Add detailed module documentation\n   - Include usage examples\n   - Document all public functions\n   - Add type specs\n\n2. **Testing**\n   - Write comprehensive tests\n   - Include both unit and integration tests\n   - Test error cases\n   - Use ExUnit's async tests when possible\n   - Mock external services in tests\n\n3. **Code Style**\n   - Follow Elixir style guide\n   - Use mix format before committing\n   - Keep functions small and focused\n   - Use meaningful variable names\n   - Add type specs for public functions\n\n4. **Python Integration**\n   - Add Python dependencies to `priv/python/pyproject.toml`\n   - Write Python tests in `priv/python/tests/`\n   - Follow Python style guide (Black formatting)\n   - Add type hints to Python code\n   - Document Python functions","ref":"contributing.html#development-guidelines"},{"type":"extras","title":"Pull Request Process - Contributing to Lux","doc":"1. Fork the repository\n2. Create a feature branch\n3. Add your changes following the guidelines above\n4. Run all relevant tests (`mix test.unit`, `mix python.test`)\n5. Format code (`mix format`)\n6. Submit a pull request with:\n   - Clear description of changes\n   - Any related issues\n   - Examples of usage\n   - Test coverage report","ref":"contributing.html#pull-request-process"},{"type":"extras","title":"Getting Help - Contributing to Lux","doc":"- Open an issue for bugs or feature requests\n- Join our community chat for questions\n- Check existing documentation and guides\n- Review existing PRs and issues\n\nThank you for contributing to Lux! Your efforts help make the project better for everyone.","ref":"contributing.html#getting-help"},{"type":"extras","title":"Troubleshooting Guide","doc":"# Troubleshooting Guide\n\nThis guide helps resolve common issues encountered during Lux setup and development.","ref":"troubleshooting.html"},{"type":"extras","title":"Setup and Installation Issues - Troubleshooting Guide","doc":"","ref":"troubleshooting.html#setup-and-installation-issues"},{"type":"extras","title":"1. ASDF and Shell Integration - Troubleshooting Guide","doc":"#### \"Command not found: asdf\"\n1. **Verify Installation**:\n   ```bash\n   # On macOS\n   brew list asdf || brew install asdf\n   \n   # On Linux\n   ls ~/.asdf\n   ```\n\n2. **Check Shell Configuration**:\n   ```bash\n   # Identify your shell\n   echo $SHELL\n   \n   # Check if asdf is in your PATH\n   echo $PATH | grep asdf\n   ```\n\n3. **Fix Shell Integration**:\n   ```bash\n   # For Zsh\n   echo '. \"$HOME/.asdf/asdf.sh\"' >> ~/.zshrc\n   echo 'fpath=($HOME/.asdf/completions $fpath)' >> ~/.zshrc\n   \n   # For Bash\n   echo '. \"$HOME/.asdf/asdf.sh\"' >> ~/.bashrc\n   echo '. \"$HOME/.asdf/completions/asdf.bash\"' >> ~/.bashrc\n   ```","ref":"troubleshooting.html#1-asdf-and-shell-integration"},{"type":"extras","title":"2. Elixir/Mix Issues - Troubleshooting Guide","doc":"#### \"mix: command not found\"\n1. **Verify ASDF Integration**:\n   ```bash\n   # Check if mix is in asdf shims\n   ls ~/.asdf/shims/mix\n   \n   # Try running mix directly from shims\n   ~/.asdf/shims/mix --version\n   ```\n\n2. **Check Elixir Installation**:\n   ```bash\n   # List installed versions\n   asdf list elixir\n   asdf list erlang\n   \n   # If none installed, install them\n   asdf install\n   ```\n\n3. **Verify Global Versions**:\n   ```bash\n   asdf current\n   \n   # If needed, set global versions\n   asdf global erlang latest\n   asdf global elixir latest\n   ```","ref":"troubleshooting.html#2-elixir-mix-issues"},{"type":"extras","title":"3. OpenSSL Issues (macOS) - Troubleshooting Guide","doc":"#### Erlang Compilation Fails\n1. **Verify OpenSSL Installation**:\n   ```bash\n   brew list openssl@3\n   brew info openssl@3\n   ```\n\n2. **Check KERL Configuration**:\n   ```bash\n   echo $KERL_CONFIGURE_OPTIONS\n   \n   # Should output something like:\n   # --with-ssl=/usr/local/opt/openssl@3\n   ```\n\n3. **Fix OpenSSL Configuration**:\n   ```bash\n   # Add to your shell config\n   export KERL_CONFIGURE_OPTIONS=\"--with-ssl=$(brew --prefix openssl@3)\"\n   \n   # Then reinstall Erlang\n   asdf uninstall erlang\n   asdf install erlang\n   ```","ref":"troubleshooting.html#3-openssl-issues-macos"},{"type":"extras","title":"4. Permission Issues - Troubleshooting Guide","doc":"#### \"Permission denied\" Errors\n1. **Check Directory Ownership**:\n   ```bash\n   ls -la ~/.asdf\n   \n   # Fix ownership if needed\n   sudo chown -R $(whoami) ~/.asdf\n   ```\n\n2. **Check File Permissions**:\n   ```bash\n   # Ensure proper permissions\n   chmod -R 755 ~/.asdf\n   ```","ref":"troubleshooting.html#4-permission-issues"},{"type":"extras","title":"5. Complete Reset - Troubleshooting Guide","doc":"If you need to start fresh:\n\n1. **Remove ASDF and Tools**:\n   ```bash\n   # Remove ASDF\n   rm -rf ~/.asdf\n   \n   # Clean shell config (remove asdf-related lines)\n   # For zsh:\n   sed -i '' '/asdf/d' ~/.zshrc\n   # For bash:\n   sed -i '' '/asdf/d' ~/.bashrc\n   ```\n\n2. **Reinstall Everything**:\n   ```bash\n   # On macOS\n   brew install asdf\n   \n   # On Linux\n   git clone https://github.com/asdf-vm/asdf.git ~/.asdf --branch v0.13.1\n   \n   # Then run setup\n   cd /path/to/lux\n   make setup\n   ```","ref":"troubleshooting.html#5-complete-reset"},{"type":"extras","title":"Development Issues - Troubleshooting Guide","doc":"","ref":"troubleshooting.html#development-issues"},{"type":"extras","title":"1. Test Failures - Troubleshooting Guide","doc":"#### Mix Test Failures\n1. **Check Dependencies**:\n   ```bash\n   mix deps.get\n   mix deps.compile\n   ```\n\n2. **Clean Build**:\n   ```bash\n   mix clean\n   mix compile --force\n   ```","ref":"troubleshooting.html#1-test-failures"},{"type":"extras","title":"2. Python Integration Issues - Troubleshooting Guide","doc":"#### Poetry/Python Problems\n1. **Verify Poetry Installation**:\n   ```bash\n   asdf which poetry\n   poetry --version\n   ```\n\n2. **Reset Python Environment**:\n   ```bash\n   cd priv/python\n   rm -rf .venv\n   poetry env remove --all\n   poetry install\n   ```","ref":"troubleshooting.html#2-python-integration-issues"},{"type":"extras","title":"Getting Help - Troubleshooting Guide","doc":"If you're still experiencing issues:\n\n1. **Check Existing Issues**: Visit our [GitHub Issues](https://github.com/spectrallabs/lux/issues) to see if others have encountered the same problem.\n\n2. **Join Our Community**:\n   - [Discord Server](https://discord.gg/luxframework)\n   - [GitHub Discussions](https://github.com/spectrallabs/lux/discussions)\n\n3. **Debug Information**: When reporting issues, please include:\n   - Your OS and version\n   - Output of `asdf current`\n   - Content of your shell configuration file\n   - Any error messages\n   - Steps to reproduce the issue","ref":"troubleshooting.html#getting-help"},{"type":"extras","title":"Contributing - Troubleshooting Guide","doc":"Found a solution to a common problem? Please consider:\n1. Opening a PR to update this guide\n2. Sharing your solution in our Discord\n3. Adding it to our FAQ in the wiki\n\nRemember to keep the solutions clear, concise, and focused on root causes rather than symptoms.","ref":"troubleshooting.html#contributing"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}